/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore","jquery","ojs/ojcontext","ojs/ojmessaging","ojs/ojknockout","knockout"],function(e,t,a,i,n,r){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a,i=i&&Object.prototype.hasOwnProperty.call(i,"default")?i.default:i;
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var o=function(){this.Init()};e._registerLegacyNamespaceProp("InvalidComponentTracker",o),e.Object.createSubclass(o,e.Object,"oj.InvalidComponentTracker"),o._OPTION_MESSAGES_SHOWN="messagesShown",o._OPTION_MESSAGES_HIDDEN="messagesHidden",o._OPTION_DISABLED="disabled",o._OPTION_READONLY="readOnly",o.prototype.Init=function(){o.superclass.Init.call(this),this._tracked=[],this._invalid=[],this._invalidHidden=[],this.invalidShown=!1,this.invalidHidden=!1},o.prototype.focusOnFirstInvalid=function(){var e=null,t=this,i=this._updateCounter,n=a.getPageContext().getBusyContext().addBusyState({description:"Setting Focus to first invalid component."});return this.invalidShown&&(e=this._getFirstInvalidComponent()),setTimeout(function(){(e=i===t._updateCounter&&e||t._getFirstInvalidComponent())&&e("instance").GetFocusElement().focus(),n()},1),!!e},o.prototype.showMessages=function(){var e;if(this.invalidHidden)for(var t=this._invalidHidden.length,a=0;a<t;a++)this._invalidHidden[a]&&(e=this._tracked[a].component.call(e,"showMessages"))},o.prototype._getFirstInvalidComponent=function(){var e=0,t=[],a=this._invalid.length;for(e=0;e<a;e++)this._invalid[e]&&t.push(this._tracked[e]);return 0===t.length?null:(t.sort(function(e,t){var a=e.element,i=t.element;return a.compareDocumentPosition(i)&Node.DOCUMENT_POSITION_FOLLOWING?-1:1}),t[0].component)},o.prototype._remove=function(e){var a=-1,i=!1;return t.each(this._tracked,function(t,i){a<0&&i.component===e&&(a=t)}),a>=0&&(this._tracked.splice(a,1),this._invalid.splice(a,1),this._invalidHidden.splice(a,1),this._updateInvalidProperties(),i=!0),i},o.prototype._update=function(e,a,i,n){var r,_=e.call(e,"isValid"),s=!0,d=-1;switch(t.each(this._tracked,function(t,a){d<0&&a.component===e&&(d=t)}),i){case o._OPTION_MESSAGES_SHOWN:case o._OPTION_MESSAGES_HIDDEN:if(r=!1,n){if(d<0&&(d=this._tracked.push({component:e,element:a})-1,this._initializeInvalidTrackers(d,r)),!_&&o._hasInvalidMessages(n)&&(r=!0,i===o._OPTION_MESSAGES_SHOWN)){var l=e.call(e,"option",o._OPTION_DISABLED),O=e.call(e,"option",o._OPTION_READONLY);r=!(l||O)}s=this._updateInvalidTracker(i,d||0,r),this._updateInvalidProperties(),s&&(void 0===this._updateCounter&&(this._updateCounter=0),this._updateCounter+=1)}break;case o._OPTION_DISABLED:case o._OPTION_READONLY:s=!1,n&&(s=this._updateInvalidTracker(o._OPTION_MESSAGES_SHOWN,d||0,!1),s=this._updateInvalidTracker(o._OPTION_MESSAGES_HIDDEN,d||0,!1)||s,this._updateInvalidProperties())}return s},o.prototype._initializeInvalidTrackers=function(e,t){void 0===this._invalid[e]&&this._updateInvalidTracker(o._OPTION_MESSAGES_SHOWN,e,t),void 0===this._invalidHidden[e]&&this._updateInvalidTracker(o._OPTION_MESSAGES_HIDDEN,e,t)},o.prototype._updateInvalidProperties=function(){this.invalidShown=this._invalid.indexOf(!0)>=0,this.invalidHidden=this._invalidHidden.indexOf(!0)>=0},o.prototype._updateInvalidTracker=function(e,t,a){var i,n=!1;return i=e===o._OPTION_MESSAGES_SHOWN?this._invalid:e===o._OPTION_MESSAGES_HIDDEN?this._invalidHidden:[],t>=0&&void 0!==i[t]?(n=i[t]!==a)&&(i[t]=a):(i.push(a),n=!0),n},o._hasInvalidMessages=function(e){return!i.isValid(e)};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var _=function(){};e._registerLegacyNamespaceProp("ValueBinding",_),_._ATTRIBUTE_INVALID_COMPONENT_TRACKER="invalidComponentTracker",_._EVENT_OPTIONCHANGE="ojoptionchange",_._OPTION_MESSAGES_SHOWN="messagesShown",_._OPTION_MESSAGES_HIDDEN="messagesHidden",_._OPTION_DISABLED="disabled",_._OPTION_READONLY="readOnly",_._update=function(e,t,a,i,n){var o={},s=n.call()[_._ATTRIBUTE_INVALID_COMPONENT_TRACKER];if(e===_._OPTION_DISABLED||e===_._OPTION_READONLY){var d=s&&s.peek()||null;return null!==d&&r.isWriteableObservable(s)&&d._update.call(d,i,a,e,t)&&s.valueHasMutated(),o[e]=t,o}},_._init=function(e,t){var a={};return a[e]=t,a},_._afterCreate=function(e,t,a,i){var n=i.call();return e===_._ATTRIBUTE_INVALID_COMPONENT_TRACKER&&!!n[e]&&_._registerInvalidComponentTrackerWriteback(e,n,t,a),{}},_._beforeDestroy=function(e,a,i,n){var o,s=t(a),d=n.call()[e];e===_._ATTRIBUTE_INVALID_COMPONENT_TRACKER&&(s.off(_._EVENT_OPTIONCHANGE,_._updateInvalidComponentTracker),d&&r.isWriteableObservable(d)&&(o=d.peek())._remove.call(o,i)&&d.valueHasMutated())},_._updateInvalidComponentTracker=function(e){var t,a=e.data.tracker,i=e.data.component,n=e.data.element,o=arguments[1],s=o.option,d=o.value;s!==_._OPTION_MESSAGES_SHOWN&&s!==_._OPTION_MESSAGES_HIDDEN||a&&r.isWriteableObservable(a)&&(t=a.peek())&&t._update.call(t,i,n,s,d)&&a.valueHasMutated()},_._registerInvalidComponentTrackerWriteback=function(e,a,i,n){var s,d=a[e],l=t(i);if(!r.isObservable(d))throw new Error("Binding attribute "+_._ATTRIBUTE_INVALID_COMPONENT_TRACKER+" should be bound to a ko observable.");if(null==(s=d.peek())&&d(s=new o),r.isWriteableObservable(d)){var O=n.call(n,"option",_._OPTION_MESSAGES_SHOWN),c=n.call(n,"option",_._OPTION_MESSAGES_HIDDEN);s._update.call(s,n,i,_._OPTION_MESSAGES_SHOWN,O),s._update.call(s,n,i,_._OPTION_MESSAGES_HIDDEN,c),d.valueHasMutated()}var u={tracker:d,component:n,element:i};l.on(_._EVENT_OPTIONCHANGE,u,_._updateInvalidComponentTracker)},e.ComponentBinding.getDefaultInstance().setupManagedAttributes({for:"editableValue",attributes:[_._ATTRIBUTE_INVALID_COMPONENT_TRACKER,_._OPTION_DISABLED,_._OPTION_READONLY],init:_._init,update:_._update,afterCreate:_._afterCreate,beforeDestroy:_._beforeDestroy})});
//# sourceMappingURL=ojknockout-validation.js.map