/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","ojs/ojdomutils","ojs/ojvcomponent-element","ojs/ojtranslation","ojs/ojfilepickerutils"],function(e,t,i,r,l,n){"use strict";t=t&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t;var s=function(e,t,i,r){var l,n=arguments.length,s=n<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,i):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,i,r);else for(var o=e.length-1;o>=0;o--)(l=e[o])&&(s=(n<3?l(s):n>3?l(t,i,s):l(t,i))||s);return n>3&&s&&Object.defineProperty(t,i,s),s};e.FilePicker=class extends r.ElementVComponent{constructor(e){super(e),this.inDropZone=!1,this.isDroppable=!1,this.selecting=!1,this.state={focus:!1,validity:"NA"},this.rootElemRef=e=>{this.rootElem=e}}_doSelectHelper(e){var t=new Promise(e=>{this.elementPromiseResolver=e});return this._fileSelectedHelper(e),t}_handleSelectingFiles(e){var t;if("click"===e.type||"keypress"===e.type&&13===e.keyCode){this.selecting=!0,e.preventDefault();const i=this.props;return n.pickFiles(this._handleFileSelected,{accept:i.accept,selectionMode:i.selectionMode,capture:null!==(t=i.capture)&&void 0!==t?t:"none"}),!0}return!1}_handleFileSelected(e){this._fileSelectedHelper(e)}_fileSelectedHelper(e){if(e.length>0){var t=this._validateTypes(e).rejected;t.length>0?this._fireInvalidSelectAction(this._getMimeTypeValidationMessages(t),event,!1):this._handleFilesAdded(e,event)}this.selecting=!1}_handleDragEnter(e){e.preventDefault(),e.stopPropagation()}_handleDragOver(e){e.preventDefault(),e.stopPropagation();var i=e.dataTransfer;if(!this.inDropZone){var r=t.AgentUtils.getAgentInfo();if(this.inDropZone=!0,this.isDroppable=!0,r.browser!==t.AgentUtils.BROWSER.SAFARI&&r.browser!==t.AgentUtils.BROWSER.IE){var n=i.items,s=[],o=this._validateSelectionMode(n),a=this._validateTypes(n);o&&0===a.rejected.length?this.updateState({validity:"valid"}):(this.isDroppable=!1,o?s=this._getMimeTypeValidationMessages(a.rejected):s.push({severity:"error",summary:l.getTranslatedString("oj-ojFilePicker.singleFileUploadError")}),this._fireInvalidSelectAction(s,e,!0))}else this.updateState({validity:"valid"})}}_handleDragLeave(e,t){this.inDropZone&&(e.preventDefault(),e.stopPropagation(),this.rootElem.contains(e.relatedTarget)||(this.inDropZone=!1,this.updateState({validity:"NA"}),this.isDroppable||t||(this.dragPromiseResolver(),this.dragPromiseResolver=null)))}_handleFileDrop(e){if(this.inDropZone){e.preventDefault(),e.stopPropagation();var t=this._createFileList(e.dataTransfer.files),i=!1;if(this.isDroppable){var r=[];if(this._validateSelectionMode(t)){var n=this._validateTypes(t);n.rejected.length>0&&(r=this._getMimeTypeValidationMessages(n.rejected),i=!0)}else r.push({severity:"error",summary:l.getTranslatedString("oj-ojFilePicker.singleFileUploadError")});r.length>0&&(this.isDroppable=!1,this._fireInvalidSelectAction(r,e,!1)),this.isDroppable&&this._handleFilesAdded(t,e)}this._handleDragLeave(e,i)}}_handleFocusIn(){this.selecting||this.updateState({focus:!i.recentPointer()})}_handleFocusOut(){this.selecting||this.updateState({focus:!1})}render(){const e=this.props,t=this.props.trigger;if(e.disabled)return this._renderDisabled(e,t);const i="drop"!=e.selectOn?this._handleSelectingFiles:void 0;return t?this._renderWithCustomTrigger(e,t,i):this._renderWithDefaultTrigger(e,i)}_renderDisabled(e,t){const i=t?"oj-filepicker":"oj-filepicker oj-filepicker-no-trigger";return r.h("oj-file-picker",{class:i},r.h("div",{class:"oj-filepicker-disabled oj-filepicker-container"},t||this._renderDefaultTriggerContent(e)))}_renderWithCustomTrigger(e,t,i){const l=this._getDndHandlers(e);return r.h("oj-file-picker",{class:"oj-filepicker"+this._getFocusClass(),ref:this.rootElemRef,onFocusin:this._handleFocusIn,onFocusout:this._handleFocusOut},r.h("div",{onClick:i,onKeypress:this._handleSelectingFiles,onDragenter:l.handleDragEnter,onDragover:l.handleDragOver,onDragleave:l.handleDragLeave,onDragend:l.handleDragLeave,onDrop:l.handleFileDrop,class:"oj-filepicker-container"},t))}_renderWithDefaultTrigger(e,t){const i=this.state.validity,l="valid"===i?" oj-valid-drop":"invalid"===i?" oj-invalid-drop":"",n=this._getDndHandlers(e);return r.h("oj-file-picker",{class:"oj-filepicker oj-filepicker-no-trigger",ref:this.rootElemRef},r.h("div",{onClick:t,onKeypress:this._handleSelectingFiles,class:"oj-filepicker-container"},r.h("div",{tabindex:"0",class:"oj-filepicker-dropzone"+l+this._getFocusClass(),onDragenter:n.handleDragEnter,onDragover:n.handleDragOver,onDragleave:n.handleDragLeave,onDragend:n.handleDragLeave,onDrop:n.handleFileDrop,onFocusin:this._handleFocusIn,onFocusout:this._handleFocusOut},this._renderDefaultTriggerContent(e))))}_renderDefaultTriggerContent(e){const t="single"==e.selectionMode,i=e.primaryText;let n;if(i)if("string"==typeof i)n=i;else{n=i()}else n=l.getTranslatedString("oj-ojFilePicker.dropzonePrimaryText");const s=e.secondaryText;let o;if(s)if("string"==typeof s)o=s;else{o=s({selectionMode:e.selectionMode})}else o=l.getTranslatedString(t?"oj-ojFilePicker.secondaryDropzoneText":"oj-ojFilePicker.secondaryDropzoneTextMultiple");return[r.h("div",null,r.h("div",{class:"oj-filepicker-text"},n),r.h("div",{class:"oj-filepicker-secondary-text"},o)),r.h("div",{class:"oj-filepicker-icon oj-fwk-icon-plus oj-fwk-icon"})]}_getDndHandlers(e){return"click"!=e.selectOn?{handleDragEnter:this._handleDragEnter,handleDragOver:this._handleDragOver,handleDragLeave:this._handleDragLeave,handleFileDrop:this._handleFileDrop}:{}}_getFocusClass(){return this.state.focus?" oj-focus-highlight":""}_validateSelectionMode(e){return"single"!==this.props.selectionMode||1===e.length}_validateTypes(e){var t,i,r=[],n=[];if(e)for(var s=0;s<e.length;s++){var o=(t=e[s]).name;if(i=l.getTranslatedString("oj-ojFilePicker.unknownFileType"),o){var a=o.split(".");i=a.length>1?"."+a.pop():i}i=t.type?t.type:i,-1===r.indexOf(i)&&-1===n.indexOf(i)&&(this._acceptFile(t)?r.push(i):n.push(i))}return{accepted:r,rejected:n}}_getMimeTypeValidationMessages(e){var t=[];return 1===e.length?t.push({severity:"error",summary:l.getTranslatedString("oj-ojFilePicker.singleFileTypeUploadError",{fileType:e[0]})}):t.push({severity:"error",summary:l.getTranslatedString("oj-ojFilePicker.multipleFileTypeUploadError",{fileTypes:e.join(l.getTranslatedString("oj-converter.plural-separator"))})}),t}_acceptFile(e){var i,r=this.props.accept;if(!r||0===r.length||!e)return!0;for(var l=0;l<r.length;l++){if(!(i=t.StringUtils.trim(r[l])))return!0;if(i.startsWith(".",0)){if(!e.name||e.name&&e.name.endsWith(i))return!0}else{if(!e.type)return!1;if("image/*"===i){if(e.type.startsWith("image/",0))return!0}else if("video/*"===i){if(e.type.startsWith("video/",0))return!0}else if("audio/*"===i){if(e.type.startsWith("audio/",0))return!0}else if(e.type===i)return!0}}return!1}_handleFilesAdded(e,t){var i,r,l=this._createFileList(e);null===(r=(i=this.props).onOjBeforeSelect)||void 0===r||r.call(i,{files:l,originalEvent:t}).then(()=>{var e,i;null===(i=(e=this.props).onOjSelect)||void 0===i||i.call(e,{files:l,originalEvent:t}),this.elementPromiseResolver&&(this.elementPromiseResolver(),this.elementPromiseResolver=null)},e=>{this._fireInvalidSelectAction(e,t,!1)})}_fireInvalidSelectAction(e,t,i){var r,l;i&&this.updateState({validity:"invalid"});var n=i?new Promise(e=>{this.dragPromiseResolver=e}):null;null===(l=(r=this.props).onOjInvalidSelect)||void 0===l||l.call(r,{messages:e,originalEvent:t,until:n}),this.elementPromiseResolver&&(this.elementPromiseResolver(),this.elementPromiseResolver=null)}_createFileList(e){for(var t={length:{value:e.length},item:{value:function(e){return this[e]}}},i=0;i<e.length;i++)t[i]={value:e[i],enumerable:!0};return Object.create(FileList.prototype,t)}},e.FilePicker.metadata={extension:{_DEFAULTS:class{constructor(){this.accept=null,this.capture="none",this.disabled=!1,this.selectOn="auto",this.selectionMode="multiple"}}},properties:{accept:{type:"Array<string>|null",value:null},capture:{type:"string|null",enumValues:["user","environment","implementation","none"],value:"none"},disabled:{type:"boolean",value:!1},primaryText:{type:"string|function"},secondaryText:{type:"string|function"},selectOn:{type:"string",enumValues:["auto","click","clickAndDrop","drop"],value:"auto"},selectionMode:{type:"string",enumValues:["multiple","single"],value:"multiple"}},slots:{trigger:{}},events:{ojBeforeSelect:{cancelable:!0},ojInvalidSelect:{},ojSelect:{}},methods:{_doSelectHelper:{}}},s([r.listener()],e.FilePicker.prototype,"_handleSelectingFiles",null),s([r.listener()],e.FilePicker.prototype,"_handleFileSelected",null),s([r.listener()],e.FilePicker.prototype,"_handleDragEnter",null),s([r.listener()],e.FilePicker.prototype,"_handleDragOver",null),s([r.listener()],e.FilePicker.prototype,"_handleDragLeave",null),s([r.listener()],e.FilePicker.prototype,"_handleFileDrop",null),s([r.listener()],e.FilePicker.prototype,"_handleFocusIn",null),s([r.listener()],e.FilePicker.prototype,"_handleFocusOut",null),e.FilePicker=s([r.customElement("oj-file-picker")],e.FilePicker),Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojfilepicker.js.map