/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["ojs/ojcore","ojs/ojcomponentcore","ojs/ojlabel","ojs/ojcore-base","ojs/ojdomutils","ojs/ojcontext","ojs/ojlogger","ojs/ojthemeutils"],function(e,t,n,o,i,a,l,r){"use strict";o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o,a=a&&Object.prototype.hasOwnProperty.call(a,"default")?a.default:a;
/**
   * @license
   * Copyright (c) 2017 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var s={properties:{colspanWrap:{type:"string",enumValues:["nowrap","wrap"]},columns:{type:"number",value:0},direction:{type:"string",enumValues:["column","row"]},labelEdge:{type:"string",enumValues:["inside","start","top"]},labelWidth:{type:"string",value:"33%"},labelWrapping:{type:"string",enumValues:["truncate","wrap"],value:"wrap"},maxColumns:{type:"number",value:1},readonly:{type:"boolean",value:!1},userAssistanceDensity:{type:"string",enumValues:["compact","efficient","reflow"],value:"efficient"}},methods:{getProperty:{},refresh:{},setProperties:{},setProperty:{},getNodeBySubId:{},getSubIdByNode:{}},extension:{}};Object.freeze(s);var d=0;function u(e){var t,n,o,s,u,c=this,f=e.element,m="data-oj-formlayout-bonus-dom",p=!0,y=!1;function h(e){f.columns<1&&"row"===f.direction&&i.addResizeListener(e,c._resizeHandler,25)}function b(){n&&(n(),n=null)}function v(){t&&(t(),t=null)}function g(e){return"inside"===f.labelEdge||"inside"===e.labelEdge||"none"===e.labelEdge}function j(e){var t=null;return g(e)||e instanceof Element&&"labelHint"in e&&""!==e.labelHint&&(_(e),t=function(e){let t=e.labelledBy;if(t){document.getElementById(t)&&l.error("The oj-form-layout descendent component with id "+e.id+' has both label-hint and labelled-by. Remove labelled-by="'+t+'" since no matching element was found in the document, and a label will be created using the label-hint.')}var n=document.createElement("oj-label");n.setAttribute(m,""),n.setAttribute("data-oj-internal",""),n.setAttribute("data-oj-binding-provider","none"),n.setAttribute("data-oj-context","");var o=document.createElement("span");o.id=e.id+"|hint",o.textContent=e.labelHint,q(e)&&A(e,n);return n.appendChild(o),function(e,t){var n=e,o=t;n.id=o.id+"-labelled-by",n.setAttribute("for",o.id)}(n,e),n}(e),e.parentElement.insertBefore(t,e),function(e){e.addEventListener("labelHintChanged",x),e.addEventListener("helpHintsChanged",C),e.addEventListener("requiredChanged",w),e.addEventListener("userAssistanceDensityChanged",L)}(e)),t}function x(e){var t=e.target,n=document.getElementById(t.id+"|hint");n&&(n.textContent=e.detail.value)}function C(e){var t=e.target,n=O(t);let o=e.detail.value;if(n){E(t)&&(n.help=o)}}function w(e){var t=e.target,n=O(t);if(n){let o;o=!!e.detail.value&&E(t),n.showRequired=o}}function L(e){let t=e.target,n=e.detail.value,o=e.detail.previousValue;if("compact"!==n&&"compact"!==o)return;let i=O(t);if(q(t))A(t,i);else{t.required&&(i.showRequired=!1);const e=t.helpHints;e&&(e.definition||e.source)&&(i.help={definition:null,source:null})}}function E(e){let t="use"===r.parseJSONFromFontFamily("oj-form-control-option-defaults").useUserAssistanceOptionDefault?e.userAssistanceDensity:"displayOptions";return"compact"===t||"displayOptions"===t}function O(e){return"labelledBy"in e?document.getElementById(e.labelledBy):f.querySelector('oj-label[for="'+e.id+'"]')}function A(e,t){var n=t,o=e.helpHints;let i;o&&(o.definition||o.source)&&(n.help=o),i=!!e.required&&E(e),n.showRequired=i}function N(){return"column"===f.direction||1===u}function S(e,t){if(!N()){for(var n,o=t.previousSibling;o&&1!==o.nodeType;)n=o,o=o.previousSibling;for(;n&&n!==t;)o=n.nextSibling,e.appendChild(n),n=o}}function B(e){if(!N())for(;e.nextSibling;){var t=e.nextSibling;if(1===t.nodeType)break;if(8===t.nodeType&&0===t.textContent.trim().indexOf("oj-bind-"))break;e.appendChild(t)}}function W(e,t){e&&B(e);var n=k("oj-flex");return t.parentElement.insertBefore(n,t),S(n,n),n}function F(){let e=f.maxColumns;const t=f.columns;if(t>0)e=t,f.classList.add("oj-form-layout-no-min-column-width");else if(f.classList.remove("oj-form-layout-no-min-column-width"),"row"===f.direction&&!I()){let t=parseFloat(window.getComputedStyle(o).columnWidth);if(!isNaN(t)){let n=parseFloat(window.getComputedStyle(f.parentElement).width),o=Math.max(Math.floor(n/t),1);o<e&&(e=o)}}return e}function D(e,t){var n=1;if("column"===f.direction)return"100%";e&&"colspan"in e&&e.colspan&&(n=Math.min(Math.floor(e.colspan),t));let o=r.parseJSONFromFontFamily("oj-form-layout-option-defaults").columnGap,i="calc(((100% / "+u+") - (("+o+" * ("+(u-1)+") / "+u+"))"+(I()?" - 0.1px":"")+")";return n>1&&(i+=" * "+n+" + ("+o+" * "+(n-1)+")"),i+=")",i}function R(e,t){var n=k("oj-flex-item");return n.style.flexGrow="0",n.style.flexShrink="1",n.style.flexBasis=t,n.style.width=t,n.style.maxWidth=t,e.appendChild(n),n}function M(e,t){var n=t%u,o=D();if("column"!==f.direction&&e&&n>0)for(var i=n;i<u;i++)i!==n&&H(e),R(e,o)}function H(e){var t=k("oj-formlayout-column-gutter");e.appendChild(t)}function T(e,t,n,o){var i=D(e,o);S(n,e);var a=k("oj-flex-item");if(n.appendChild(a),a.appendChild(e),t)if(a.style.flexGrow="1",a.style.flexShrink="1",a.style.flexBasis=i,a.style.width=i,a.style.maxWidth=i,"OJ-FORM-LAYOUT"===t.tagName&&a.classList.add("oj-formlayout-nested-formlayout"),"start"===f.labelEdge){a.style.display="flex";let n=k("oj-formlayout-inline-label"),o=k("oj-formlayout-inline-value");n.style.flexGrow="0",n.style.flexShrink="0",n.style.flexBasis=f.labelWidth,n.style.width=f.labelWidth,n.style.maxWidth=f.labelWidth,n.appendChild(e),a.appendChild(n),o.style.flexGrow="1",o.style.flexShrink="1",o.style.flexBasis="calc(100% - "+f.labelWidth+")",o.style.width=o.style.flexBasis,o.style.maxWidth=o.style.flexBasis,o.appendChild(t),a.appendChild(o)}else a.appendChild(t);else if("labelHint"in e&&g(e))a.style.flexGrow="1",a.style.flexShrink="1",a.style.flexBasis=i,a.style.width=i,a.style.maxWidth=i,a.appendChild(e);else if(a.appendChild(e),a.style.flexGrow="1",a.style.flexShrink="1",a.style.flexBasis=i,a.style.width=i,a.style.maxWidth=i,a.classList.add("oj-formlayout-no-label-flex-item"),"OJ-LABEL-VALUE"===e.tagName){let t=r.parseJSONFromFontFamily("oj-form-layout-option-defaults").columnGap;a.classList.add("oj-formlayout-nested-labelvalue"),e.setAttribute("data-oj-colspan",o),e.setAttribute("data-oj-column-gap",t),e.refresh()}else"OJ-FORM-LAYOUT"===e.tagName&&a.classList.add("oj-formlayout-nested-formlayout");B(n)}function k(e){var t=document.createElement("div");return t.setAttribute(m,""),t.setAttribute("data-oj-internal",""),t.classList.add(e),t}function J(e){for(var t=e,n=!0;t!==f;){if("OJ-FORM-LAYOUT"===t.tagName){n=!1;break}if(null==(t=t.parentElement)){n=!1;break}}return n}function U(e){for(;e.firstChild;){var t=e.firstChild;e.parentNode.insertBefore(t,e)}e.parentNode.removeChild(e)}function _(e){var t=e;t.id||(t.id="oflId_"+d,d+=1)}function I(){var e=oj.AgentUtils.getAgentInfo();return"ie"===e.browser&&11===e.browserVersion}function q(e){let t=r.parseJSONFromFontFamily("oj-form-control-option-defaults"),n="displayOptions";if(t){n="use"===t.useUserAssistanceOptionDefault?e.userAssistanceDensity:"displayOptions"}return"compact"===n||"displayOptions"===n}function V(e){var t=r.parseJSONFromFontFamily("oj-form-layout-option-defaults")||{};e?(e.props.labelEdge||(f.labelEdge=t.labelEdge),e.props.colspanWrap||(f.colspanWrap=t.colspanWrap),e.props.direction||(f.direction=t.direction)):(f.labelEdge||(f.labelEdge=t.labelEdge),f.colspanWrap||(f.colspanWrap=t.colspanWrap),f.direction||(f.direction=t.direction))}V(e),c._rootElementMutationObserver=new MutationObserver(function(e){document.body.contains(f)?(!function(e){for(var t=e.length,n=0;n<t;n++){var i=e[n];if("childList"===i.type)for(var a=i.addedNodes.length,l=0;l<a;l++){var r=i.addedNodes[l];r.parentNode===f&&o.appendChild(r)}}}(e),function(e){for(var t=!0,n=e.length,o=["colspan","label-hint"],i=0;i<n;i++){var a=e[i];if("childList"===a.type&&((l=a.target)===f||l&&"DIV"===l.tagName&&l.hasAttribute(m))&&J(a.target)){t=!1;break}if("attributes"===a.type&&o.includes(a.attributeName)){t=!1;break}}var l;return t}(e)||(!function(e){for(var t=e.length,n=0;n<t;n++){var o=e[n];if("childList"===o.type)for(var i=o.removedNodes.length,a=0;a<i;a++){var l=o.removedNodes[a];1===l.nodeType&&(l.removeEventListener("labelHintChanged",x),l.removeEventListener("helpHintsChanged",C),l.removeEventListener("requiredChanged",w),l.removeEventListener("userAssistanceDensityChanged",L))}}}(e),f.refresh())):this.disconnect()}),c._resizeHandler=function(e,t){F()!==u&&f.refresh()},this.createDOM=function(){f.classList.add("oj-form-layout"),(o=document.createElement("div")).classList.add("oj-form"),o.setAttribute("data-oj-context",""),o.setAttribute("data-oj-internal",""),o.setAttribute(m,""),f.readonly?o.classList.remove("oj-enabled"):o.classList.add("oj-enabled");for("efficient"===f.userAssistanceDensity?o.classList.add("oj-efficient"):o.classList.remove("oj-efficient");f.firstChild;)o.appendChild(f.firstChild);f.appendChild(o)},c.handlePropertyChanged=function(e,t){switch(e){case"readonly":return f.readonly?o.classList.remove("oj-enabled"):o.classList.add("oj-enabled"),!0;case"userAssistanceDensity":{const e="oj-efficient";return"efficient"===f.userAssistanceDensity?o.classList.add(e):o.classList.remove(e),!0}case"labelWrapping":return"truncate"===f.labelWrapping?o.classList.add("oj-formlayout-labels-nowrap"):o.classList.remove("oj-formlayout-labels-nowrap"),!0;default:return!1}},this.updateDOM=function(){function e(){!function(){if(!n){var e=a.getContext(f).getBusyContext(),t={description:"The oj-form-layout component with id = '"+f.id+"' is being rendered."};n=e.addBusyState(t)}}(),V(),s=[],a.getContext(o).getBusyContext().whenReady().then(function(){var e,n=document.activeElement,r=!1;!function(){if(!t){var e=a.getContext(o).getBusyContext(),n={description:"The oj-form div for oj-form-layout component with id = '"+f.id+"' is being rendered."};t=e.addBusyState(n)}}(),c._rootElementMutationObserver.disconnect(),(e=o)&&c._resizeHandler&&i.removeResizeListener(e,c._resizeHandler),function(){var e;if("start"===f.labelEdge){var t=parseInt(f.labelWidth,10);(isNaN(t)||t>0)&&o.classList.add("oj-form-cols-labels-inline"),f.classList.add("oj-formlayout-labels-inline"),o.classList.remove("oj-form-cols")}else o.classList.add("oj-form-cols"),o.classList.remove("oj-form-cols-labels-inline"),f.classList.remove("oj-formlayout-labels-inline");"truncate"===f.labelWrapping?o.classList.add("oj-formlayout-labels-nowrap"):o.classList.remove("oj-formlayout-labels-nowrap");let n=u;if((u=F())!==n){var i="oj-formlayout-max-cols-"+u,a=f.className;-1!==a.indexOf("oj-formlayout-max-cols-")?f.className=a.replace(/oj-formlayout-max-cols-[\d+]/,i):f.classList.add(i)}"row"===f.direction?(e=1,o.classList.add("oj-formlayout-form-across")):(e=u,o.classList.remove("oj-formlayout-form-across"));o.style.columnCount=e,o.style.webkitColumnCount=e,o.style.MozColumnCount=e}(),p||function(){for(var e=o.querySelectorAll("[data-oj-formlayout-bonus-dom]"),t=e.length,n=0;n<t;++n){var i=e[n];J(i)&&("OJ-LABEL"===i.tagName?(i.for="",i.parentElement.removeChild(i)):U(i))}}(),function(){var e=o.firstElementChild,t=0,n="column"===f.direction;for(;e;){var i=e.tagName.toLowerCase();if(-1!==i.indexOf("-"))if("oj-label"===i){var a=e;if(!(e=e.nextElementSibling))throw _(f),_(a),v(),b(),new Error("oj-form-layout component with id='"+f.id+"' has an oj-label child element with id='"+a.id+"' but has no next sibling element that it is associated with.")}else"oj-label-value"===i?p||e.refresh():e.classList.contains("oj-complete")?j(e):((n||t%u==0)&&e.setAttribute("data-oj-needs-oj-flex-div",""),s.push(e));t+=1,e=e.nextElementSibling}}(),function(){var e,t=[],n=o.children.length,i="column"===f.direction,a=0,r=0;!function(e,t){for(var n=t,o=e.length-1;o>=0;o--)n[o]=e[o]}(o.children,t);var d,c=0,m=!1,p=!1;for(;a<n;){var y=t[a];if(d=1,(i||r%u==0)&&(e=W(e,y)),-1===s.indexOf(y))if("oj-label"===y.tagName.toLowerCase())T(y,t[a+=1],e);else if("labelHint"in y&&g(y))T(y,null,e);else{if("colspan"in y&&y.getAttribute("colspan"))if(i)m||(l.error('Colspan attribute is ignored unless direction is set to "row"'),m=!0);else{var h=u-c;d=Math.floor(y.colspan),"wrap"===f.colspanWrap&&h<d&&c>0?(M(e,r),r+=h,c=0,d=Math.min(d,u),e=W(e,y)):d=Math.min(d,h),!p&&u>1&&(p=!0)}T(y,null,e,d)}r+=d,i||r%u==0||H(e),c=r%u,a+=1}p&&!i?o.classList.add("oj-form-control-full-width"):o.classList.remove("oj-form-control-full-width");M(e,r)}(),n&&(r=i.isAncestorOrSelf(f,n)),!p&&r&&setTimeout(function(){n.focus()},0),h(o),c._rootElementMutationObserver.observe(f,{childList:!0,subtree:!0,attributes:!0}),p&&(p=!1),v(),b()})}var r;y||(!(p||!f.hasAttribute("data-oj-context"))&&!(r=a.getContext(f).getBusyContext()).isReady()?(y=!0,r.whenReady().then(function(){y=!1,e()})):e())}}u.getDynamicDefaults=function(){var e=r.parseJSONFromFontFamily("oj-form-layout-option-defaults")||{};return{labelEdge:e.labelEdge,direction:e.direction}},s.extension._CONSTRUCTOR=u,s.extension._TRACK_CHILDREN="nearestCustomElement",o.CustomElementBridge.register("oj-form-layout",{metadata:o.CollectionUtils.mergeDeep(s,{properties:{readonly:{binding:{provide:[{name:"containerReadonly"},{name:"readonly"}],consume:{name:"containerReadonly"}}},userAssistanceDensity:{binding:{provide:[{name:"containerUserAssistanceDensity",default:"efficient"},{name:"userAssistanceDensity",default:"efficient"}],consume:{name:"containerUserAssistanceDensity"}}},labelEdge:{binding:{provide:[{name:"containerLabelEdge"},{name:"labelEdge",transform:{top:"provided",start:"provided"}}],consume:{name:"containerLabelEdge"}}}}})})});
//# sourceMappingURL=ojformlayout.js.map