/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","ojs/ojdatacollection-common","ojs/ojanimation","ojs/ojthemeutils","ojs/ojvcomponent-element","ojs/ojcontext","ojs/ojlogger","ojs/ojvcollection","ojs/ojdomutils"],function(t,e,s,i,o,n,l,r,a,h){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,l=l&&Object.prototype.hasOwnProperty.call(l,"default")?l.default:l;class c{constructor(t,e,s,i,o){this.dataProvider=t,this.fullWidth=e,this.gutterWidth=s,this.itemWidth=i,this.cache=o,this.columns=0,this.margin=0,this.columnsInfo=[],this.bottom=0,this.keys=[],t&&(this.modelEventHandler=this._handleModelEvent.bind(this),t.addEventListener("mutate",this.modelEventHandler)),null==this.cache&&(this.cache=new Map)}destroy(){this.dataProvider&&this.modelEventHandler&&this.dataProvider.removeEventListener("mutate",this.modelEventHandler)}_initializeColumnsInfo(){this.columns=Math.max(1,Math.floor(this.fullWidth/(this.itemWidth+this.gutterWidth))),this.margin=Math.max(this.gutterWidth,(this.fullWidth-this.columns*(this.itemWidth+this.gutterWidth))/2),this.columnsInfo.length=this.columns;for(let t=0;t<this.columns;t++)this.columnsInfo[t]=0}_populatePositions(t,e,s,i,o,n){for(let l=0;l<t.length;l++){let r=s(t[l]);if(null==r)continue;const a=l+e,h=a%this.columnsInfo.length;let c=void 0;const u=this.cache.get(r);if(u&&!isNaN(u.height)){if(c=u.height,!1!==u.valid&&!isNaN(u.top)&&!isNaN(u.left)){i(a,r,h,u);continue}}else c=o(t[l]);if(isNaN(c))return;let d,m=this.margin;if(a<this.columnsInfo.length)m+=h*(this.itemWidth+this.gutterWidth),d={top:this.gutterWidth,left:m,height:c,valid:!0},this.columnsInfo[h]=c+2*this.gutterWidth,this.bottom=Math.max(this.bottom,c);else{const t=this.columnsInfo.reduce((t,e)=>Math.min(t,e)),e=this.columnsInfo.indexOf(t);m+=e*(this.itemWidth+this.gutterWidth),d={top:t,left:m,height:c,valid:!0},this.columnsInfo[e]=this.columnsInfo[e]+c+this.gutterWidth,this.bottom=Math.max(this.bottom,t+c)}d&&(-1===this.keys.indexOf(r)&&this.keys.push(r),this.cache.set(r,d),n&&n(r,d))}}setWidth(t){this.fullWidth!==t&&(this.fullWidth=t,this.columnsInfo.length>0&&(this._initializeColumnsInfo(),this._invalidatePositions(0)))}getPositionForItems(t,e){let s=new Map;null==this.itemWidth&&t.length>0&&(this.itemWidth=t[0].element.offsetWidth),0===this.columnsInfo.length&&this._initializeColumnsInfo(),this._populatePositions(t,e,t=>t.key,(t,e,i,o)=>{s.set(e,o)},t=>t.element.offsetHeight,(t,e)=>{s.set(t,e)});let i=0,o=new Set,n=Array.from(s.values());for(let t=0;t<n.length;t++){let e=n[t].left;if(o.has(e)||o.add(e),i=Math.max(i,n[t].top),o.size===this.columnsInfo.length)break}o.clear();let l=Number.MAX_VALUE;for(let t=n.length-1;t>=0;t--){let e=n[t].left;if(o.has(e)||o.add(e),l=Math.min(l,n[t].top+n[t].height),o.size===this.columnsInfo.length)break}return{start:i,end:l,positions:s}}getItemWidth(){return this.itemWidth}getPositions(){return this.cache}getPosition(t){return this.cache.get(t)}getLastItemPosition(){return this.bottom}getColumnsInfo(){return this.columnsInfo.map((t,e)=>({top:t,left:this.margin+e*(this.itemWidth+this.gutterWidth)}))}_handleModelEvent(t){if("mutate"===t.type){const e=t.detail;if(e.add){const t=e.add.addBeforeKeys;if(null!=t){const s=Array.from(e.add.keys);this._insertKeys(t,s)}}if(e.remove){const t=Array.from(e.remove.keys);this._removeKeys(t)}if(e.update){const t=Array.from(e.update.keys);this._updateKeys(t)}}}_insertKeys(t,e){let s=Number.MAX_VALUE;t.forEach((t,i)=>{const o=this.keys.indexOf(t),n=e[i];o>-1&&(s=Math.min(s,o),this.keys.splice(o,0,n),this.cache.set(n,{top:void 0,left:void 0,height:void 0,valid:!1}))}),this._invalidatePositions(s)}_removeKeys(t){let e=Number.MAX_VALUE;t.forEach(t=>{this.cache.delete(t);const s=this.keys.indexOf(t);s>-1&&(e=Math.min(e,s),this.keys.splice(s,1))}),this._invalidatePositions(e)}_updateKeys(t){let e=Number.MAX_VALUE;t.forEach(t=>{const s=this.keys.indexOf(t);if(s>-1){e=Math.min(e,s+1);let i=this.getPosition(t);i&&(i.top=void 0,i.left=void 0,i.height=void 0,i.valid=!1)}}),this._invalidatePositions(e)}_invalidatePositions(t){for(let e=t;e<this.keys.length;e++){let t=this.cache.get(this.keys[e]);null!=t&&(t.valid=!1)}for(let t=0;t<this.columns;t++)this.columnsInfo[t]=0;this.recalculatePositions()}recalculatePositions(){this._populatePositions(this.keys,0,t=>t,(t,e,s,i)=>{const o=i.height;if(t<this.columnsInfo.length)this.columnsInfo[s]=o+2*this.gutterWidth,this.bottom=Math.max(this.bottom,o);else{const t=this.columnsInfo.reduce(function(t,e){return Math.min(t,e)}),e=this.columnsInfo.indexOf(t);this.columnsInfo[e]=this.columnsInfo[e]+o+this.gutterWidth,this.bottom=Math.max(this.bottom,t+o)}},t=>{})}}class u extends a.IteratingDataProviderContentHandler{constructor(t,e,s,i,o){super(t,e,s,i),this.root=t,this.dataProvider=e,this.callback=s,this.scrollPolicyOptions=i,this.gutterWidth=o,this.postRender=()=>{const t=this.root.lastElementChild.firstElementChild;if(t&&null==this.adjustPositionsResolveFunc){this.adjustPositionsResolveFunc=this.addBusyState("adjusting item positions");l.getContext(t).getBusyContext().whenReady().then(()=>{if(this.adjustPositionsResolveFunc&&(this.adjustPositionsResolveFunc(),this.adjustPositionsResolveFunc=null),this.callback){const t=this._adjustAllItems();if(t.done){if(this.newItemsTracker.clear(),this.domScroller&&!this.domScroller.checkViewport())return;this.callback.renderComplete(t.items),this.initialFetch=!1}}})}},this.newItemsTracker=new Set,this.vnodesCache=new Map}destroy(){super.destroy(),this.layout&&this.layout.destroy()}getLayout(){return null==this.layout&&(this.layout=new c(this.dataProvider,this.root.clientWidth,this.gutterWidth,null,null)),this.layout}_adjustAllItems(){let t=!0;const e=Array.from(this.root.querySelectorAll(".oj-waterfalllayout-item")).map(e=>("false"===e.getAttribute("data-oj-positioned")&&(t=!1),{key:this.getKey(e),element:e}));if(t)return{done:!0,items:e};const s=this.callback.getData().startIndex,i=this.getLayout().getPositionForItems(e,isNaN(s)?0:s);return this.callback.setPositions(i.positions),this.callback.setContentHeight(this.getLayout().getLastItemPosition()),this.domScroller&&this.domScroller.setViewportRange(i.start,i.end),{done:!1,items:e}}handleResizeWidth(t){this.initialFetch=!1,this.getLayout().setWidth(t)}fetchSuccess(t){null!=t&&this.newItemsTracker.clear(),this.initialFetch=!1,super.fetchSuccess(t)}beforeFetchByOffset(t,e){return this.isRenderingViewportOnly()&&this.vnodesCache.clear(),super.beforeFetchByOffset(t,e)}addItem(t,e,s,i){let o=-1,n=-1;const l=this.getLayout().getPosition(t);null!=l?isNaN(l.left)||isNaN(l.top)||(o=l.left,n=l.top):this.newItemsTracker.add(t);const r=this.isInitialFetch();null==this.callback.getCurrentItem()&&r&&0==e&&this.callback.setCurrentItem(t);const a=this.renderItem(t,e,s);return this.decorateItem(a,t,o,n,r,i),a}renderItem(t,e,s){const i=this.vnodesCache.get(t);if(i){if(i.index===e)return i.vnodes;this.vnodesCache.clear()}const o=this.callback.getItemRenderer()({data:s,index:e,key:t});return this.vnodesCache.set(t,{index:e,vnodes:o}),o}decorateItem(t,e,s,i,o,n){let l,r;for(let e=0;e<t.length;e++){l=t[e];const s=l._node;if(1===s.nodeType){r=s;break}}if(null!=r){r.key=e,r.setAttribute("role","gridcell"),r.setAttribute("tabIndex","-1"),r.setAttribute("data-oj-positioned",-1!=s&&-1!=i?"true":"false");this.getItemStyleClass(n,s,i,this.newItemsTracker.has(e),o).forEach(t=>{r.classList.add(t)});const t=this.getItemInlineStyle(n,s,i,o);Object.keys(t).forEach(e=>{r.style[e]=t[e]})}}getItemInlineStyle(t,e,s,i){let o={};return-1===e||-1===s?(o.top=0,o.left=0):(o.left=e+"px",o.top=s+"px"),t&&-1!=e&&-1!=s&&!i&&(o.visibility="visible"),o}getItemStyleClass(t,e,s,i,o){let n=[];return t&&(n.push("oj-waterfalllayout-item"),-1!=e&&-1!=s&&!o&&i&&n.push("oj-waterfalllayout-new-item")),n}renderSkeletonsForLoadMore(){const t=this.getLayout(),e=t.getColumnsInfo(),s=t.getItemWidth();let i=[];const o=Math.max(...e.map(t=>t.top));if(o>0){const t=o+100;this.callback.setContentHeight(t);let n=e.map(e=>({left:e.left,top:e.top,height:t-e.top,width:s}));i=this.callback.renderSkeletons(n)}return i}handleCurrentRangeItemUpdated(t){let e=this.getLayout().getPosition(t);e&&(e.top=void 0,e.left=void 0),super.handleCurrentRangeItemUpdated(t)}handleItemsUpdated(t){t.keys.forEach(t=>{this.vnodesCache.delete(t)}),super.handleItemsUpdated(t)}handleItemsRemoved(t){t.keys.forEach(t=>{this.vnodesCache.delete(t)}),super.handleItemsRemoved(t)}handleModelRefresh(){this.vnodesCache.clear(),super.handleModelRefresh()}_log(t){r.info("[WaterfallLayoutContentHandler]=> "+t)}}var d,m=function(t,e,s,i){var o,n=arguments.length,l=n<3?e:null===i?i=Object.getOwnPropertyDescriptor(e,s):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)l=Reflect.decorate(t,e,s,i);else for(var r=t.length-1;r>=0;r--)(o=t[r])&&(l=(n<3?o(l):n>3?o(e,s,l):o(e,s))||l);return n>3&&l&&Object.defineProperty(e,s,l),l};t.WaterfallLayout=d=class extends n.ElementVComponent{constructor(t){super(t),this.restoreFocus=!1,this.actionableMode=!1,this.renderCompleted=!1,this.ticking=!1,this.setRootElement=t=>{this.root=t},this.state={renderedData:null,positions:null,skeletonPositions:null,width:0,height:0,contentHeight:0}}_handleFocusIn(t){this.currentItem&&this.focusInHandler(this.currentItem)}_handleFocusOut(t){this.currentItem&&this.focusOutHandler(this.currentItem)}_handleClick(t){this._handleTouchOrClickEvent(t)}_handleKeyDown(t){if(this.currentItem){let e;switch(t.key){case"ArrowLeft":case"Left":e=this.currentItem.previousElementSibling;break;case"ArrowRight":case"Right":e=this.currentItem.nextElementSibling;break;case"F2":!1===this.actionableMode&&this._enterActionableMode();break;case"Escape":case"Esc":!0===this.actionableMode&&this._exitActionableMode();break;case"Tab":!0===this.actionableMode&&this.currentItem&&(t.shiftKey?s.handleActionablePrevTab(t,this.currentItem):s.handleActionableTab(t,this.currentItem))}!1===this.actionableMode&&null!=e&&e.classList.contains(this.getItemStyleClass())&&this._updateCurrentItem(e)}}_touchStartHandler(t){this._handleTouchOrClickEvent(t)}render(){let t;if(null==this.contentHandler)t=this._renderInitialSkeletons(null);else{const e=this.getData(),s=this.state.skeletonPositions;e?null!=s&&this.contentHandler.isInitialFetch()?t=this._renderInitialSkeletons(s.positions):(t=this.contentHandler.render(),this.currentItem&&this.currentItem.contains(document.activeElement)&&(this.restoreFocus=!0)):null!=s&&(t=this._renderInitialSkeletons(s.positions))}return n.h("oj-waterfall-layout",{ref:this.setRootElement,style:this._getRootElementStyle()},n.h("div",{onClick:this._handleClick,onKeydown:this._handleKeyDown,onTouchstart:this._touchStartHandler,onFocusin:this._handleFocusIn,onFocusout:this._handleFocusOut,role:"grid","aria-label":this.props["aria-label"],"aria-labelledby":this.props["aria-labelledby"]},n.h("div",{role:"row",style:this._getContentDivStyle(),"data-oj-context":!0},t)))}_getScrollPolicyOptions(){return{fetchSize:this.props.scrollPolicyOptions.fetchSize,maxCount:this.props.scrollPolicyOptions.maxCount,scroller:this._getScroller()}}mounted(){const t=this.getRootElement();this.props.data&&(this.contentHandler=new u(t,this.props.data,this,this._getScrollPolicyOptions(),d.gutterWidth),this.contentHandler.fetchRows());const e=t.clientWidth,i=t.clientHeight;this.updateState({width:e,height:i});let o=t.querySelector(".oj-waterfalllayout-skeleton");if(o&&(this.skeletonWidth=o.clientWidth,this.contentHandler&&this._delayShowSkeletons()),window.ResizeObserver){const e=new window.ResizeObserver(e=>{e.forEach(e=>{if(e.target===t&&e.contentRect){const t=this.state.width,s=Math.round(e.contentRect.width);Math.abs(s-t)>d.minResizeWidthThreshold&&(this.updateState({width:s}),null!=this.getSkeletonPositions()?this._updatePositionsForSkeletons(s):null!=this.getPositions()&&this.contentHandler&&(this.contentHandler.getLayout().setWidth(s),this.renderCompleted&&this.contentHandler.handleResizeWidth(s)));const i=this.state.height,o=Math.round(e.contentRect.height);Math.abs(o-i)>1&&o!==this.state.contentHeight&&this.updateState({height:o})}})});e.observe(t),this.resizeObserver=e}h.makeFocusable({applyHighlight:!0,setupHandlers:(t,e)=>{let i=s.getNoJQFocusHandlers(t,e);this.focusInHandler=i.focusIn,this.focusOutHandler=i.focusOut}}),this._getScroller().addEventListener("scroll",this.scrollListener)}_handleNewData(){this.updateState({renderedData:null,positions:null}),this.contentHandler&&this.contentHandler.destroy(),this.currentKey=null,this.currentItem=null;const t=this.getRootElement();this.contentHandler=new u(t,this.props.data,this,this._getScrollPolicyOptions(),d.gutterWidth),this.contentHandler.fetchRows(),this._delayShowSkeletons()}updated(t,s){if(null!=this.getData()){if(null==s.renderedData){const t=this._findSkeletons();t.length>0?this._applySkeletonExitAnimation(t).then(()=>{this.updateState({skeletonPositions:null})}):(this.updateState({skeletonPositions:null}),this.contentHandler.postRender())}else if(this.props.data!=t.data){const t=this.addBusyState("apply exit animations on existing items");this._applyExitAnimation().then(()=>{t(),this._handleNewData()})}else null==s.positions&&null!=this.state.positions?(this._applyEntranceAnimation(),!this.renderCompleted&&this.contentHandler&&this.contentHandler.postRender()):null!=s.positions&&null!=this.state.positions&&s.positions.size<this.state.positions.size?(this._applyLoadMoreEntranceAnimation(),!this.renderCompleted&&this.contentHandler&&this.contentHandler.postRender()):this.contentHandler&&this.contentHandler.postRender();e.Object.compareValues(this.props.scrollPosition,t.scrollPosition)||e.Object.compareValues(this.props.scrollPosition,this.lastInternalScrollPositionUpdate)||this._syncScrollTopWithProps()}else this.props.data&&null==t.data&&this._handleNewData()}unmounted(){this.contentHandler&&this.contentHandler.destroy(),this.contentHandler=null,this.resizeObserver&&this.resizeObserver.disconnect(),this.resizeObserver=null,this.scrollListener&&null!=this._getScroller()&&this._getScroller().removeEventListener("scroll",this.scrollListener)}_delayShowSkeletons(){window.setTimeout(()=>{null==this.getData()&&this._updatePositionsForSkeletons(this.state.width)},this._getShowSkeletonsDelay())}_updatePositionsForSkeletons(t){const e=this._getPositionsForSkeletons(50,t,this.skeletonWidth);this.updateState({skeletonPositions:e})}_getOptionDefaults(){return null==this.defaultOptions&&(this.defaultOptions=o.parseJSONFromFontFamily("oj-waterfalllayout-option-defaults")),this.defaultOptions}_getShowSkeletonsDelay(){const t=this._getOptionDefaults(),e=parseInt(t.showIndicatorDelay,10);return isNaN(e)?0:e}addBusyState(t){const e=this.getRootElement();return l.getContext(e).getBusyContext().addBusyState({description:t})}_isReady(){const t=this.getRootElement();return l.getContext(t).getBusyContext().isReady()}_findSkeletons(){const t=this.getRootElement().querySelectorAll(".oj-waterfalllayout-skeleton");return t.length>1?t:[]}getRootElement(){return this.root}isAvailable(){return null!=this.contentHandler}getCurrentItem(){return this.currentKey}setCurrentItem(t){this.currentKey=t}getData(){return this.state.renderedData}setData(t){null!=t&&(this.renderCompleted=!1),this.updateState({renderedData:t});const e=this._findSkeletons();null!=t&&0!==e.length||this.updateState({skeletonPositions:null})}updateData(t){this.updateState(function(e){let s=e.renderedData;return t(s)}.bind(this))}getSkeletonPositions(){return this.state.skeletonPositions}setSkeletonPositions(t){this.updateState({skeletonPositions:t})}getPositions(){return this.state.positions}setPositions(t){this.updateState({positions:t})}setContentHeight(t){null!=this.props.scrollPolicyOptions.scroller&&this.updateState({contentHeight:t})}getItemRenderer(){return this.props.itemTemplate}getItemStyleClass(){return"oj-waterfalllayout-item"}getExpanded(){}_applySkeletonExitAnimation(t){const e=this.addBusyState("apply skeleton exit animations");return new Promise((s,o)=>{let n;t.forEach(t=>{n=i.fadeOut(t)}),n&&n.then(()=>{e(),s(!0)})})}_applyEntranceAnimation(){const t=this.getRootElement().querySelectorAll("."+this.getItemStyleClass());if(0===t.length)return Promise.resolve(!0);const e=[];return t.forEach((t,s)=>{let o=t;o.style.visibility="visible";const n=o.style.transition;o.style.transition="none";const l=Math.min(1e3,50*s)+"ms",r=i.slideIn(t,{offsetY:"300px",delay:l,duration:"300ms"});e.push(r),e.push(i.fadeIn(t,{delay:l,duration:"300ms"})),r.then(()=>{o.style.transition=n})}),Promise.all(e)}_applyExitAnimation(){const t=this.getRootElement().querySelectorAll("."+this.getItemStyleClass());if(0===t.length)return Promise.resolve(!0);const e=[];return t.forEach(t=>{e.push(i.slideOut(t,{offsetY:"300px",duration:"300ms",persist:"all"})),e.push(i.fadeOut(t,{duration:"300ms",persist:"all"}))}),Promise.all(e)}_applyLoadMoreEntranceAnimation(){const t=this.getRootElement().querySelectorAll(".oj-waterfalllayout-new-item");if(0===t.length)return Promise.resolve(!0);const e=[];return t.forEach(t=>{t.classList.remove("oj-waterfalllayout-new-item"),e.push(i.fadeIn(t,{duration:"150ms"}))}),Promise.all(e)}scrollListener(t){this.ticking||(window.requestAnimationFrame(()=>{this.isAvailable()&&this._updateScrollPosition(),this.ticking=!1}),this.ticking=!0)}_updateScrollPosition(){var t,e;const s=this._getScroller().scrollTop,i=this.contentHandler.getLayout().getPositions().entries();let o,n=i.next(),l=0;for(;!n.done;){let t=n.value;n=i.next();let e=t[1].top;if(e>s){void 0===o&&(o=t[0]);break}e>l&&(o=t[0],l=e)}const r={y:s,key:o,offsetY:Math.abs(s-l)};this.lastInternalScrollPositionUpdate=r,null===(e=(t=this.props).onScrollPositionChanged)||void 0===e||e.call(t,r)}_syncScrollTopWithProps(){let t,e=this.props.scrollPosition;const s=e.key;if(s){const i=this.contentHandler.getLayout().getPosition(s);if(null==i)return;t=i.top;const o=e.offsetY;isNaN(o)||(t+=o)}else{const s=e.y;if(isNaN(s))return;t=s}t>this._getScroller().scrollHeight||(this._getScroller().scrollTop=t)}_handleTouchOrClickEvent(t){let e=t.target.closest("."+this.getItemStyleClass());this._updateCurrentItem(e)}_resetFocus(t){this.focusOutHandler(t),t.tabIndex=-1}_setFocus(t,e){t.tabIndex=0,e&&(this.focusInHandler(t),t.focus())}_updateCurrentItem(t){if(this.currentItem){let t=this.currentItem;this._resetFocus(t)}this.currentItem=t;const e=t;this.currentKey=e.key,this._setFocus(e,!0),this._scrollToVisible(e)}_scrollToVisible(t){const e=t.offsetTop,s=t.offsetHeight,i=this._getScroller(),o=i.scrollTop,n=i.offsetHeight;if(e>=o&&e+s<=o+n)return;const l=Math.max(0,Math.min(e,Math.abs(e+s-n)));i.scrollTop=l}_getScroller(){let t=this.props.scrollPolicyOptions.scroller;return"string"==typeof t&&(t=document.querySelector(t)),null!=t?t:this.getRootElement()}_getContentDivStyle(){return{height:this.state.contentHeight+"px"}}_getRootElementStyle(){return null!=this.props.scrollPolicyOptions.scroller?{overflow:"hidden"}:null}_renderInitialSkeletons(t){const e=this._getScroller();if(null!=e&&(e.scrollTop=0),null==t)return this._renderSkeleton(null);{const e=t.size;let s=[];for(let i=0;i<e;i++){let e=t.get(i);s.push(this._renderSkeleton(e))}return n.h("div",{role:"row"},s)}}_getPositionsForSkeletons(t,e,s){let i=[],o=new Map;for(let e=0;e<t;e++){const t=150+e%3*100;o.set(e,{height:t}),i.push({key:e})}return new c(null,e,d.gutterWidth,s,o).getPositionForItems(i,0)}_isInViewport(t){let e=parseInt(t.style.top,10),s=this._getScroller().scrollTop;return e>=s&&e<=s+this.state.height}_restoreCurrentItem(t){if(null!=this.currentKey)for(let s=0;s<t.length;s++)if(e.KeyUtils.equals(t[s].key,this.currentKey)){const e=t[s].element;this.restoreFocus&&this._isInViewport(e)?this._updateCurrentItem(e):(this._setFocus(e,!1),this.currentItem=e);break}this.restoreFocus=!1}_disableAllTabbableElements(t){t.forEach(t=>{s.disableAllFocusableElements(t.element,!0)})}_enterActionableMode(){if(this.actionableMode=!0,this.currentItem){const t=s.enableAllFocusableElements(this.currentItem,!0);t&&t.length>0&&t[0].focus()}}_exitActionableMode(){this.actionableMode=!1,this.currentItem&&(s.disableAllFocusableElements(this.currentItem,!0),this._setFocus(this.currentItem,!0))}renderComplete(t){this.renderCompleted=!0,this.actionableMode=!1,this._disableAllTabbableElements(t),this._restoreCurrentItem(t)}renderSkeletons(t){let e=[];return t.forEach(t=>{e.push(this._renderSkeleton(t))}),e}_renderSkeleton(t){let e;return null==t?e={visibility:"hidden"}:(e={top:t.top+"px",left:t.left+"px",height:t.height+"px"},isNaN(t.width)||(e.width=t.width+"px")),n.h("div",{class:"oj-waterfalllayout-skeleton",style:e},n.h("div",{class:"oj-waterfalllayout-skeleton-content oj-animation-skeleton"}))}},t.WaterfallLayout.gutterWidth=20,t.WaterfallLayout.minResizeWidthThreshold=10,t.WaterfallLayout.metadata={extension:{_DEFAULTS:class{constructor(){this.data=null,this.scrollPolicy="loadMoreOnScroll",this.scrollPolicyOptions={fetchSize:25,maxCount:500,scroller:null},this.scrollPosition={y:0}}},_ROOT_PROPS_MAP:{"aria-label":1,"aria-labelledby":1},_WRITEBACK_PROPS:["scrollPosition"],_READ_ONLY_PROPS:[]},properties:{data:{type:"object|null",value:null},scrollPolicy:{type:"string",enumValues:["loadAll","loadMoreOnScroll"],value:"loadMoreOnScroll"},scrollPolicyOptions:{type:"object",properties:{fetchSize:{type:"number",value:25},maxCount:{type:"number",value:500},scroller:{type:"Element|string|null",value:null}}},scrollPosition:{type:"object",properties:{y:{type:"number",value:0},key:{type:"any"},offsetY:{type:"number"}},writeback:!0}},slots:{itemTemplate:{data:{}}}},m([n.listener()],t.WaterfallLayout.prototype,"_handleFocusIn",null),m([n.listener()],t.WaterfallLayout.prototype,"_handleFocusOut",null),m([n.listener()],t.WaterfallLayout.prototype,"_handleClick",null),m([n.listener()],t.WaterfallLayout.prototype,"_handleKeyDown",null),m([n.listener({passive:!0})],t.WaterfallLayout.prototype,"_touchStartHandler",null),m([n.listener()],t.WaterfallLayout.prototype,"scrollListener",null),t.WaterfallLayout=d=m([n.customElement("oj-waterfall-layout")],t.WaterfallLayout),Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojwaterfalllayout.js.map