/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore-base","ojs/ojtranslation","jquery","ojs/ojconverterutils","ojs/ojvalidation-error"],function(e,r,t,n,o,a){"use strict";r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r,n=n&&Object.prototype.hasOwnProperty.call(n,"default")?n.default:n,o=o&&Object.prototype.hasOwnProperty.call(o,"default")?o.default:o;
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var i={numeringSystems:{latn:"0123456789",arab:"٠١٢٣٤٥٦٧٨٩",thai:"๐๑๒๓๔๕๖๗๘๙"},regexTrim:/^\s+|\s+$|\u200f|\u200e/g,regexTrimNumber:/\s+|\u200f|\u200e/g,regexTrimRightZeros:/0+$/g,zeros:["0","00","000"],_ISO_DATE_REGEXP:/^[+-]?\d{4}(?:-\d{2}(?:-\d{2})?)?(?:T\d{2}:\d{2}(?::\d{2}(?:\.\d{1,3})?)?(Z|[+-]\d{2}(?::?\d{2})?)?)?$|^T\d{2}:\d{2}(?::\d{2}(?:\.\d{1,3})?)?(Z|[+-]\d{2}(?::?\d{2})?)?$/,getLocalTimeZoneOffset:function(){var e=(new Date).getTimezoneOffset();return i.getTimeStringFromOffset("Etc/GMT",e,!1,!1)},dateToLocalIso:function(e){var r=e;"number"==typeof r&&(r=new Date(r));var t=i.padZeros(r.getFullYear(),4)+"-"+i.padZeros(r.getMonth()+1,2)+"-"+i.padZeros(r.getDate(),2)+"T"+i.padZeros(r.getHours(),2)+":"+i.padZeros(r.getMinutes(),2)+":"+i.padZeros(r.getSeconds(),2);return r.getMilliseconds()>0&&(t+="."+i.trimRightZeros(i.padZeros(r.getMilliseconds(),3))),t},partsToIsoString:function(e){var r=i.padZeros(e[0],4)+"-"+i.padZeros(e[1],2)+"-"+i.padZeros(e[2],2)+"T"+i.padZeros(e[3],2)+":"+i.padZeros(e[4],2)+":"+i.padZeros(e[5],2);return e[6]>0&&(r+="."+i.trimRightZeros(i.padZeros(e[6],3))),r},isoToLocalDate:function(e){return e&&"string"==typeof e?this._isoToLocalDateIgnoreTimezone(e):null},_isoToLocalDateIgnoreTimezone:function(e){var r=i._IsoStrParts(e),t=new Date(r[0],r[1]-1,r[2],r[3],r[4],r[5],r[6]);return t.setFullYear(r[0]),t},_IsoStrParts:function(e){!1===i._ISO_DATE_REGEXP.test(e)&&i._throwInvalidISOStringSyntax(e);var r,t=e.split("T"),n=e.indexOf("T"),o=new Date,a=!1,s=[o.getFullYear(),o.getMonth()+1,o.getDate(),0,0,0,0];if(""!==t[0]){i.startsWith(t[0],"-")&&(t[0]=t[0].substr(1),a=!0);var u=t[0].split("-");for(r=0;r<u.length;r++){var l=parseInt(u[r],10);if(1===r&&(l<1||l>12)&&i._throwInvalidISOStringRange(e,"month",l,1,12),2===r){var g=i._getDaysInMonth(s[0],s[1]-1);(l<1||l>g)&&i._throwInvalidISOStringRange(e,"day",l,1,g)}s[r]=l}a&&(s[0]=-s[0])}if(-1!==n){var p=t[1].split("."),d=p[0].split(":");for(r=0;r<d.length;r++){var f=parseInt(d[r],10);0===r&&(f<0||f>24)&&i._throwInvalidISOStringRange(e,"hour",f,0,24),1===r&&(f<0||f>59)&&i._throwInvalidISOStringRange(e,"minute",f,0,59),2===r&&(f<0||f>59)&&i._throwInvalidISOStringRange(e,"second",f,0,59),s[3+r]=f}2===p.length&&p[1]&&(s[6]=parseInt(i.zeroPad(p[1],3,!1),10))}return s},getISOStrFormatInfo:function(e){var r={format:null,dateTime:null,timeZone:"",isoStrParts:null},t=i._ISO_DATE_REGEXP.exec(e);if(null===t&&i._throwInvalidISOStringSyntax(e),void 0===t[1]&&void 0===t[2])return r.format="local",r.dateTime=e,r.isoStrParts=i._IsoStrParts(r.dateTime),r;r.timeZone=void 0!==t[1]?t[1]:t[2],"Z"===r.timeZone?r.format="zulu":r.format="offset";var n=e.length,o=r.timeZone.length;return r.dateTime=e.substring(0,n-o),r.isoStrParts=i._IsoStrParts(r.dateTime),r},_isLeapYear:function(e){return e%400==0||e%100!=0&&e%4==0},_getDaysInMonth:function(e,r){switch(r){case 0:case 2:case 4:case 6:case 7:case 9:case 11:return 31;case 1:return i._isLeapYear(e)?29:28;default:return 30}},_throwInvalidISOStringRange:function(e,r,t,n,o){var a=new RangeError("The string "+e+" is not a valid ISO 8601 string: "+t+" is out of range.  Enter a value between "+n+" and "+o+" for "+r),i={errorCode:"isoStringOutOfRange",parameterMap:{isoString:e,value:t,minValue:n,maxValue:o,propertyName:r}};throw a.errorInfo=i,a},_throwInvalidISOStringSyntax:function(e){var r=new Error("The string "+e+" is not a valid ISO 8601 string syntax."),t={errorCode:"invalidISOString",parameterMap:{isoStr:e}};throw r.errorInfo=t,r},trim:function(e){return(e+"").replace(i.regexTrim,"")},trimRightZeros:function(e){return(e+"").replace(i.regexTrimRightZeros,"")},trimNumber:function(e){return(e+"").replace(i.regexTrimNumber,"")},startsWith:function(e,r){return 0===e.indexOf(r)},toUpper:function(e){return e.split(" ").join(" ").toUpperCase()},padZeros:function(e,r){var t=e+"",n=!1;return e<0&&(t=t.substr(1),n=!0),r>1&&t.length<r&&(t=(t=i.zeros[r-2]+t).substr(t.length-r,r)),n&&(t="-"+t),t},zeroPad:function(e,r,t){for(var n=""+e,o=n.length;o<r;o+=1)n=t?"0"+n:n+"0";return n},getTimeStringFromOffset:function(e,r,t,n){var o=t?r>=0:r<0,a=Math.abs(r),s=Math.floor(a/60),u=a%60,l=o?"-":"+";n&&(s=i.zeroPad(s,2,!0));var g=e+l+s;return(u>0||n)&&(g+=":"+i.zeroPad(u,2,!0)),g},getNumberingSystemKey:function(e,r){if(void 0===r)return"latn";var t=i.getNumberingExtension(r),n="symbols-numberSystem-"+t;return void 0===e.numbers[n]&&(t="latn"),t},getBCP47Lang:function(e){return e.split("-")[0]},getBCP47Region:function(e){var r=e.split("-");return 3===r.length?r[2]:2===r.length&&2===r[1].length?r[1]:"001"},getNumberingExtension:function(e){var r=e||"en-US",t=r.indexOf("-u-nu-"),n="latn";return-1!==t&&(n=r.substr(t+6,4)),n},haveSamePropertiesLength:function(e){return Object.keys(e).length},getLocaleElementsMainNode:function(e){var r=e.main;return r[Object.keys(r)[0]]},getLocaleElementsMainNodeKey:function(e){var r=e.main;return Object.keys(r)[0]},_toBoolean:function(e){if("string"==typeof e)switch(e.toLowerCase().trim()){case"true":case"1":return!0;case"false":case"0":return!1;default:return e}return e},getGetOption:function(e,r){if(void 0===e)throw new Error("Internal "+r+" error. Default options missing.");return function(t,n,o,a){if(void 0!==e[t]){var s=e[t];switch(n){case"boolean":s=i._toBoolean(s);break;case"string":s=String(s);break;case"number":s=Number(s);break;default:throw new Error("Internal error. Wrong value type.")}if(void 0!==o&&-1===o.indexOf(s)){for(var u=[],l=0;l<o.length;l++)u.push(o[l]);var g="The value '"+e[t]+"' is out of range for '"+r+"' options property '"+t+"'. Valid values: "+u,p=new RangeError(g),d={errorCode:"optionOutOfRange",parameterMap:{propertyName:t,propertyValue:e[t],propertyValueValid:u,caller:r}};throw p.errorInfo=d,p}return s}return a}},matchString:function(e,r,t,n){void 0===n&&(n={sensitivity:"base",usage:"sort"});var o=i.getGetOption(n,"OraI18nUtils.matchString");n.usage=o("usage","string",["sort","search"],"sort"),n.sensitivity=o("sensitivity","string",["base","accent","case","variant"],"base");for(var a=e.length,s=r.length-1,u=0;u<a;u++)for(var l=0;l<3;l++){var g=a-u;if(g=Math.min(g,s+l),0===e.substr(u,g).localeCompare(r,t,n))return[u,u+(g-1)]}return null}},s={fullYear:{pos:0,pad:4},month:{pos:1,pad:2},date:{pos:2,pad:2},hours:{pos:3,pad:2},minutes:{pos:4,pad:2},seconds:{pos:5,pad:2},milliseconds:{pos:6,pad:3},timeZone:{pos:7}};i.isoToDate=function(e){return new Date(this._normalizeIsoString(e))},i._copyTimeOver=function(e,r){if(!e||!r)throw new Error("Provided invalid arguments");var t=this._normalizeIsoString(r),n=e.indexOf("T"),o=t.indexOf("T");return t.substring(0,o)+(-1!==n?e.substring(n):"T00:00:00.000")},i._clearTime=function(e){return this._dateTime(e,{hours:0,minutes:0,seconds:0,milliseconds:0})},i._dateTime=function(e,r,t){if(!e||!r)throw new Error("Invalid argument invocation");var o,a,i=null,u=s,l=this.padZeros,g=this._normalizeIsoString(e),p=/(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):?(\d{2})?\.?(\d{3})?(.*)?/.exec(g);if(!p)throw new Error("Unable to capture anything");if(p=p.slice(1),Array.isArray(r)){i={};for(var d=0,f=r.length;d<f;d++){var c=r[d];if(c in u){if(a=p[o=u[c].pos],t&&"timeZone"===c)throw new Error("Dude you tried to ask timezone to be parsed");if(t){var m=parseInt(a,10);i[c]=1===o?m-1:m}else i[c]=a}}}else if(n.isPlainObject(r)){for(var v=Object.keys(r),h=0;h<v.length;h++){var T=v[h],y=u[T];o=y.pos,a=r[T],1===o&&"number"==typeof a&&(a+=1),p[o]=y.pad?l(a,y.pad):a}i=p[0]+"-"+p[1]+"-"+p[2]+"T"+p[3]+":"+p[4]+":"+p[5]+(p.length>6&&p[6]?"."+p[6]+(8===p.length&&p[7]?p[7]:""):"")}return i},i._normalizeIsoString=function(e){if(!e)throw new Error("Provided invalid arguments");var r,t=(new Date).toISOString(),n=t.substring(0,t.indexOf("T")),o=e.indexOf("T"),a=-1===o?e:e.substring(0,o);return(a=a||n)+(-1!==o?(r=e.substring(o)).split(":").length>1?r:r+":00":"T00:00:00.000")},i.formatString=function(e,r){for(var t=r.length,n=e,o=0;o<t;o++){var a="{"+o+"}";n=n.replace(a,r[o])}return n},i.getInitials=function(e,r){var t,n=0,o=0;if(void 0!==e&&e.length>0&&(n=e.charCodeAt(0)),n>=1536&&n<=1791)return"";if(n>=2304&&n<=2431)return e.charAt(0);if(n>=3584&&n<=3711)return e.charAt(0);if(n>=4352&&n<=4607||n>=12592&&n<=12687||n>=43360&&n<=43391||n>=44032&&n<=55295)return e;if(void 0!==r&&r.length>0&&(n=r.charCodeAt(0)),n>=11904&&n<=12255||n>=12288&&n<=12591||n>=12688&&n<=12799||n>=13056&&n<=19903||n>=19968&&n<=40959||n>=63744&&n<=64255)return r;if(n>=55296&&n<=56319){if(r.length<2)return"";if((o=r.charCodeAt(1))<56320||o>57343)return"";if((t=1024*(n-55296)+(o-56320)+65536)>=110592&&t<=110847||t>=127488&&t<=127743||t>=131072&&t<=173791||t>=173824&&t<=177983||t>=177984&&t<=178207||t>=178208&&t<=183983||t>=194560&&t<=195103)return r}return n="",o="",void 0!==e&&e.length>0&&(n=e.charAt(0).toUpperCase()),void 0!==r&&r.length>0&&(o=r.charAt(0).toUpperCase()),n+o};
/**
   * @license
   * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var u={isoToDate:function(e){return i.isoToDate(e)},isoToLocalDate:function(e){return i.isoToLocalDate(e)},dateToLocalIso:function(e){return i.dateToLocalIso(e)},getLocalTimeZoneOffset:function(){return i.getLocalTimeZoneOffset()},getConverterInstance:function(e){return o.getConverterInstance(e)},_minMaxIsoString:function(e,r){if(e){var t=(r=r||this.dateToLocalIso(new Date)).indexOf("T");0===e.indexOf("T")&&t>0&&(e=r.substring(0,t)+e)}return e},__getConverterOptionError:function(e,n){r.Assert.assertObject(n);var o,i="",s="",l=n.propertyName;if("optionTypesMismatch"===e){var g=n.requiredPropertyName;o=n.requiredPropertyValueValid,i=t.getTranslatedString("oj-converter.optionTypesMismatch.summary",{propertyName:l,propertyValue:n.propertyValue,requiredPropertyName:g}),s=u._getOptionValueDetailMessage(g,o)}else"optionTypeInvalid"===e?(l=n.propertyName,o=n.propertyValueValid,i=t.getTranslatedString("oj-converter.optionTypeInvalid.summary",{propertyName:l}),s=u._getOptionValueDetailMessage(l,o)):"optionOutOfRange"===e?(i=t.getTranslatedString("oj-converter.optionOutOfRange.summary",{propertyName:l,propertyValue:n.propertyValue}),o=n.propertyValueValid,s=u._getOptionValueDetailMessage(l,o)):"optionValueInvalid"===e&&(i=t.getTranslatedString("oj-converter.optionValueInvalid.summary",{propertyName:l,propertyValue:n.propertyValue}),o=n.propertyValueHint,s=u._getOptionValueDetailMessage(l,o));return new a.ConverterError(i,s)},_getOptionValueDetailMessage:function(e,r){var n;return r?("string"==typeof r?n="oj-converter.optionHint.detail":(n="oj-converter.optionHint.detail-plural",r=r.join(t.getTranslatedString("oj-converter.plural-separator"))),t.getTranslatedString(n,{propertyName:e,propertyValueValid:r})):""},_copyTimeOver:function(e,r){return i._copyTimeOver(e,r)},_clearTime:function(e){return i._clearTime(e)},_dateTime:function(e,r,t){return i._dateTime(e,r,t)},_normalizeIsoString:function(e){return i._normalizeIsoString(e)},getInitials:function(e,r){return i.getInitials(e,r)}};e.IntlConverterUtils=u,e.OraI18nUtils=i,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=ojconverterutils-i18n.js.map