/**
 * @license
 * Copyright (c) 2014, 2021, Oracle and/or its affiliates.
 * Licensed under The Universal Permissive License (UPL), Version 1.0
 * as shown at https://oss.oracle.com/licenses/upl/
 * @ignore
 */
define(["exports","ojs/ojcore","jquery","ojs/ojlogger","ojdnd","ojs/ojlistview"],function(t,e,r,i,s,a){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e,r=r&&Object.prototype.hasOwnProperty.call(r,"default")?r.default:r;
/**
   * @license
   * Copyright (c) 2015 2021, Oracle and/or its affiliates.
   * The Universal Permissive License (UPL), Version 1.0
   * as shown at https://oss.oracle.com/licenses/upl/
   * @ignore
   */
var n=function(t){this.listview=t};e._registerLegacyNamespaceProp("ListViewDndContext",n),e.Object.createSubclass(n,e.Object,"oj.ListViewDndContext"),n.C_KEY=67,n.V_KEY=86,n.X_KEY=88,n.CUT_COMMAND="cut",n.COPY_COMMAND="copy",n.PASTE_COMMAND="paste",n.PASTE_BEFORE_COMMAND="pasteBefore",n.PASTE_AFTER_COMMAND="pasteAfter",n.prototype.reset=function(){this._unsetSelectionDraggable(),this.m_itemsDragged=null,this.m_dragImage=null,this.m_currentDragItem=null,this.m_dragItems=null,this.m_contextMenuItem=null,this.m_cachedOffset=null,this.m_dropTarget=null,this.m_firstDropTarget=null},n.prototype._getDndOptions=function(t){var e=this.listview.GetOption("dnd");return null!=e&&e[t]?e[t].items:null},n.prototype._getDragOptions=function(){return this._getDndOptions("drag")},n.prototype._getDropOptions=function(){return this._getDndOptions("drop")},n.prototype.IsItemReOrdering=function(){return"enabled"===this._getDndOptions("reorder")},n.prototype.GetDragAffordanceClass=function(){return"oj-listview-drag-handle"},n.prototype.GetDragImageClass=function(){return"oj-listview-drag-image"},n.prototype.GetDragItemClass=function(){return"oj-listview-drag-item"},n.prototype.GetCutStyleClass=function(){return"oj-listview-cut"},n.prototype.GetCommandPrefix=function(){return"oj-listview-"},n.prototype._findItem=function(t){return r(t).get(0).classList.contains("oj-listview-first-drop-target")?r(this.m_dropTargetElem):this.listview.FindItem(t)},n.prototype._getSelectedItems=function(t){var e=[];if(this.listview._isSelectionEnabled())for(var i=this.listview.GetOption("selection"),s=0;s<i.length;s++){var a=this.listview.FindElementByKey(i[s]);null==a||this.listview.SkipFocus(r(a))||e.push(a)}else{var n=this._getActiveItem();null!=n&&e.push(n)}return!t&&null!=this.m_contextMenuItem&&this.m_contextMenuItem.length>0&&(this.listview.element.get(0).contains(this.m_contextMenuItem.get(0))?-1===e.indexOf(this.m_contextMenuItem.get(0))&&(e=[this.m_contextMenuItem.get(0)]):this.m_contextMenuItem=null),e},n.prototype._getActiveItem=function(){return null==this.listview.m_active?null:this.listview.m_active.elem[0]},n.prototype.itemRenderComplete=function(t,e){r(t).hasClass(this.listview.getItemStyleClass())||(t=t.firstElementChild);var i=r(t).find("."+this.GetDragAffordanceClass());if(null!=i&&i.length>0){var s=i.attr("aria-labelledby");null==s?i.attr("aria-labelledby",this.listview._createSubId("instr")):i.attr("aria-labelledby",s+" "+this.listview._createSubId("instr")),this.listview._isTouchSupport()&&i.attr("draggable","true")}},n.prototype._unsetSelectionDraggable=function(){this.m_draggableSelection&&r.each(this.m_draggableSelection,function(t,e){r(e).removeClass("oj-draggable"),this.listview._isTouchSupport()&&r(e).removeAttr("draggable")}.bind(this))},n.prototype.setSelectionDraggable=function(){var t=[];this._unsetSelectionDraggable();for(var e=this.listview.GetOption("selection"),i=0;i<e.length;i++){var s=this.listview.FindElementByKey(e[i]);null==s||this.listview.SkipFocus(r(s))||(t.push(s),r(s).addClass("oj-draggable"),this.listview._isTouchSupport()&&r(s).attr("draggable","true"))}this.m_draggableSelection=t},n.prototype._setItemDraggable=function(t){var e=this.GetDragAffordanceClass(),r=t.find("."+e);return null!=r&&r.length>0||(t.addClass("oj-draggable"),!1)},n.prototype._unsetItemDraggable=function(t){t.removeClass("oj-draggable")},n.prototype._setDraggable=function(t){if(null!=this._getDragOptions()||this.IsItemReOrdering()){var e,i=this.GetDragAffordanceClass();if(t.hasClass(i))e=r(t);else{var s=this._findItem(t);if(this.shouldDragCurrentItem())e=s;else{if(null!=s&&this._setItemDraggable(s))return;var a=this._getSelectedItems(!0);a.length>0&&(null!=s&&a.indexOf(s[0])>-1?e=s:r(a[0]).removeClass("oj-draggable"))}}null!=e&&e.attr("draggable",!0)}},n.prototype._unsetDraggable=function(t){if(null!=this._getDragOptions()||this.IsItemReOrdering()){var e,i=this.GetDragAffordanceClass();null!=(e=t.hasClass(i)?r(t):this._findItem(t))&&(e.removeAttr("draggable"),this._unsetItemDraggable(e))}},n.prototype.isDndInProgress=function(){return null!=this.m_dragImage},n.prototype._invokeDndCallback=function(t,e,r,s){var a,n="drag"===t?this._getDragOptions():this._getDropOptions();if(n){var o=n[e];if(o&&"function"==typeof o)try{this.listview.ojContext._IsCustomElement()?(o(r.originalEvent,s),r.originalEvent.defaultPrevented&&r.preventDefault()):(r.dataTransfer=r.originalEvent.dataTransfer,a=o(r,s))}catch(t){i.error("Error: "+t)}else a=-1}else a=-1;return a},n.prototype._setDragItemDataTransfer=function(t,e,r){for(var i=[],s=0;s<r.length;s++){var a=this.listview._getDataForItem(r[s]);a&&(a.innerHTML&&a.tagName&&"LI"===a.tagName?i.push(a.innerHTML):i.push(a))}return i.length>0?(this._setDragItemData(t.originalEvent,e,i),this.SetDragItemImage(t.originalEvent,r),{items:i}):null},n.prototype._setDragItemData=function(t,e,r){var i=t.dataTransfer,s=JSON.stringify(r);if("string"==typeof e)i.setData(e,s);else if(e)for(var a=0;a<e.length;a++)i.setData(e[a],s);i.setData(this.GetDragSourceType(),this.listview.element.get(0).id)},n.prototype._createDragImage=function(){var t=document.createElement("ul");if(t.className=this.listview.element.get(0).className,t.classList.add(this.GetDragImageClass()),this.listview.ojContext._IsCustomElement()){var e=["oj-component","oj-complete"].concat(this.listview.GetContainerStyleClass().split(" "));this.listview.GetRootElement().get(0).classList.forEach(function(r){-1===e.indexOf(r)&&t.classList.add(r)})}return t},n.prototype._calculateOffset=function(t){var e=window.getComputedStyle(t);return parseFloat(e.marginLeft)+parseFloat(e.marginRight)+parseFloat(e.paddingLeft)+parseFloat(e.paddingRight)+parseFloat(e.borderLeftWidth)+parseFloat(e.borderRightWidth)},n.prototype._calculateAffordanceOffset=function(t,e){if(null==this.m_cachedOffset){this.m_cachedOffset=Math.max(0,e.offsetLeft-t.offsetLeft)+e.offsetWidth/2;var r=this._calculateOffset(t),i=this._calculateOffset(this.listview.getListContainer().get(0));this.m_cachedOffset+=Math.max(i,r-i)}return this.m_cachedOffset},n.prototype.SetDragItemImage=function(t,e){var i,s,a,n=0,o=0,l=t.target,h=this.listview.isCardLayout();if(e.length>1){var d;(i=r(this._createDragImage())).css({width:this.listview.element.css("width"),height:this.listview.element.css("height")});var p=Number.MAX_VALUE;for(d=0;d<e.length;d++)p=Math.min(p,e[d].offsetTop);for(d=0;d<e.length;d++){s=e[d].offsetTop-p;var m=e[d].offsetWidth;(a=r(e[d].cloneNode(!0))).removeClass("oj-selected oj-focus oj-hover").css({position:"absolute",top:s,width:m}),h||a.addClass("oj-listview-item-drag-image"),i.append(a)}}else r(l).hasClass(this.GetDragAffordanceClass())?(s=0,r.contains(e[0],l.offsetParent)&&(s=l.offsetTop),n=this._calculateAffordanceOffset(e[0],l),o=s+l.offsetHeight/2):(n=Math.max(0,t.offsetX),o=Math.max(0,t.offsetY)),(a=r(e[0].cloneNode(!0))).removeClass("oj-selected oj-focus oj-hover").addClass("oj-drag"),h||a.addClass("oj-listview-item-drag-image"),(i=r(this._createDragImage())).css({width:this.GetDragImageWidth(e[0]),height:2*e[0].offsetHeight}).append(a);h&&i.addClass("oj-listview-card-layout"),r("body").append(i),this.m_dragImage=i,t.dataTransfer.setDragImage(i.get(0),n,o)},n.prototype.GetDragImageWidth=function(){return this.listview.element.css("width")},n.prototype.GetDefaultDataType=function(){return"text/ojlistview-items-data"},n.prototype._handleDragStart=function(t){var e,i,s=this._getDragOptions();if((null!=s||this.IsItemReOrdering())&&(e=null!=s?s.dataTypes:this.GetDefaultDataType(),r(t.target).hasClass(this.GetDragAffordanceClass())||this.shouldDragCurrentItem()?(i=[]).push(this._findItem(t.target)[0]):i=this._getSelectedItems(!0),i.length>0)){this.m_dragItems=i,this.m_currentDragItem=r(i[0]);var a=this._setDragItemDataTransfer(t,e,i);if(a){var n=this._invokeDndCallback("drag","dragStart",t,a);if(-1===n)return;return n}return!1}},n.prototype._handleDrag=function(t){return this._invokeDndCallback("drag","drag",t)},n.prototype._destroyDragImage=function(){null!=this.m_dragImage&&(this.m_dragImage.remove(),this.m_dragImage=null)},n.prototype._handleDragEnd=function(t){if(null!=this.m_currentDragItem&&null!=this.m_dragItems){this.m_currentDragItem.find("."+this.GetDragAffordanceClass()).removeAttr("draggable"),this.m_currentDragItem.removeClass("oj-drag oj-draggable").removeAttr("draggable");for(var e=0;e<this.m_dragItems.length;e++){var i=this.m_dragItems[e];i.classList.remove("oj-listview-drag-source"),i.classList.remove(this.GetDragItemClass()),r(i).css("display","")}}this._cleanupDropTarget(),this._destroyDragImage(),this._unsetSelectionDraggable(),this._invokeDndCallback("drag","dragEnd",t),this.m_itemsDragged=this.m_dragItems,this.m_dragImage=null,this.m_currentDragItem=null,this.m_dragItems=null,this.listview.restoreFocusAfterDrag()},n.prototype._matchDragDataType=function(t){var e=this._getDropOptions();if(e&&e.dataTypes)for(var r=e.dataTypes,i="string"==typeof r?[r]:r,s=t.originalEvent.dataTransfer.types,a=0;a<s.length;a++)if(i.indexOf(s[a])>=0)return!0;return!1},n.prototype._invokeDropCallback=function(t,e,r){var i=this._invokeDndCallback("drop",t,e,r);return void 0!==i&&-1!==i||this._matchDragDataType(e)&&e.preventDefault(),i},n.prototype._getDropIndicator=function(){return null!=this.m_dragItems?"space":"line"},n.prototype._createDropTarget=function(t){var e,i=this._getDropIndicator();null==this.m_dropTarget&&("space"===i?(e=r(t.get(0).cloneNode(!1))).addClass("oj-drop").removeClass("oj-drag oj-draggable oj-hover oj-focus").css({display:"block",height:t.outerHeight(),width:t.outerWidth()}):"line"===i&&(e=document.createElement("li")).classList.add("oj-listview-drop-target"),this.m_dropTarget=r(e));var s=t.get(0);if("line"===i){s.classList.add("oj-drop"),null!=this.m_dropTargetElem&&this.m_dropTargetElem.classList.remove("oj-drop"),this.m_dropTargetElem=s;var a=s.offsetTop+s.offsetHeight-this._getDropIndicatorHeight();null==s.nextElementSibling&&this.listview._isGridlinesVisible()&&(a-=1),this.m_dropTarget.get(0).style.top=a+"px"}else"space"===i&&(this.m_dropTarget.get(0).key=s.key);return this.m_dropTarget},n.prototype._getDropIndicatorHeight=function(){if(!isNaN(this.m_dropIndicatorHeight))return this.m_dropIndicatorHeight;if(this.m_dropTarget){var t=this.m_dropTarget.get(0);return this.listview.element.get(0).appendChild(t),this.m_dropIndicatorHeight=t.offsetHeight,this.listview._isGridlinesVisible()&&(this.m_dropIndicatorHeight-=1),this.m_dropIndicatorHeight}return 0},n.prototype._cleanupGroupItem=function(){null!=this.m_currentDropItem&&-1===this.m_dropTargetIndex&&this.m_currentDropItem.children("."+this.listview.getGroupItemStyleClass()).removeClass("oj-drop")},n.prototype._cleanupEmptyList=function(){null!=this.m_currentDropItem&&this.m_currentDropItem.hasClass(this.listview.getEmptyTextStyleClass())&&(this.m_currentDropItem.removeClass("oj-drop"),this.m_currentDropItem.get(0).textContent=this.listview._getEmptyText())},n.prototype._cleanupDropTarget=function(){null!=this.m_dropTarget&&(this.m_dropTarget.css("height","0"),this.m_dropTarget.remove(),this.m_dropTarget=null),null!=this.m_dropTargetElem&&this.m_dropTargetElem.classList.remove("oj-drop"),null!=this.m_firstDropTarget&&(this.m_firstDropTarget.parentNode&&this.m_firstDropTarget.parentNode.removeChild(this.m_firstDropTarget),this.m_firstDropTarget=null),this._cleanupEmptyList(),this._cleanupGroupItem()},n.prototype._handleDragEnter=function(t){var e=this._findItem(t.target);if(null!=e&&e.length>0){var r=this._invokeDropCallback("dragEnter",t,{item:e.get(0)});if(-1!==r)return r}},n.prototype._setCurrentDropItem=function(t){null!=this.m_currentDropItem&&this.m_currentDropItem.removeClass("oj-valid-drop oj-invalid-drop"),this.m_currentDropItem=t,this.m_currentDropItem.addClass("oj-valid-drop")},n.prototype._setAccInfo=function(t,e){var r=t.attr("aria-label");null==r&&(r=t.text());var i="accessibleReorder"+e.charAt(0).toUpperCase()+e.substr(1)+"Item",s=this.listview.ojContext.getTranslatedString(i,{item:r});this.listview._setAccInfoText(s)},n.prototype._adjustGroupItemStyle=function(){null==this.m_maxHeightAdjusted&&this.listview._isTouchSupport()&&(this.listview.element.find("ul."+this.listview.getGroupStyleClass()).each(function(){r(this).attr("oldMaxHeight",r(this).css("maxHeight").toString()),r(this).css("maxHeight",1e4)}),this.m_maxHeightAdjusted="adjusted")},n.prototype._restoreGroupItemStyle=function(){this.listview._isTouchSupport()&&this.listview.element.find("ul."+this.listview.getGroupStyleClass()).each(function(){r(this).css("maxHeight",parseInt(r(this).attr("oldMaxHeight"),10)),r(this).removeAttr("oldMaxHeight")}),this.m_maxHeightAdjusted=null},n.prototype._setDropPosition=function(t,e){if("line"===this._getDropIndicator())return e.insertAfter(t),"after";var r=t.index();return null==this.m_dropTargetIndex||this.m_dropTargetIndex<r?(e.insertAfter(t),"after"):(e.insertBefore(t),"before")},n.prototype._checkFirstItemDropTarget=function(t,e,r){if(r.classList.contains("oj-listview-first-drop-target"))return this.m_dropPosition="before",void(e.style.top="0px");if("line"===this._getDropIndicator())if(null===t.previousElementSibling)if(null==this.m_firstDropTarget){var i=document.createElement("li");i.classList.add("oj-listview-first-drop-target"),i.style.top="0px",t.parentNode.appendChild(i),this.m_firstDropTarget=i}else this.m_dropPosition="after",e.style.top=t.offsetTop+t.offsetHeight-this._getDropIndicatorHeight()+"px";else this.m_firstDropTarget&&(this.m_firstDropTarget.parentNode&&this.m_firstDropTarget.parentNode.removeChild(this.m_firstDropTarget),this.m_firstDropTarget=null)},n.prototype._isDropOnDragItem=function(t,e){return this._matchDragDataType(t)&&null!=this.m_dragItems&&this.m_dragItems.length>=0&&this.m_dragItems[0].key===e.get(0).key},n.prototype._handleDragOver=function(t){var e,i,s;if(this._adjustGroupItemStyle(),null!=this.m_dragItems&&"none"!==r(this.m_dragItems[0]).css("display"))if(e=r(this.m_dragItems[0]),-1===(s=this._invokeDropCallback("dragOver",t,{item:e.get(0)}))&&this.IsItemReOrdering()&&this.isDndInProgress()||!1===s||t.isDefaultPrevented()){i=this._createDropTarget(e);for(var a=0;a<this.m_dragItems.length;a++)r(this.m_dragItems[a]).addClass(this.GetDragItemClass()).css("display","none");i.insertBefore(e),this.m_dropTargetIndex=i.index()}else e.get(0).classList.remove("oj-hover"),e.get(0).classList.add("oj-listview-drag-source");else if(null!=(e=this._findItem(t.target))&&e.length>0){if(this._isDropOnDragItem(t,e)){if(s=this._invokeDndCallback("drop","dragOver",t,{item:e.get(0)}),!t.isDefaultPrevented())return-1}else s=this._invokeDropCallback("dragOver",t,{item:e.get(0)});-1===s&&this.IsItemReOrdering()&&this.isDndInProgress()||!1===s||t.isDefaultPrevented()?(e.hasClass(this.listview.getItemStyleClass())?(this._cleanupGroupItem(),e.hasClass("oj-drop")?i=this.m_dropTarget:(i=this._createDropTarget(e),this.m_dropPosition=this._setDropPosition(e,i),this._setAccInfo(e,this.m_dropPosition),this._setCurrentDropItem(e),this.m_dropTargetIndex=i.index()),this._checkFirstItemDropTarget(e.get(0),i.get(0),t.target)):(this._cleanupDropTarget(),e.children("."+this.listview.getGroupItemStyleClass()).addClass("oj-drop"),this._setCurrentDropItem(e),this.m_dropTargetIndex=-1,this.m_dropPosition="inside",this._setAccInfo(e,this.m_dropPosition)),t.preventDefault()):r(t.target).hasClass(this.listview.getGroupStyleClass())||(e.addClass("oj-invalid-drop"),this._cleanupDropTarget())}else{var n=this._getAndUpdateEmptyItem();null!=n&&n.length>0&&(this._setCurrentDropItem(n),t.preventDefault())}return s},n.prototype._getAndUpdateEmptyItem=function(){var t=this.listview.element.children("."+this.listview.getEmptyTextStyleClass());return 0===t.length?t=r(this.listview.element[0].querySelector(".oj-listview-no-data-item")):t.get(0).textContent="",t.addClass("oj-drop"),t},n.prototype._isDndEventInElement=function(t,e){var r=e.getBoundingClientRect(),i=t.originalEvent;return i.clientX>=r.left&&i.clientX<r.right&&i.clientY>=r.top&&i.clientY<r.bottom},n.prototype._handleDragLeave=function(t){var e;if(null!=this.m_currentDropItem){var r=this._findItem(t.target);return null!=r&&r.length>0?(r.removeClass("oj-valid-drop oj-invalid-drop"),e=this._invokeDropCallback("dragLeave",t,{item:r.get(0)}),!this._isDndEventInElement(t,t.currentTarget)&&r.hasClass("oj-drop")&&(this._cleanupDropTarget(),this._restoreGroupItemStyle())):this._isDndEventInElement(t,t.currentTarget)||this._cleanupEmptyList(),-1!==e?e:void 0}},n.prototype._isEmptyItem=function(t){return t.hasClass(this.listview.getEmptyTextStyleClass())||t.hasClass("oj-listview-no-data-item")},n.prototype._handleDrop=function(t){if(null!=this.m_currentDropItem){var e,r=t.originalEvent.dataTransfer.getData(this.GetDragSourceType());e=this._isEmptyItem(this.m_currentDropItem)?{}:{item:this.m_currentDropItem.get(0),position:this.m_dropPosition},this.IsItemReOrdering()&&r===this.listview.element.get(0).id?e.reorder=!0:e.reorder=!1,null!=this.m_currentDropItem&&this.m_currentDropItem.removeClass("oj-valid-drop"),this._cleanupDropTarget(),this._restoreGroupItemStyle(),this._destroyDragImage();var i=this._invokeDropCallback("drop",t,e);if(e.reorder&&(e.items=null==this.m_dragItems?this.m_itemsDragged:this.m_dragItems,this.listview.Trigger("reorder",t,this.CreateReorderPayload(e.items,e.position,e.item)),t.preventDefault()),this.m_currentDropItem=null,this.m_dropTargetIndex=-1,this.m_dropPosition=null,this.m_itemsDragged=null,-1!==i)return i}},n.prototype.CreateReorderPayload=function(t,e,r){return{items:t,position:e,reference:r}},n.prototype.prepareContextMenu=function(t){var e=this;if(this.IsItemReOrdering()){var i=r(t);this.m_contextMenu!==t&&(this.m_contextMenu=t,"OJ-MENU"===t.tagName?(t.addEventListener("ojBeforeOpen",this._handleContextMenuBeforeOpen.bind(this)),t.addEventListener("ojAction",this._handleContextMenuSelect.bind(this))):(i.on("ojbeforeopen",this._handleContextMenuBeforeOpen.bind(this)),i.on("ojselect",this._handleContextMenuSelect.bind(this))));var s=this._getCommands(t,function(t,i){var s=e._buildContextMenuItem(i,t.tagName);"OJ-OPTION"===t.tagName?(t.innerHTML=s.get(0).innerHTML,r(t).attr("data-oj-command",s.attr("data-oj-command"))):(s.get(0).className=r(t).get(0).className,r(t).replaceWith(s))});this.m_menuItemsSet=s,s.length>0&&i.data("oj-ojMenu")&&("OJ-MENU"===t.tagName?t.refresh():r(t).ojMenu("refresh"))}},n.prototype._getDndContextMenuItemSelector=function(){var t=this,e="",r=["cut","copy","paste","paste-before","paste-after","pasteBefore","pasteAfter"];return this.m_dndMenuItemSelector||(r.forEach(function(i,s){e+="[data-oj-command="+t.GetCommandPrefix()+i+"],",e+="[data-oj-command="+i+"]",s<r.length-1&&(e+=",")}),this.m_dndMenuItemSelector=e),this.m_dndMenuItemSelector},n.prototype._getCommands=function(t,e){var i=this,s=[];return r(t).find(this._getDndContextMenuItemSelector()).each(function(){var t;0===r(this).children("a").length?0===r(this).attr("data-oj-command").indexOf(i.GetCommandPrefix())&&(t=r(this).attr("data-oj-command").substring(i.GetCommandPrefix().length),e&&e(this,t)):(t=r(this).attr("data-oj-command"))===n.PASTE_BEFORE_COMMAND?t="paste-before":t===n.PASTE_AFTER_COMMAND&&(t="paste-after"),t&&s.push(t)}),s},n.prototype._buildContextMenuItem=function(t,e){return"paste-before"===t?this._buildContextMenuListItem(n.PASTE_BEFORE_COMMAND,e):"paste-after"===t?this._buildContextMenuListItem(n.PASTE_AFTER_COMMAND,e):this._buildContextMenuListItem(t,e)},n.prototype._buildContextMenuListItem=function(t,e){var i=r(document.createElement(e));return i.attr("data-oj-command",t),i.append(this._buildContextMenuLabel(t,"OJ-OPTION"===e)),i},n.prototype._buildContextMenuLabel=function(t,e){var i="label"+t.charAt(0).toUpperCase()+t.slice(1),s=document.createTextNode(this.listview.ojContext.getTranslatedString(i));return e?s:r('<a href="#"></a>').append(s)},n.prototype._handleCut=function(t){null!=this.m_clipboard&&r(this.m_clipboard).removeClass(this.GetCutStyleClass());var e=this.GetCutItems(t);this.listview.ojContext.element.focus(),r(e).addClass(this.GetCutStyleClass()),this.m_clipboard=e,this.listview.Trigger("cut",t,{items:e})},n.prototype.GetCutItems=function(t){return this._getSelectedItems()},n.prototype._handleCopy=function(t){null!=this.m_clipboard&&r(this.m_clipboard).removeClass(this.GetCutStyleClass());var e=this._getSelectedItems();this.m_clipboard=e,this.listview.Trigger("copy",t,{items:e})},n.prototype._handlePaste=function(t,e,i){this.listview.Trigger("paste",t,{item:e.get(0)}),r(this.m_clipboard).removeClass(this.GetCutStyleClass()),this.listview.Trigger("reorder",t,this.CreateReorderPayload(this.m_clipboard,i,e.get(0))),this.m_clipboard=null},n.prototype._handleContextMenuSelect=function(t,e){if(null!=this.m_contextMenuItem)switch((e?e.item:r(t.target)).attr("data-oj-command")){case n.CUT_COMMAND:this._handleCut(t);break;case n.COPY_COMMAND:this._handleCopy(t);break;case n.PASTE_COMMAND:this._handlePaste(t,this.m_contextMenuItem,"inside"),this.m_contextMenuItem=null;break;case n.PASTE_BEFORE_COMMAND:this._handlePaste(t,this.m_contextMenuItem,"before"),this.m_contextMenuItem=null;break;case n.PASTE_AFTER_COMMAND:this._handlePaste(t,this.m_contextMenuItem,"after"),this.m_contextMenuItem=null}},n.prototype._appendToMenuContainer=function(t,e){null!=this.m_menuItemsSet&&("paste-before"===e?e=n.PASTE_BEFORE_COMMAND:"paste-after"===e&&(e=n.PASTE_AFTER_COMMAND),t.find("[data-oj-command='"+e+"']").removeClass("oj-disabled"))},n.prototype._handleContextMenuBeforeOpen=function(t,e){var i=r(t.target);i.find(this._getDndContextMenuItemSelector()).addClass("oj-disabled");var s=e?e.openOptions.launcher:t.detail.openOptions.launcher;null!=s&&null!=this.m_menuItemsSet&&0!==this.m_menuItemsSet.length?(s.children().first().hasClass(this.listview.getGroupItemStyleClass())?null!=this.m_clipboard&&this._appendToMenuContainer(i,"paste"):(this._appendToMenuContainer(i,"cut"),this._appendToMenuContainer(i,"copy"),null!=this.m_clipboard&&(this._appendToMenuContainer(i,"paste-before"),this._appendToMenuContainer(i,"paste-after"))),"OJ-MENU"!==i.get(0).tagName&&i.ojMenu("refresh"),this.m_contextMenuItem=s):"OJ-MENU"!==i.get(0).tagName&&i.ojMenu("refresh")},n.prototype.HandleKeyDown=function(t){if(t.ctrlKey||t.metaKey){var e=t.keyCode;if(e===n.X_KEY||e===n.C_KEY||n.V_KEY){if(!this.IsItemReOrdering())return!1;var i=this.listview.ojContext._GetContextMenu();if(null==i)return!1;var s=this._getCommands(i);if(0===s.length)return!1;if(e===n.X_KEY&&s.indexOf("cut")>-1)return this._handleCut(t),!0;if(e===n.C_KEY&&s.indexOf("copy")>-1)return this._handleCopy(t),!0;if(e===n.V_KEY&&null!=this.m_clipboard){var a,o=r(this._getActiveItem());if(o.children().first().hasClass(this.listview.getGroupItemStyleClass())?s.indexOf("paste")>-1&&(a="inside"):s.indexOf("paste-before")>-1?a="before":s.indexOf("paste-after")>-1&&(a="after"),null!=a)return this._handlePaste(t,o,a),!0}}}return!1},n.prototype.shouldDragCurrentItem=function(){return!1},n.prototype.GetDragSourceType=function(){return"text/ojlistview-dragsource-id"},t.ListViewDndContext=n,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=ojlistviewdnd.js.map