define(["../PersistenceStore","../impl/storageUtils","pouchdb","./logger"],function(a,b,c,d){"use strict";var e=function(b){a.call(this,b)};e.prototype=new a,e.prototype.Init=function(a){this._version=a&&a.version||"0";var b=this._name+this._version,e=a?a.adapter:null,f=this._extractDBOptions(a);if(e)try{e.plugin&&c.plugin(e.plugin),f=f||{},f.adapter=e.name,this._dbOptions=f,this._db=new c(b,f)}catch(a){return d.log("Error creating PouchDB instance with adapter "+e+": ",a.message),d.log("Please make sure the needed plugin and adapter are installed."),Promise.reject(a)}else f?(this._dbOptions=f,this._db=new c(b,f)):(this._dbOptions=null,this._db=new c(b));return a&&a.index&&(Array.isArray(a.index)?(this._index=a.index.filter(function(a){return"key"!==a}),0===this._index.length&&(this._index=null)):d.log("index must be an array")),this._createIndex()},e.prototype._extractDBOptions=function(a){var b=null;if(a){var c=this;Object.keys(a).forEach(function(d){c._isPersistenceStoreKey(d)||(b||(b={}),b[d]=a[d])})}return b},e.prototype._isPersistenceStoreKey=function(a){return"version"===a||"adapter"===a||"index"===a||"skipMetadata"===a},e.prototype._createIndex=function(){if(this._index&&this._db.createIndex){var a=this,b=a._name+a._index.toString().replace(",","").replace(".",""),c={index:{fields:a._index,name:b}};return a._db.createIndex(c).catch(function(b){d.error("creating index on "+a._index.toString()+" failed with error "+b)})}return Promise.resolve()},e.prototype.upsert=function(a,b,c,e){d.log("Offline Persistence Toolkit pouchDBPersistenceStore: upsert() for key: "+a);var g=this,h=a.toString();return g._db.get(h).then(function(a){return f(e,a)?a:Promise.reject({status:409})}).catch(function(a){return 404===a.status&&"missing"===a.message?void 0:Promise.reject(a)}).then(function(a){return g._put(h,b,c,e,a)})},e.prototype._put=function(a,b,c,d,e){var f=[],g=this._prepareUpsert(c,f),h={_id:a,key:a,metadata:b,value:g?null:c};e&&(h._rev=e._rev);var i=this;return i._db.put(h).then(function(b){return i._addAttachments(a,b.rev,f)}).catch(function(a){if(409!==a.status)throw a})};var f=function(a,b){if(a){return b.metadata.versionIdentifier===a}return!0};e.prototype._addAttachments=function(a,b,c){if(c&&c.length){var e=this,f=c.map(function(c){var d;return d=c.value instanceof Blob?c.value:new Blob([c.value]),e._db.putAttachment(a,c.path,b,d,"binary")},this);return Promise.all(f).catch(function(b){d.error("store: "+e._name+" failed add attachment for doc "+a)})}return Promise.resolve()},e.prototype.upsertAll=function(a){if(d.log("Offline Persistence Toolkit pouchDBPersistenceStore: upsertAll()"),a&&a.length){var b=this,c={},e=a.map(function(a){var d=a.key.toString(),e=a.value,f=[],g=b._prepareUpsert(e,f);f.length>0&&(c[d]=f);var h={_id:d,key:a.key,metadata:a.metadata,value:g?null:e};return b._db.get(d).then(function(a){return h._rev=a._rev,h}).catch(function(a){if(404===a.status&&"missing"===a.message)return h;throw a})});return Promise.all(e).then(function(a){return b._db.bulkDocs(a)}).then(function(a){var e=[];if(a.forEach(function(a,f){if(a.ok){var g=c[a.id];g&&e.push(b._addAttachments(a.id,a.rev,g))}else 409===a.status&&d.log("conflict error")}),e.length>0)return Promise.all(e)}).catch(function(a){d.log("error in upsertAll")})}return Promise.resolve()},e.prototype.find=function(a){d.log("Offline Persistence Toolkit pouchDBPersistenceStore: find() for expression: "+JSON.stringify(a));var c=this;if(a=a||{},c._db.find){var e=c._prepareFind(a);return c._db.find(e).then(function(a){if(a&&a.docs&&a.docs.length){var b=a.docs.map(c._findResultCallback(e.fields),c);return Promise.all(b)}return[]}).catch(function(a){if(404===a.status&&"missing"===a.message)return[];throw a})}return c._db.allDocs({include_docs:!0}).then(function(d){if(d&&d.rows&&d.rows.length){var e=d.rows.filter(function(c){var d=c.doc;return!(g(c)||!b.satisfy(a.selector,d))});if(e.length){var f=e.map(function(a){return c._fixKey(a.doc),a.doc}),h=b.sortRows(f,a.sort),i=h.map(function(d){return c._fixBinaryValue(d).then(function(c){return a.fields?b.assembleObject(c,a.fields):c.value})});return Promise.all(i)}return[]}return[]}).catch(function(a){return d.log("error retrieving all documents from pouch db, returns empty list as find operation.",a),[]})},e.prototype._findResultCallback=function(a){return function(b){return this._fixValue(b).then(function(b){return a?b:b.value})}},e.prototype._fixValue=function(a){return this._fixKey(a),this._fixBinaryValue(a)},e.prototype._fixBinaryValue=function(a){var b=a._id||a.id||a.key,c=a._attachments;if(c){var e=this,f=Object.keys(c)[0];return e._db.getAttachment(b,f).then(function(b){if("rootpath"===f)a.value=b;else{for(var c=f.split("."),d=a.value,e=0;e<c.length-1;e++)d=d[c[e]];d[c[c.length-1]]=b}return a}).catch(function(a){d.error("store: "+e._name+" error getting attachment. ")})}return Promise.resolve(a)},e.prototype.findByKey=function(a){d.log("Offline Persistence Toolkit pouchDBPersistenceStore: findByKey() for key: "+a);var b=this,c=a.toString();return b._db.get(c,{attachments:!0}).then(function(a){return b._fixBinaryValue(a)}).then(function(a){return a.value}).catch(function(a){return 404===a.status&&"missing"===a.message?void 0:Promise.reject(a)})},e.prototype.removeByKey=function(a){d.log("Offline Persistence Toolkit pouchDBPersistenceStore: removeByKey() for key: "+a);var b=this;if(!a)return Promise.resolve(!1);var c=a.toString();return b._db.get(c).then(function(a){return b._db.remove(a)}).then(function(){return!0}).catch(function(a){return(404!==a.status||"missing"!==a.message)&&Promise.reject(a)})},e.prototype.delete=function(a){d.log("Offline Persistence Toolkit pouchDBPersistenceStore: delete() for expression: "+JSON.stringify(a));var b=this;if(a){var e=a;return e.fields=["_id","_rev"],b.find(e).then(function(a){if(a&&a.length){var c=a.map(function(a){return{_id:a._id,_rev:a._rev,_deleted:!0}});return b._db.bulkDocs(c)}}).catch(function(a){d.error("store: "+b._name+" error deleting....")})}return b._db.destroy().then(function(){var a=b._name+b._version;return b._dbOptions?b._db=new c(a,b._dbOptions):b._db=new c(a),b._createIndex()}).catch(function(a){d.error("store: "+b._name+" error deleting....")})},e.prototype.keys=function(){d.log("Offline Persistence Toolkit pouchDBPersistenceStore: keys()");var a=this;return a._db.allDocs().then(function(a){var b=a.rows,c=[];if(b&&b.length)for(var d=0;d<b.length;d++)g(b[d])||c.push(b[d].id);return c}).catch(function(b){d.error("store: "+a._name+" error getting all the docs for keys ")})},e.prototype._prepareFind=function(a){var b={},c=a.selector;c?c&&(b.selector=c):b.selector={_id:{$gt:null}};var d=a.fields;return d&&d.length&&(b.fields=d,-1!==d.indexOf("key")&&-1===d.indexOf("_id")&&b.fields.push("_id")),b},e.prototype._prepareUpsert=function(a,b){if(!a)return!1;if(a instanceof Blob||a instanceof ArrayBuffer)return b.push({path:"rootpath",value:a}),!0;return this._inspectValue("",a,b),!1},e.prototype._inspectValue=function(a,b,c){for(var d in b)if(b.hasOwnProperty(d)){var e=b[d];if(e&&"object"==typeof e)if(e instanceof Blob||e instanceof ArrayBuffer){var f=a;f.length>0&&(f+=".");var g={path:f+d,value:e};c.push(g),b.key=null}else if(void 0===e.length){var h=a;a.length>0&&(a+="."),a+=d,this._inspectValue(a,e,c),a=h}}},e.prototype.updateKey=function(a,b){d.log("Offline Persistence Toolkit PouchDBPersistenceStore: updateKey() with currentKey: "+a+" and new key: "+b);var c=this;return c._db.get(a).then(function(a){return a?c.upsert(b,a.metadata,a.value):Promise.reject("No existing key found to update")}).then(function(){return c.removeByKey(a)}).catch(function(){d.error("store: "+c._name+" error updating key")})};var g=function(a){return a.id.startsWith("_design/")};return e.prototype._fixKey=function(a){var b=a._id||a.id||a.key;b&&(a.key=b)},e});