/**
 * Copyright (c) 2017, Oracle and/or its affiliates.
 * All rights reserved.
 */

// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// originally parseUri 1.2.2, now patched by us
// (c) Steven Levithan <stevenlevithan.com>
// MIT License

define("persist/PersistenceStore",[],function(){"use strict";var e=function(e){this._name=e};return e.prototype={},e.prototype.getName=function(){return this._name},e.prototype.getVersion=function(){return this._version},e.prototype.Init=function(e){return e&&e.version?this._version=e.version:this._version="0",Promise.resolve()},e.prototype.upsert=function(e,t,n,r){throw TypeError("failed in abstract function")},e.prototype.upsertAll=function(e){throw TypeError("failed in abstract function")},e.prototype.find=function(e){throw TypeError("failed in abstract function")},e.prototype.findByKey=function(e){throw TypeError("failed in abstract function")},e.prototype.removeByKey=function(e){throw TypeError("failed in abstract function")},e.prototype.delete=function(e){throw TypeError("failed in abstract function")},e.prototype.keys=function(){throw TypeError("failed in abstract function")},e.prototype.updateKey=function(e,t){throw TypeError("failed in abstract function")},e}),define("persist/impl/storageUtils",["./logger"],function(e){"use strict";function t(t,r){e.log("Offline Persistence Toolkit storageUtils: Processing selector: "+JSON.stringify(t));if(!t)return!0;var s=n(t);return i(s,r)}function n(e){var t,i=[];for(var a in e)if(e.hasOwnProperty(a)){var f=e[a];if(a.indexOf("$")===0){if(s(a)){if(!(f instanceof Array))throw new Error("not a valid expression: "+e);t={operator:a,array:[]};for(var l=0;l<f.length;l++){var c=n(f[l]);t.array.push(c)}}else if(o(a))throw new Error("not a valid expression: "+e)}else if(u(f))i.push({left:a,right:f,operator:"$eq"});else{var h={left:a};r(h,f),i.push(h)}}return i.length>1?t={operator:"$and",array:i}:i.length===1&&(t=i[0]),t}function r(e,t){var n=!1;for(var r in t)if(t.hasOwnProperty(r)){var i=t[r];if(n||!o(r))throw new Error("parsing error "+t);e.operator=r,e.right=i,n=!0}}function i(e,t){var n=e.operator;if(s(n)){if(!e.left&&e.array instanceof Array){var r,u=e.array;for(var a=0;a<u.length;a++){var c=i(u[a],t);if(n==="$or"&&c===!0)return!0;if(n==="$and"&&c===!1)return!1;r=c}return r}throw new Error("invalid expression tree!"+e)}if(!o(n))throw new Error("not a valid expression!"+e);var h=l(e.left,t),p=e.right;if(n==="$lt"){var d=f(h,p);return h=d[0],p=d[1],h<p}if(n==="$gt"){var d=f(h,p);return h=d[0],p=d[1],h>p}if(n==="$lte"){var d=f(h,p);return h=d[0],p=d[1],h<=p}if(n==="$gte"){var d=f(h,p);return h=d[0],p=d[1],h>=p}if(n==="$eq")return h===p;if(n==="$ne")return h!==p;if(n==="$regex"){var v=h.match(p);return v!==null}if(n==="$exists")return p?h!==null&&h!==undefined:h===null||h===undefined;if(n!=="$in"){if(n==="$nin")return p.indexOf(h)<0;throw new Error("not a valid expression! "+e)}for(var m=0;m<p.length;m++)if(p[m]===h)return!0;return!1}function s(e){return e==="$and"||e==="$or"}function o(e){return e==="$lt"||e==="$gt"||e==="$lte"||e==="$gte"||e==="$eq"||e==="$ne"||e==="$regex"||e==="$exists"||e==="$in"||e==="$nin"}function u(e){return typeof e!="object"}function a(e){return e!=null&&(e instanceof String||typeof e=="string")}function f(e,t){return a(e)&&t==null?t="":a(t)&&e==null&&(e=""),[e,t]}function l(e,t){var n=e.split("."),r=t;for(var i=0;i<n.length;i++)r=r[n[i]];return r}function c(e,t){var n;if(!t)n=e;else{n={};for(var r=0;r<t.length;r++){var i=n,s=e,o=t[r],u=o.split(".");for(var a=0;a<u.length;a++)s=s[u[a]],!i[u[a]]&&a<u.length-1&&(i[u[a]]={}),a===u.length-1?i[u[a]]=s:i=i[u[a]]}}return n}function h(e,t){return!e||!Array.isArray(e)||e.length<1||!t||!Array.isArray(t)||!t.length?e:e.sort(p(t))}var p=function(e){return function(t,n){for(var r=0;r<e.length;r++){var i=e[r],s,o=!0;if(typeof i=="string")s=i;else{if(typeof i!="object")throw new Error("invalid sort criteria.");var u=Object.keys(i);if(!u||u.length!==1)throw new Error("invalid sort criteria");s=u[0],o=i[s].toLowerCase()==="asc"}var a=l(s,t),f=l(s,n);if(a==f)continue;return o?a<f?-1:1:a<f?1:-1}return 0}};return{satisfy:t,getValue:l,assembleObject:c,sortRows:h}}),define("persist/impl/keyValuePersistenceStore",["../PersistenceStore","./storageUtils","./logger"],function(e,t,n){"use strict";var r=function(t){e.call(this,t)};return r.prototype=new e,r.prototype.Init=function(e){return this._version=e&&e.version||"0",Promise.resolve()},r.prototype.getItem=function(e){throw TypeError("failed in abstract function")},r.prototype.removeByKey=function(e){throw TypeError("failed in abstract function")},r.prototype.keys=function(){throw TypeError("failed in abstract function")},r.prototype.findByKey=function(e){return n.log("Offline Persistence Toolkit keyValuePersistenceStore called by subclass: findByKey() with key: "+e),this.getItem(e).then(function(e){return e?Promise.resolve(e.value):Promise.resolve()})},r.prototype.find=function(e){n.log("Offline Persistence Toolkit keyValuePersistenceStore called by subclass: find() with expression: "+JSON.stringify(e));var r=this,i=[],s=[],e=e||{};return this.keys().then(function(n){var o=[];for(var u=0;u<n.length;u++){var a=n[u];a&&o.push(function(n){return r.getItem(n).then(function(r){r&&t.satisfy(e.selector,r)&&(r.key=n,s.push(r))})}(a))}return Promise.all(o).then(function(){var n=t.sortRows(s,e.sort);for(var o=0;o<n.length;o++)i.push(r._constructReturnObject(e.fields,n[o]));return Promise.resolve(i)})})},r.prototype.updateKey=function(e,t){n.log("Offline Persistence Toolkit keyValuePersistenceStore called by subclass: updateKey() with currentKey: "+e+" and new key: "+t);var r=this;return this.getItem(e).then(function(e){return e?r._insert(t,e.metadata,e.value):Promise.reject("No existing key found to update")}).then(function(){return r.removeByKey(e)})},r.prototype._constructReturnObject=function(e,n){var r;return e?r=t.assembleObject(n,e):r=n.value,r},r.prototype._removeByKeyMapCallback=function(e){var t=this;return function(n){var r;return e?r=n[e]:r=n,t.removeByKey(r)}},r.prototype.delete=function(e){n.log("Offline Persistence Toolkit keyValuePersistenceStore called by subclass: delete() with expression: "+JSON.stringify(e));var t=this;if(!e)return this.deleteAll();var r=e;return r.fields=["key"],t.find(r).then(function(e){if(e&&e.length){var n=e.map(t._removeByKeyMapCallback("key"),t);return Promise.all(n)}return Promise.resolve()})},r.prototype.deleteAll=function(){n.log("Offline Persistence Toolkit keyValuePersistenceStore called by subclass: deleteAll()");var e=this,t=[],r;return this.keys().then(function(n){for(r=0;r<n.length;r++)t.push(e.removeByKey(n[r]));return Promise.all(t)})},r.prototype.upsert=function(e,t,r,i){n.log("Offline Persistence Toolkit keyValuePersistenceStore called by subclass: upsert() for key: "+e);var s=this;return this.getItem(e).then(function(n){if(n&&i){var o=n.metadata.versionIdentifier;if(o!==i)return Promise.reject({status:409});var u=t.versionIdentifier;return u!==o?s._insert(e,t,r):Promise.resolve()}return s._insert(e,t,r)})},r.prototype.upsertAll=function(e){n.log("Offline Persistence Toolkit keyValuePersistenceStore called by subclass: upsertAll()");var t=[];for(var r=0;r<e.length;r++){var i=e[r];t.push(this.upsert(i.key,i.metadata,i.value,i.expectedVersionIndentifier))}return Promise.all(t)},r}),define("persist/impl/PersistenceStoreMetadata",[],function(){"use strict";var e=function(e,t,n){this.name=e,this.persistenceStoreFactory=t,this.versions=n};return e.prototype={},e.prototype.name,e.prototype.persistenceStoreFactory,e.prototype.versions,e}),function(e){if(typeof exports=="object"&&typeof module!="undefined")module.exports=e();else if(typeof define=="function"&&define.amd)define("pouchdb",[],e);else{var t;typeof window!="undefined"?t=window:typeof global!="undefined"?t=global:typeof self!="undefined"?t=self:t=this,t.PouchDB=e()}}(function(){var e,t,n;return function(){function e(t,n,i){function s(u,a){if(!n[u]){if(!t[u]){var f="function"==typeof require&&require;if(!a&&f)return f(u,!0);if(o)return o(u,!0);var l=new Error("Cannot find module '"+u+"'");throw l.code="MODULE_NOT_FOUND",l}var c=n[u]={exports:{}};t[u][0].call(c.exports,function(e){var n=t[u][1][e];return s(n||e)},c,c.exports,e,t,n,i)}return n[u].exports}for(var o="function"==typeof require&&require,u=0;u<i.length;u++)s(i[u]);return s}return e}()({1:[function(e,t,n){"use strict";function r(e){return function(){var t=arguments.length;if(t){var n=[],r=-1;while(++r<t)n[r]=arguments[r];return e.call(this,n)}return e.call(this,[])}}t.exports=r},{}],2:[function(e,t,n){function o(){if(!this._events||!Object.prototype.hasOwnProperty.call(this,"_events"))this._events=r(null),this._eventsCount=0;this._maxListeners=this._maxListeners||undefined}function c(e){return e._maxListeners===undefined?o.defaultMaxListeners:e._maxListeners}function h(e,t,n){if(t)e.call(n);else{var r=e.length,i=x(e,r);for(var s=0;s<r;++s)i[s].call(n)}}function p(e,t,n,r){if(t)e.call(n,r);else{var i=e.length,s=x(e,i);for(var o=0;o<i;++o)s[o].call(n,r)}}function d(e,t,n,r,i){if(t)e.call(n,r,i);else{var s=e.length,o=x(e,s);for(var u=0;u<s;++u)o[u].call(n,r,i)}}function v(e,t,n,r,i,s){if(t)e.call(n,r,i,s);else{var o=e.length,u=x(e,o);for(var a=0;a<o;++a)u[a].call(n,r,i,s)}}function m(e,t,n,r){if(t)e.apply(n,r);else{var i=e.length,s=x(e,i);for(var o=0;o<i;++o)s[o].apply(n,r)}}function g(e,t,n,i){var s,o,u;if(typeof n!="function")throw new TypeError('"listener" argument must be a function');o=e._events,o?(o.newListener&&(e.emit("newListener",t,n.listener?n.listener:n),o=e._events),u=o[t]):(o=e._events=r(null),e._eventsCount=0);if(!u)u=o[t]=n,++e._eventsCount;else{typeof u=="function"?u=o[t]=i?[n,u]:[u,n]:i?u.unshift(n):u.push(n);if(!u.warned){s=c(e);if(s&&s>0&&u.length>s){u.warned=!0;var a=new Error("Possible EventEmitter memory leak detected. "+u.length+' "'+String(t)+'" listeners '+"added. Use emitter.setMaxListeners() to "+"increase limit.");a.name="MaxListenersExceededWarning",a.emitter=e,a.type=t,a.count=u.length,typeof console=="object"&&console.warn&&console.warn("%s: %s",a.name,a.message)}}}return e}function y(){if(!this.fired){this.target.removeListener(this.type,this.wrapFn),this.fired=!0;switch(arguments.length){case 0:return this.listener.call(this.target);case 1:return this.listener.call(this.target,arguments[0]);case 2:return this.listener.call(this.target,arguments[0],arguments[1]);case 3:return this.listener.call(this.target,arguments[0],arguments[1],arguments[2]);default:var e=new Array(arguments.length);for(var t=0;t<e.length;++t)e[t]=arguments[t];this.listener.apply(this.target,e)}}}function b(e,t,n){var r={fired:!1,wrapFn:undefined,target:e,type:t,listener:n},i=s.call(y,r);return i.listener=n,r.wrapFn=i,i}function w(e,t,n){var r=e._events;if(!r)return[];var i=r[t];return i?typeof i=="function"?n?[i.listener||i]:[i]:n?T(i):x(i,i.length):[]}function E(e){var t=this._events;if(t){var n=t[e];if(typeof n=="function")return 1;if(n)return n.length}return 0}function S(e,t){for(var n=t,r=n+1,i=e.length;r<i;n+=1,r+=1)e[n]=e[r];e.pop()}function x(e,t){var n=new Array(t);for(var r=0;r<t;++r)n[r]=e[r];return n}function T(e){var t=new Array(e.length);for(var n=0;n<t.length;++n)t[n]=e[n].listener||e[n];return t}function N(e){var t=function(){};return t.prototype=e,new t}function C(e){var t=[];for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.push(n);return n}function k(e){var t=this;return function(){return t.apply(e,arguments)}}var r=Object.create||N,i=Object.keys||C,s=Function.prototype.bind||k;t.exports=o,o.EventEmitter=o,o.prototype._events=undefined,o.prototype._maxListeners=undefined;var u=10,a;try{var f={};Object.defineProperty&&Object.defineProperty(f,"x",{value:0}),a=f.x===0}catch(l){a=!1}a?Object.defineProperty(o,"defaultMaxListeners",{enumerable:!0,get:function(){return u},set:function(e){if(typeof e!="number"||e<0||e!==e)throw new TypeError('"defaultMaxListeners" must be a positive number');u=e}}):o.defaultMaxListeners=u,o.prototype.setMaxListeners=function(t){if(typeof t!="number"||t<0||isNaN(t))throw new TypeError('"n" argument must be a positive number');return this._maxListeners=t,this},o.prototype.getMaxListeners=function(){return c(this)},o.prototype.emit=function(t){var n,r,i,s,o,u,a=t==="error";u=this._events;if(u)a=a&&u.error==null;else if(!a)return!1;if(a){arguments.length>1&&(n=arguments[1]);if(n instanceof Error)throw n;var f=new Error('Unhandled "error" event. ('+n+")");throw f.context=n,f}r=u[t];if(!r)return!1;var l=typeof r=="function";i=arguments.length;switch(i){case 1:h(r,l,this);break;case 2:p(r,l,this,arguments[1]);break;case 3:d(r,l,this,arguments[1],arguments[2]);break;case 4:v(r,l,this,arguments[1],arguments[2],arguments[3]);break;default:s=new Array(i-1);for(o=1;o<i;o++)s[o-1]=arguments[o];m(r,l,this,s)}return!0},o.prototype.addListener=function(t,n){return g(this,t,n,!1)},o.prototype.on=o.prototype.addListener,o.prototype.prependListener=function(t,n){return g(this,t,n,!0)},o.prototype.once=function(t,n){if(typeof n!="function")throw new TypeError('"listener" argument must be a function');return this.on(t,b(this,t,n)),this},o.prototype.prependOnceListener=function(t,n){if(typeof n!="function")throw new TypeError('"listener" argument must be a function');return this.prependListener(t,b(this,t,n)),this},o.prototype.removeListener=function(t,n){var i,s,o,u,a;if(typeof n!="function")throw new TypeError('"listener" argument must be a function');s=this._events;if(!s)return this;i=s[t];if(!i)return this;if(i===n||i.listener===n)--this._eventsCount===0?this._events=r(null):(delete s[t],s.removeListener&&this.emit("removeListener",t,i.listener||n));else if(typeof i!="function"){o=-1;for(u=i.length-1;u>=0;u--)if(i[u]===n||i[u].listener===n){a=i[u].listener,o=u;break}if(o<0)return this;o===0?i.shift():S(i,o),i.length===1&&(s[t]=i[0]),s.removeListener&&this.emit("removeListener",t,a||n)}return this},o.prototype.removeAllListeners=function(t){var n,s,o;s=this._events;if(!s)return this;if(!s.removeListener)return arguments.length===0?(this._events=r(null),this._eventsCount=0):s[t]&&(--this._eventsCount===0?this._events=r(null):delete s[t]),this;if(arguments.length===0){var u=i(s),a;for(o=0;o<u.length;++o){a=u[o];if(a==="removeListener")continue;this.removeAllListeners(a)}return this.removeAllListeners("removeListener"),this._events=r(null),this._eventsCount=0,this}n=s[t];if(typeof n=="function")this.removeListener(t,n);else if(n)for(o=n.length-1;o>=0;o--)this.removeListener(t,n[o]);return this},o.prototype.listeners=function(t){return w(this,t,!0)},o.prototype.rawListeners=function(t){return w(this,t,!1)},o.listenerCount=function(e,t){return typeof e.listenerCount=="function"?e.listenerCount(t):E.call(e,t)},o.prototype.listenerCount=E,o.prototype.eventNames=function(){return this._eventsCount>0?Reflect.ownKeys(this._events):[]}},{}],3:[function(e,t,n){(function(e){(function(){"use strict";function l(){a=!0;var e,t,n=f.length;while(n){t=f,f=[],e=-1;while(++e<n)t[e]();n=f.length}a=!1}function c(e){f.push(e)===1&&!a&&r()}var n=e.MutationObserver||e.WebKitMutationObserver,r;if(n){var i=0,s=new n(l),o=e.document.createTextNode("");s.observe(o,{characterData:!0}),r=function(){o.data=i=++i%2}}else if(!e.setImmediate&&typeof e.MessageChannel!="undefined"){var u=new e.MessageChannel;u.port1.onmessage=l,r=function(){u.port2.postMessage(0)}}else"document"in e&&"onreadystatechange"in e.document.createElement("script")?r=function(){var t=e.document.createElement("script");t.onreadystatechange=function(){l(),t.onreadystatechange=null,t.parentNode.removeChild(t),t=null},e.document.documentElement.appendChild(t)}:r=function(){setTimeout(l,0)};var a,f=[];t.exports=c}).call(this)}).call(this,typeof global!="undefined"?global:typeof self!="undefined"?self:typeof window!="undefined"?window:{})},{}],4:[function(e,t,n){typeof Object.create=="function"?t.exports=function(t,n){t.super_=n,t.prototype=Object.create(n.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}})}:t.exports=function(t,n){t.super_=n;var r=function(){};r.prototype=n.prototype,t.prototype=new r,t.prototype.constructor=t}},{}],5:[function(e,t,n){(function(n,r){(function(){"use strict";function i(e){return e&&typeof e=="object"&&"default"in e?e["default"]:e}function h(e){return typeof ArrayBuffer!="undefined"&&e instanceof ArrayBuffer||typeof Blob!="undefined"&&e instanceof Blob}function p(e){if(typeof e.slice=="function")return e.slice(0);var t=new ArrayBuffer(e.byteLength),n=new Uint8Array(t),r=new Uint8Array(e);return n.set(r),t}function d(e){if(e instanceof ArrayBuffer)return p(e);var t=e.size,n=e.type;return typeof e.slice=="function"?e.slice(0,t,n):e.webkitSlice(0,t,n)}function g(e){var t=Object.getPrototypeOf(e);if(t===null)return!0;var n=t.constructor;return typeof n=="function"&&n instanceof n&&v.call(n)==m}function y(e){var t,n,r;if(!e||typeof e!="object")return e;if(Array.isArray(e)){t=[];for(n=0,r=e.length;n<r;n++)t[n]=y(e[n]);return t}if(e instanceof Date)return e.toISOString();if(h(e))return d(e);if(!g(e))return e;t={};for(n in e)if(Object.prototype.hasOwnProperty.call(e,n)){var i=y(e[n]);typeof i!="undefined"&&(t[n]=i)}return t}function b(e){var t=!1;return s(function(n){if(t)throw new Error("once called more than once");t=!0,e.apply(this,n)})}function w(e){return s(function(t){t=y(t);var n=this,r=typeof t[t.length-1]=="function"?t.pop():!1,i=new Promise(function(r,i){var s;try{var o=b(function(e,t){e?i(e):r(t)});t.push(o),s=e.apply(n,t),s&&typeof s.then=="function"&&r(s)}catch(u){i(u)}});return r&&i.then(function(e){r(null,e)},r),i})}function E(e,t,n){if(e.constructor.listeners("debug").length){var r=["api",e.name,t];for(var i=0;i<n.length-1;i++)r.push(n[i]);e.constructor.emit("debug",r);var s=n[n.length-1];n[n.length-1]=function(n,r){var i=["api",e.name,t];i=i.concat(n?["error",n]:["success",r]),e.constructor.emit("debug",i),s(n,r)}}}function S(e,t){return w(s(function(n){if(this._closed)return Promise.reject(new Error("database is closed"));if(this._destroyed)return Promise.reject(new Error("database is destroyed"));var r=this;return E(r,e,n),this.taskqueue.isReady?t.apply(this,n):new Promise(function(t,i){r.taskqueue.addTask(function(s){s?i(s):t(r[e].apply(r,n))})})}))}function x(e){return"$"+e}function T(e){return e.substring(1)}function N(){this._store={}}function C(e){this._store=new N;if(e&&Array.isArray(e))for(var t=0,n=e.length;t<n;t++)this.add(e[t])}function k(){if(typeof Symbol=="undefined"||typeof Map=="undefined"||typeof Set=="undefined")return!1;var e=Object.getOwnPropertyDescriptor(Map,Symbol.species);return e&&"get"in e&&Map[Symbol.species]===Map}function O(e,t){var n={};for(var r=0,i=t.length;r<i;r++){var s=t[r];s in e&&(n[s]=e[s])}return n}function _(e){return e}function D(e){return[{ok:e}]}function P(e,t,n){function a(){var e=[];u.forEach(function(t){t.docs.forEach(function(n){e.push({id:t.id,docs:[n]})})}),n(null,{results:e})}function f(){++o===s&&a()}function l(e,t,n){u[e]={id:t,docs:n},f()}function p(){if(h>=c.length)return;var e=Math.min(h+M,c.length),t=c.slice(h,e);d(t,h),h+=t.length}function d(n,r){n.forEach(function(n,s){var o=r+s,u=i.get(n),a=O(u[0],["atts_since","attachments"]);a.open_revs=u.map(function(e){return e.rev}),a.open_revs=a.open_revs.filter(_);var f=_;a.open_revs.length===0&&(delete a.open_revs,f=D),["revs","attachments","binary","ajax","latest"].forEach(function(e){e in t&&(a[e]=t[e])}),e.get(n,a,function(e,t){var r;e?r=[{error:e}]:r=f(t),l(o,n,r),p()})})}var r=t.docs,i=new A;r.forEach(function(e){i.has(e.id)?i.get(e.id).push(e):i.set(e.id,[e])});var s=i.size,o=0,u=new Array(s),c=[];i.forEach(function(e,t){c.push(t)});var h=0;p()}function j(){return H}function F(e){j()&&addEventListener("storage",function(t){e.emit(t.key)})}function I(){u.EventEmitter.call(this),this._listeners={},F(this)}function q(e){if(typeof console!="undefined"&&typeof console[e]=="function"){var t=Array.prototype.slice.call(arguments,1);console[e].apply(console,t)}}function R(e,t){var n=6e5;e=parseInt(e,10)||0,t=parseInt(t,10),t!==t||t<=e?t=(e||1)<<1:t+=1,t>n&&(e=n>>1,t=n);var r=Math.random(),i=t-e;return~~(i*r+e)}function U(e){var t=0;return e||(t=2e3),R(e,t)}function z(e,t){q("info","The above "+e+" is totally normal. "+t)}function V(e,t,n){Error.call(this,n),this.status=e,this.name=t,this.message=n,this.error=!0}function gt(e,t){function n(t){for(var n in e)typeof e[n]!="function"&&(this[n]=e[n]);t!==undefined&&(this.reason=t)}return n.prototype=V.prototype,new n(t)}function yt(e){if(typeof e!="object"){var t=e;e=tt,e.data=t}return"error"in e&&e.error==="conflict"&&(e.name="conflict",e.status=409),"name"in e||(e.name=e.error||"unknown"),"status"in e||(e.status=500),"message"in e||(e.message=e.message||e.reason),e}function bt(e,t,n){try{return!e(t,n)}catch(r){var i="Filter function threw: "+r.toString();return gt(ot,i)}}function wt(e){var t={},n=e.filter&&typeof e.filter=="function";return t.query=e.query_params,function(i){i.doc||(i.doc={});var s=n&&bt(e.filter,i.doc,t);if(typeof s=="object")return s;if(s)return!1;if(!e.include_docs)delete i.doc;else if(!e.attachments)for(var o in i.doc._attachments)i.doc._attachments.hasOwnProperty(o)&&(i.doc._attachments[o].stub=!0);return!0}}function Et(e){var t=[];for(var n=0,r=e.length;n<r;n++)t=t.concat(e[n]);return t}function St(e){var t;e?typeof e!="string"?t=gt(G):/^_/.test(e)&&!/^_(design|local)/.test(e)&&(t=gt(Z)):t=gt(Y);if(t)throw t}function xt(e){return typeof e._remote=="boolean"?e._remote:typeof e.type=="function"?(q("warn","db.type() is deprecated and will be removed in a future version of PouchDB"),e.type()==="http"):!1}function Tt(e,t){return"listenerCount"in e?e.listenerCount(t):u.EventEmitter.listenerCount(e,t)}function Nt(e){if(!e)return null;var t=e.split("/");return t.length===2?t:t.length===1?[e,e]:null}function Ct(e){var t=Nt(e);return t?t.join("/"):null}function Mt(e){var t=Ot.exec(e),n={},r=14;while(r--){var i=kt[r],s=t[r]||"",o=["user","password"].indexOf(i)!==-1;n[i]=o?decodeURIComponent(s):s}return n[Lt]={},n[kt[12]].replace(At,function(e,t,r){t&&(n[Lt][t]=r)}),n}function _t(e,t){var n=[],r=[];for(var i in t)t.hasOwnProperty(i)&&(n.push(i),r.push(t[i]));return n.push(e),Function.apply(null,n).apply(null,r)}function Dt(e,t,n){return new Promise(function(r,i){e.get(t,function(s,o){if(s){if(s.status!==404)return i(s);o={}}var u=o._rev,a=n(o);if(!a)return r({updated:!1,rev:u});a._id=t,a._rev=u,r(Pt(e,a,n))})})}function Pt(e,t,n){return e.put(t).then(function(e){return{updated:!0,rev:e.rev}},function(r){if(r.status!==409)throw r;return Dt(e,t._id,n)})}function jt(e,t){e=e||[],t=t||{};try{return new Blob(e,t)}catch(n){if(n.name!=="TypeError")throw n;var r=typeof BlobBuilder!="undefined"?BlobBuilder:typeof MSBlobBuilder!="undefined"?MSBlobBuilder:typeof MozBlobBuilder!="undefined"?MozBlobBuilder:WebKitBlobBuilder,i=new r;for(var s=0;s<e.length;s+=1)i.append(e[s]);return i.getBlob(t.type)}}function Ft(e){var t=e.length,n=new ArrayBuffer(t),r=new Uint8Array(n);for(var i=0;i<t;i++)r[i]=e.charCodeAt(i);return n}function It(e,t){return jt([Ft(e)],{type:t})}function qt(e,t){return It(Ht(e),t)}function Rt(e){var t="",n=new Uint8Array(e),r=n.byteLength;for(var i=0;i<r;i++)t+=String.fromCharCode(n[i]);return t}function Ut(e,t){var n=new FileReader,r=typeof n.readAsBinaryString=="function";n.onloadend=function(e){var n=e.target.result||"";if(r)return t(n);t(Rt(n))},r?n.readAsBinaryString(e):n.readAsArrayBuffer(e)}function zt(e,t){Ut(e,function(e){t(e)})}function Wt(e,t){zt(e,function(e){t(Bt(e))})}function Xt(e,t){var n=new FileReader;n.onloadend=function(e){var n=e.target.result||new ArrayBuffer(0);t(n)},n.readAsArrayBuffer(e)}function Jt(e){return Bt(e)}function Kt(e,t,n){return e.webkitSlice?e.webkitSlice(t,n):e.slice(t,n)}function Qt(e,t,n,r,i){if(n>0||r<t.size)t=Kt(t,n,r);Xt(t,function(t){e.append(t),i()})}function Gt(e,t,n,r,i){if(n>0||r<t.length)t=t.substring(n,r);e.appendBinary(t),i()}function Yt(e,t){function l(){Vt(h)}function c(){var e=u.end(!0),n=Jt(e);t(n),u.destroy()}function h(){var t=o*i,n=t+i;o++,o<s?a(u,e,t,n,l):a(u,e,t,n,c)}var n=typeof e=="string",r=n?e.length:e.size,i=Math.min($t,r),s=Math.ceil(r/i),o=0,u=n?new f:new f.ArrayBuffer,a=n?Gt:Qt;h()}function Zt(e){return f.hash(e)}function en(e,t){var n=y(e);return t?(delete n._rev_tree,Zt(JSON.stringify(n))):l.v4().replace(/-/g,"").toLowerCase()}function nn(e){var t,n,r,i=e.rev_tree.slice(),s;while(s=i.pop()){var o=s.ids,u=o[2],a=s.pos;if(u.length){for(var f=0,l=u.length;f<l;f++)i.push({pos:a+1,ids:u[f]});continue}var c=!!o[1].deleted,h=o[0];if(!t||(r!==c?r:n!==a?n<a:t<h))t=h,n=a,r=c}return n+"-"+t}function rn(e,t){var n=e.slice(),r;while(r=n.pop()){var i=r.pos,s=r.ids,o=s[2],u=t(o.length===0,i,s[0],r.ctx,s[1]);for(var a=0,f=o.length;a<f;a++)n.push({pos:i+1,ids:o[a],ctx:u})}}function sn(e,t){return e.pos-t.pos}function on(e){var t=[];rn(e,function(e,n,r,i,s){e&&t.push({rev:n+"-"+r,pos:n,opts:s})}),t.sort(sn).reverse();for(var n=0,r=t.length;n<r;n++)delete t[n].pos;return t}function un(e){var t=nn(e),n=on(e.rev_tree),r=[];for(var i=0,s=n.length;i<s;i++){var o=n[i];o.rev!==t&&!o.opts.deleted&&r.push(o.rev)}return r}function an(e){var t=[];return rn(e.rev_tree,function(e,n,r,i,s){s.status==="available"&&!e&&(t.push(n+"-"+r),s.status="missing")}),t}function fn(e){var t=[],n=e.slice(),r;while(r=n.pop()){var i=r.pos,s=r.ids,o=s[0],u=s[1],a=s[2],f=a.length===0,l=r.history?r.history.slice():[];l.push({id:o,opts:u}),f&&t.push({pos:i+1-l.length,ids:l});for(var c=0,h=a.length;c<h;c++)n.push({pos:i+1,ids:a[c],history:l})}return t.reverse()}function ln(e,t){return e.pos-t.pos}function cn(e,t,n){var r=0,i=e.length,s;while(r<i)s=r+i>>>1,n(e[s],t)<0?r=s+1:i=s;return r}function hn(e,t,n){var r=cn(e,t,n);e.splice(r,0,t)}function pn(e,t){var n,r;for(var i=t,s=e.length;i<s;i++){var o=e[i],u=[o.id,o.opts,[]];r?(r[2].push(u),r=u):n=r=u}return n}function dn(e,t){return e[0]<t[0]?-1:1}function vn(e,t){var n=[{tree1:e,tree2:t}],r=!1;while(n.length>0){var i=n.pop(),s=i.tree1,o=i.tree2;if(s[1].status||o[1].status)s[1].status=s[1].status==="available"||o[1].status==="available"?"available":"missing";for(var u=0;u<o[2].length;u++){if(!s[2][0]){r="new_leaf",s[2][0]=o[2][u];continue}var a=!1;for(var f=0;f<s[2].length;f++)s[2][f][0]===o[2][u][0]&&(n.push({tree1:s[2][f],tree2:o[2][u]}),a=!0);a||(r="new_branch",hn(s[2],o[2][u],dn))}}return{conflicts:r,tree:e}}function mn(e,t,n){var r=[],i=!1,s=!1,o;if(!e.length)return{tree:[t],conflicts:"new_leaf"};for(var u=0,a=e.length;u<a;u++){var f=e[u];if(f.pos===t.pos&&f.ids[0]===t.ids[0])o=vn(f.ids,t.ids),r.push({pos:f.pos,ids:o.tree}),i=i||o.conflicts,s=!0;else if(n!==!0){var l=f.pos<t.pos?f:t,c=f.pos<t.pos?t:f,h=c.pos-l.pos,p=[],d=[];d.push({ids:l.ids,diff:h,parent:null,parentIdx:null});while(d.length>0){var v=d.pop();if(v.diff===0){v.ids[0]===c.ids[0]&&p.push(v);continue}var m=v.ids[2];for(var g=0,y=m.length;g<y;g++)d.push({ids:m[g],diff:v.diff-1,parent:v.ids,parentIdx:g})}var b=p[0];b?(o=vn(b.ids,c.ids),b.parent[2][b.parentIdx]=o.tree,r.push({pos:l.pos,ids:l.ids}),i=i||o.conflicts,s=!0):r.push(f)}else r.push(f)}return s||r.push(t),r.sort(ln),{tree:r,conflicts:i||"internal_node"}}function gn(e,t){var n=fn(e),r,i;for(var s=0,o=n.length;s<o;s++){var u=n[s],a=u.ids,f;if(a.length>t){r||(r={});var l=a.length-t;f={pos:u.pos+l,ids:pn(a,l)};for(var c=0;c<l;c++){var h=u.pos+c+"-"+a[c].id;r[h]=!0}}else f={pos:u.pos,ids:pn(a,0)};i?i=mn(i,f,!0).tree:i=[f]}return r&&rn(i,function(e,t,n){delete r[t+"-"+n]}),{tree:i,revs:r?Object.keys(r):[]}}function yn(e,t,n){var r=mn(e,t),i=gn(r.tree,n);return{tree:i.tree,stemmedRevs:i.revs,conflicts:r.conflicts}}function bn(e,t){var n=e.slice(),r=t.split("-"),i=parseInt(r[0],10),s=r[1],o;while(o=n.pop()){if(o.pos===i&&o.ids[0]===s)return!0;var u=o.ids[2];for(var a=0,f=u.length;a<f;a++)n.push({pos:o.pos+1,ids:u[a]})}return!1}function wn(e){return e.ids}function En(e,t){t||(t=nn(e));var n=t.substring(t.indexOf("-")+1),r=e.rev_tree.map(wn),i;while(i=r.pop()){if(i[0]===n)return!!i[1].deleted;r=r.concat(i[2])}}function Sn(e){return/^_local/.test(e)}function xn(e,t){var n=t.rev_tree.slice(),r;while(r=n.pop()){var i=r.pos,s=r.ids,o=s[0],u=s[1],a=s[2],f=a.length===0,l=r.history?r.history.slice():[];l.push({id:o,pos:i,opts:u});if(f)for(var c=0,h=l.length;c<h;c++){var p=l[c],d=p.pos+"-"+p.id;if(d===e)return i+"-"+o}for(var v=0,m=a.length;v<m;v++)n.push({pos:i+1,ids:a[v],history:l})}throw new Error("Unable to resolve latest revision for id "+t.id+", rev "+e)}function Tn(e,t,n,r){try{e.emit("change",t,n,r)}catch(i){q("error",'Error in .on("change", function):',i)}}function Nn(e,t,n){function s(){r.cancel()}u.EventEmitter.call(this);var r=this;this.db=e,t=t?y(t):{};var i=t.complete=b(function(t,n){t?Tt(r,"error")>0&&r.emit("error",t):r.emit("complete",n),r.removeAllListeners(),e.removeListener("destroyed",s)});n&&(r.on("complete",function(e){n(null,e)}),r.on("error",n)),e.once("destroyed",s),t.onChange=function(e,t,n){if(r.isCancelled)return;Tn(r,e,t,n)};var o=new Promise(function(e,n){t.complete=function(t,r){t?n(t):e(r)}});r.once("cancel",function(){e.removeListener("destroyed",s),t.complete(null,{status:"cancelled"})}),this.then=o.then.bind(o),this["catch"]=o["catch"].bind(o),this.then(function(e){i(null,e)},i),e.taskqueue.isReady?r.validateChanges(t):e.taskqueue.addTask(function(e){e?t.complete(e):r.isCancelled?r.emit("cancel"):r.validateChanges(t)})}function Cn(e,t,n){var r=[{rev:e._rev}];n.style==="all_docs"&&(r=on(t.rev_tree).map(function(e){return{rev:e.rev}}));var i={id:t.id,changes:r,doc:e};return En(t,e._rev)&&(i.deleted=!0),n.conflicts&&(i.doc._conflicts=un(t),i.doc._conflicts.length||delete i.doc._conflicts),i}function kn(e,t){return e<t?-1:e>t?1:0}function Ln(e,t){return function(n,r){n||r[0]&&r[0].error?(n=n||r[0],n.docId=t,e(n)):e(null,r.length?r[0]:r)}}function An(e){for(var t=0;t<e.length;t++){var n=e[t];if(n._deleted)delete n._attachments;else if(n._attachments){var r=Object.keys(n._attachments);for(var i=0;i<r.length;i++){var s=r[i];n._attachments[s]=O(n._attachments[s],["data","digest","content_type","length","revpos","stub"])}}}}function On(e,t){var n=kn(e._id,t._id);if(n!==0)return n;var r=e._revisions?e._revisions.start:0,i=t._revisions?t._revisions.start:0;return kn(r,i)}function Mn(e){var t={},n=[];return rn(e,function(e,r,i,s){var o=r+"-"+i;return e&&(t[o]=0),s!==undefined&&n.push({from:s,to:o}),o}),n.reverse(),n.forEach(function(e){t[e.from]===undefined?t[e.from]=1+t[e.to]:t[e.from]=Math.min(t[e.from],1+t[e.to])}),t}function _n(e){var t="limit"in e?e.keys.slice(e.skip,e.limit+e.skip):e.skip>0?e.keys.slice(e.skip):e.keys;e.keys=t,e.skip=0,delete e.limit,e.descending&&(t.reverse(),e.descending=!1)}function Dn(e){var t=e._compactionQueue[0],n=t.opts,r=t.callback;e.get("_local/compaction").catch(function(){return!1}).then(function(t){t&&t.last_seq&&(n.last_seq=t.last_seq),e._compact(n,function(t,n){t?r(t):r(null,n),o(function(){e._compactionQueue.shift(),e._compactionQueue.length&&Dn(e)})})})}function Pn(e){return e.charAt(0)==="_"?e+" is not a valid attachment name, attachment "+"names cannot start with '_'":!1}function Hn(){u.EventEmitter.call(this);for(var e in Hn.prototype)typeof this[e]=="function"&&(this[e]=this[e].bind(this))}function Bn(){this.isReady=!1,this.failed=!1,this.queue=[]}function jn(e,t){var n=e.match(/([a-z-]*):\/\/(.*)/);if(n)return{name:/https?/.test(n[1])?n[1]+"://"+n[2]:n[2],adapter:n[1]};var r=In.adapters,i=In.preferredAdapters,s=In.prefix,o=t.adapter;if(!o)for(var u=0;u<i.length;++u){o=i[u];if(o==="idb"&&"websql"in r&&j()&&localStorage["_pouch__websqldb_"+s+e]){q("log",'PouchDB is downgrading "'+e+'" to WebSQL to'+" avoid data loss, because it was already opened with WebSQL.");continue}break}var a=r[o],f=a&&"use_prefix"in a?a.use_prefix:!0;return{name:f?s+e:e,adapter:o}}function Fn(e){function t(t){e.removeListener("closed",n),t||e.constructor.emit("destroyed",e.name)}function n(){e.removeListener("destroyed",t),e.constructor.emit("unref",e)}e.once("destroyed",t),e.once("closed",n),e.constructor.emit("ref",e)}function In(e,t){if(!(this instanceof In))return new In(e,t);var n=this;t=t||{},e&&typeof e=="object"&&(t=e,e=t.name,delete t.name),t.deterministic_revs===undefined&&(t.deterministic_revs=!0),this.__opts=t=y(t),n.auto_compaction=t.auto_compaction,n.prefix=In.prefix;if(typeof e!="string")throw new Error("Missing/invalid DB name");var r=(t.prefix||"")+e,i=jn(r,t);t.name=i.name,t.adapter=t.adapter||i.adapter,n.name=e,n._adapter=t.adapter,In.emit("debug",["adapter","Picked adapter: ",t.adapter]);if(!In.adapters[t.adapter]||!In.adapters[t.adapter].valid())throw new Error("Invalid Adapter: "+t.adapter);Hn.call(n),n.taskqueue=new Bn,n.adapter=t.adapter,In.adapters[t.adapter].call(n,t,function(e){if(e)return n.taskqueue.fail(e);Fn(n),n.emit("created",n),In.emit("created",n.name),n.taskqueue.ready(n)})}function Wn(e){Object.keys(u.EventEmitter.prototype).forEach(function(t){typeof u.EventEmitter.prototype[t]=="function"&&(e[t]=zn[t].bind(zn))});var t=e._destructionListeners=new A;e.on("ref",function(n){t.has(n.name)||t.set(n.name,[]),t.get(n.name).push(n)}),e.on("unref",function(n){if(!t.has(n.name))return;var r=t.get(n.name),i=r.indexOf(n);if(i<0)return;r.splice(i,1),r.length>1?t.set(n.name,r):t.delete(n.name)}),e.on("destroyed",function(n){if(!t.has(n))return;var r=t.get(n);t.delete(n),r.forEach(function(e){e.emit("destroyed",!0)})})}function Vn(e,t){var n=e;for(var r=0,i=t.length;r<i;r++){var s=t[r];n=n[s];if(!n)break}return n}function $n(e,t){return e<t?-1:e>t?1:0}function Jn(e){var t=[],n="";for(var r=0,i=e.length;r<i;r++){var s=e[r];s==="."?r>0&&e[r-1]==="\\"?n=n.substring(0,n.length-1)+".":(t.push(n),n=""):n+=s}return t.push(n),t}function Qn(e){return Kn.indexOf(e)>-1}function Gn(e){return Object.keys(e)[0]}function Yn(e){return e[Gn(e)]}function Zn(e){var t={};return e.forEach(function(e){Object.keys(e).forEach(function(n){var r=e[n];typeof r!="object"&&(r={$eq:r});if(Qn(n))r instanceof Array?t[n]=r.map(function(e){return Zn([e])}):t[n]=Zn([r]);else{var i=t[n]=t[n]||{};Object.keys(r).forEach(function(e){var t=r[e];if(e==="$gt"||e==="$gte")return er(e,t,i);if(e==="$lt"||e==="$lte")return tr(e,t,i);if(e==="$ne")return nr(t,i);if(e==="$eq")return rr(t,i);i[e]=t})}})}),t}function er(e,t,n){if(typeof n.$eq!="undefined")return;typeof n.$gte!="undefined"?e==="$gte"?t>n.$gte&&(n.$gte=t):t>=n.$gte&&(delete n.$gte,n.$gt=t):typeof n.$gt!="undefined"?e==="$gte"?t>n.$gt&&(delete n.$gt,n.$gte=t):t>n.$gt&&(n.$gt=t):n[e]=t}function tr(e,t,n){if(typeof n.$eq!="undefined")return;typeof n.$lte!="undefined"?e==="$lte"?t<n.$lte&&(n.$lte=t):t<=n.$lte&&(delete n.$lte,n.$lt=t):typeof n.$lt!="undefined"?e==="$lte"?t<n.$lt&&(delete n.$lt,n.$lte=t):t<n.$lt&&(n.$lt=t):n[e]=t}function nr(e,t){"$ne"in t?t.$ne.push(e):t.$ne=[e]}function rr(e,t){delete t.$gt,delete t.$gte,delete t.$lt,delete t.$lte,delete t.$ne,t.$eq=e}function ir(e){var t=y(e),n=!1;"$and"in t&&(t=Zn(t.$and),n=!0),["$or","$nor"].forEach(function(e){e in t&&t[e].forEach(function(e){var t=Object.keys(e);for(var n=0;n<t.length;n++){var r=t[n],i=e[r];if(typeof i!="object"||i===null)e[r]={$eq:i}}})}),"$not"in t&&(t.$not=Zn([t.$not]));var r=Object.keys(t);for(var i=0;i<r.length;i++){var s=r[i],o=t[s];typeof o!="object"||o===null?o={$eq:o}:"$ne"in o&&!n&&(o.$ne=[o.$ne]),t[s]=o}return t}function sr(e,t,n){var r="",i=n-e.length;while(r.length<i)r+=t;return r}function or(e,t,n){var r=sr(e,t,n);return r+e}function lr(e,t){if(e===t)return 0;e=cr(e),t=cr(t);var n=wr(e),r=wr(t);if(n-r!==0)return n-r;switch(typeof e){case"number":return e-t;case"boolean":return e<t?-1:1;case"string":return yr(e,t)}return Array.isArray(e)?gr(e,t):br(e,t)}function cr(e){switch(typeof e){case"undefined":return null;case"number":if(e===Infinity||e===-Infinity||isNaN(e))return null;return e;case"object":var t=e;if(Array.isArray(e)){var n=e.length;e=new Array(n);for(var r=0;r<n;r++)e[r]=cr(t[r])}else{if(e instanceof Date)return e.toJSON();if(e!==null){e={};for(var i in t)if(t.hasOwnProperty(i)){var s=t[i];typeof s!="undefined"&&(e[i]=cr(s))}}}}return e}function hr(e){if(e!==null)switch(typeof e){case"boolean":return e?1:0;case"number":return Er(e);case"string":return e.replace(/\u0002/g,"").replace(/\u0001/g,"").replace(/\u0000/g,"");case"object":var t=Array.isArray(e),n=t?e:Object.keys(e),r=-1,i=n.length,s="";if(t)while(++r<i)s+=pr(n[r]);else while(++r<i){var o=n[r];s+=pr(o)+pr(e[o])}return s}return""}function pr(e){var t="\0";return e=cr(e),wr(e)+fr+hr(e)+t}function dr(e,t){var n=t,r,i=e[t]==="1";if(i)r=0,t++;else{var s=e[t]==="0";t++;var o="",u=e.substring(t,t+ar),a=parseInt(u,10)+ur;s&&(a=-a),t+=ar;for(;;){var f=e[t];if(f==="\0")break;o+=f,t++}o=o.split("."),o.length===1?r=parseInt(o,10):r=parseFloat(o[0]+"."+o[1]),s&&(r-=10),a!==0&&(r=parseFloat(r+"e"+a))}return{num:r,length:t-n}}function vr(e,t){var n=e.pop();if(t.length){var r=t[t.length-1];n===r.element&&(t.pop(),r=t[t.length-1]);var i=r.element,s=r.index;if(Array.isArray(i))i.push(n);else if(s===e.length-2){var o=e.pop();i[o]=n}else e.push(n)}}function mr(e){var t=[],n=[],r=0;for(;;){var i=e[r++];if(i==="\0"){if(t.length===1)return t.pop();vr(t,n);continue}switch(i){case"1":t.push(null);break;case"2":t.push(e[r]==="1"),r++;break;case"3":var s=dr(e,r);t.push(s.num),r+=s.length;break;case"4":var o="";for(;;){var u=e[r];if(u==="\0")break;o+=u,r++}o=o.replace(/\u0001\u0001/g,"\0").replace(/\u0001\u0002/g,"").replace(/\u0002\u0002/g,""),t.push(o);break;case"5":var a={element:[],index:t.length};t.push(a.element),n.push(a);break;case"6":var f={element:{},index:t.length};t.push(f.element),n.push(f);break;default:throw new Error("bad collationIndex or unexpectedly reached end of input: "+i)}}}function gr(e,t){var n=Math.min(e.length,t.length);for(var r=0;r<n;r++){var i=lr(e[r],t[r]);if(i!==0)return i}return e.length===t.length?0:e.length>t.length?1:-1}function yr(e,t){return e===t?0:e>t?1:-1}function br(e,t){var n=Object.keys(e),r=Object.keys(t),i=Math.min(n.length,r.length);for(var s=0;s<i;s++){var o=lr(n[s],r[s]);if(o!==0)return o;o=lr(e[n[s]],t[r[s]]);if(o!==0)return o}return n.length===r.length?0:n.length>r.length?1:-1}function wr(e){var t=["boolean","number","string","object"],n=t.indexOf(typeof e);if(~n)return e===null?1:Array.isArray(e)?5:n<3?n+2:n+3;if(Array.isArray(e))return 5}function Er(e){if(e===0)return"1";var t=e.toExponential().split(/e\+?/),n=parseInt(t[1],10),r=e<0,i=r?"0":"2",s=(r?-n:n)-ur,o=or(s.toString(),"0",ar);i+=fr+o;var u=Math.abs(parseFloat(t[0]));r&&(u=10-u);var a=u.toFixed(20);return a=a.replace(/\.?0+$/,""),i+=fr+a,i}function Sr(e){function t(t){return e.map(function(e){var n=Gn(e),r=Jn(n),i=Vn(t,r);return i})}return function(e,n){var r=t(e.doc),i=t(n.doc),s=lr(r,i);return s!==0?s:$n(e.doc._id,n.doc._id)}}function xr(e,t,n){e=e.filter(function(e){return Tr(e.doc,t.selector,n)});if(t.sort){var r=Sr(t.sort);e=e.sort(r),typeof t.sort[0]!="string"&&Yn(t.sort[0])==="desc"&&(e=e.reverse())}if("limit"in t||"skip"in t){var i=t.skip||0,s=("limit"in t?t.limit:e.length)+i;e=e.slice(i,s)}return e}function Tr(e,t,n){return n.every(function(n){var r=t[n],i=Jn(n),s=Vn(e,i);return Qn(n)?Cr(n,r,e):Nr(r,e,i,s)})}function Nr(e,t,n,r){return e?Object.keys(e).every(function(i){var s=e[i];return kr(i,t,s,n,r)}):!0}function Cr(e,t,n){return e==="$or"?t.some(function(e){return Tr(n,e,Object.keys(e))}):e==="$not"?!Tr(n,t,Object.keys(t)):!t.find(function(e){return Tr(n,e,Object.keys(e))})}function kr(e,t,n,r,i){if(!Br[e])throw new Error('unknown operator "'+e+'" - should be one of $eq, $lte, $lt, $gt, $gte, $exists, $ne, $in, '+"$nin, $size, $mod, $regex, $elemMatch, $type, $allMatch or $all");return Br[e](t,n,r,i)}function Lr(e){return typeof e!="undefined"&&e!==null}function Ar(e){return typeof e!="undefined"}function Or(e,t){var n=t[0],r=t[1];if(n===0)throw new Error("Bad divisor, cannot divide by zero");if(parseInt(n,10)!==n)throw new Error("Divisor is not an integer");if(parseInt(r,10)!==r)throw new Error("Modulus is not an integer");return parseInt(e,10)!==e?!1:e%n===r}function Mr(e,t){return t.some(function(t){return e instanceof Array?e.indexOf(t)>-1:e===t})}function _r(e,t){return t.every(function(t){return e.indexOf(t)>-1})}function Dr(e,t){return e.length===t}function Pr(e,t){var n=new RegExp(t);return n.test(e)}function Hr(e,t){switch(t){case"null":return e===null;case"boolean":return typeof e=="boolean";case"number":return typeof e=="number";case"string":return typeof e=="string";case"array":return e instanceof Array;case"object":return{}.toString.call(e)==="[object Object]"}throw new Error(t+" not supported as a type."+"Please use one of object, string, array, number, boolean or null.")}function jr(e,t){if(typeof t!="object")throw new Error("Selector error: expected a JSON object");t=ir(t);var n={doc:e},r=xr([n],{selector:t},Object.keys(t));return r&&r.length===1}function Fr(e){return _t('"use strict";\nreturn '+e+";",{})}function Ir(e){var t=["return function(doc) {",'  "use strict";',"  var emitted = false;","  var emit = function (a, b) {","    emitted = true;","  };","  var view = "+e+";","  view(doc);","  if (emitted) {","    return true;","  }","};"].join("\n");return _t(t,{})}function qr(e,t){if(e.selector&&e.filter&&e.filter!=="_selector"){var n=typeof e.filter=="string"?e.filter:"function";return t(new Error('selector invalid for filter "'+n+'"'))}t()}function Rr(e){e.view&&!e.filter&&(e.filter="_view"),e.selector&&!e.filter&&(e.filter="_selector"),e.filter&&typeof e.filter=="string"&&(e.filter==="_view"?e.view=Ct(e.view):e.filter=Ct(e.filter))}function Ur(e,t){return t.filter&&typeof t.filter=="string"&&!t.doc_ids&&!xt(e.db)}function zr(e,t){var n=t.complete;if(t.filter==="_view"){if(!t.view||typeof t.view!="string"){var r=gt(ot,"`view` filter parameter not found or invalid.");return n(r)}var i=Nt(t.view);e.db.get("_design/"+i[0],function(r,s){if(e.isCancelled)return n(null,{status:"cancelled"});if(r)return n(yt(r));var o=s&&s.views&&s.views[i[1]]&&s.views[i[1]].map;if(!o)return n(gt(K,s.views?"missing json key: "+i[1]:"missing json key: views"));t.filter=Ir(o),e.doChanges(t)})}else if(t.selector)t.filter=function(e){return jr(e,t.selector)},e.doChanges(t);else{var s=Nt(t.filter);e.db.get("_design/"+s[0],function(r,i){if(e.isCancelled)return n(null,{status:"cancelled"});if(r)return n(yt(r));var o=i&&i.filters&&i.filters[s[1]];if(!o)return n(gt(K,i&&i.filters?"missing json key: "+s[1]:"missing json key: filters"));t.filter=Fr(o),e.doChanges(t)})}}function Wr(e){e._changesFilterPlugin={validate:qr,normalize:Rr,shouldFilter:Ur,filter:zr}}function Xr(e){return e.reduce(function(e,t){return e[t]=!0,e},{})}function Jr(e){if(!/^\d+-./.test(e))return gt(pt);var t=e.indexOf("-"),n=e.substring(0,t),r=e.substring(t+1);return{prefix:parseInt(n,10),id:r}}function Kr(e,t){var n=e.start-e.ids.length+1,r=e.ids,i=[r[0],t,[]];for(var s=1,o=r.length;s<o;s++)i=[r[s],{status:"missing"},[i]];return[{pos:n,ids:i}]}function Qr(e,t,n){n||(n={deterministic_revs:!0});var r,i,s,o={status:"available"};e._deleted&&(o.deleted=!0);if(t){e._id||(e._id=tn()),i=en(e,n.deterministic_revs);if(e._rev){s=Jr(e._rev);if(s.error)return s;e._rev_tree=[{pos:s.prefix,ids:[s.id,{status:"missing"},[[i,o,[]]]]}],r=s.prefix+1}else e._rev_tree=[{pos:1,ids:[i,o,[]]}],r=1}else{e._revisions&&(e._rev_tree=Kr(e._revisions,o),r=e._revisions.start,i=e._revisions.ids[0]);if(!e._rev_tree){s=Jr(e._rev);if(s.error)return s;r=s.prefix,i=s.id,e._rev_tree=[{pos:r,ids:[i,o,[]]}]}}St(e._id),e._rev=r+"-"+i;var u={metadata:{},data:{}};for(var a in e)if(Object.prototype.hasOwnProperty.call(e,a)){var f=a[0]==="_";if(f&&!Vr[a]){var l=gt(st,a);throw l.message=st.message+": "+a,l}f&&!$r[a]?u.metadata[a.slice(1)]=e[a]:u.data[a]=e[a]}return u}function Gr(e){try{return Ht(e)}catch(t){var n=gt(nt,"Attachment is not a valid base64 string");return{error:n}}}function Yr(e,t,n){var r=Gr(e.data);if(r.error)return n(r.error);e.length=r.length,t==="blob"?e.data=It(r,e.content_type):t==="base64"?e.data=Bt(r):e.data=r,Yt(r,function(t){e.digest="md5-"+t,n()})}function Zr(e,t,n){Yt(e.data,function(r){e.digest="md5-"+r,e.length=e.data.size||e.data.length||0,t==="binary"?zt(e.data,function(t){e.data=t,n()}):t==="base64"?Wt(e.data,function(t){e.data=t,n()}):n()})}function ei(e,t,n){if(e.stub)return n();typeof e.data=="string"?Yr(e,t,n):Zr(e,t,n)}function ti(e,t,n){function s(){r++,e.length===r&&(i?n(i):n())}if(!e.length)return n();var r=0,i;e.forEach(function(e){function o(e){i=e,r++,r===n.length&&s()}var n=e.data&&e.data._attachments?Object.keys(e.data._attachments):[],r=0;if(!n.length)return s();for(var u in e.data._attachments)e.data._attachments.hasOwnProperty(u)&&ei(e.data._attachments[u],t,o)})}function ni(e,t,n,r,i,s,o,u){if(bn(t.rev_tree,n.metadata.rev)&&!u)return r[i]=n,s();var a=t.winningRev||nn(t),f="deleted"in t?t.deleted:En(t,a),l="deleted"in n.metadata?n.metadata.deleted:En(n.metadata),c=/^1-/.test(n.metadata.rev);if(f&&!l&&u&&c){var h=n.data;h._rev=a,h._id=n.metadata.id,n=Qr(h,u)}var p=yn(t.rev_tree,n.metadata.rev_tree[0],e),d=u&&(f&&l&&p.conflicts!=="new_leaf"||!f&&p.conflicts!=="new_leaf"||f&&!l&&p.conflicts==="new_branch");if(d){var v=gt(Q);return r[i]=v,s()}var m=n.metadata.rev;n.metadata.rev_tree=p.tree,n.stemmedRevs=p.stemmedRevs||[],t.rev_map&&(n.metadata.rev_map=t.rev_map);var g=nn(n.metadata),y=En(n.metadata,g),b=f===y?0:f<y?-1:1,w;m===g?w=y:w=En(n.metadata,m),o(n,g,y,w,!0,b,i,s)}function ri(e){return e.metadata.rev_tree[0].ids[1].status==="missing"}function ii(e,t,n,r,i,s,o,u,a){function f(e,t,n){var r=nn(e.metadata),i=En(e.metadata,r);if("was_delete"in u&&i)return s[t]=gt(K,"deleted"),n();var a=l&&ri(e);if(a){var f=gt(Q);return s[t]=f,n()}var c=i?0:1;o(e,r,i,i,!1,c,t,n)}function d(){++h===p&&a&&a()}e=e||1e3;var l=u.new_edits,c=new A,h=0,p=t.length;t.forEach(function(e,t){if(e._id&&Sn(e._id)){var r=e._deleted?"_removeLocal":"_putLocal";n[r](e,{ctx:i},function(e,n){s[t]=e||n,d()});return}var o=e.metadata.id;c.has(o)?(p--,c.get(o).push([e,t])):c.set(o,[[e,t]])}),c.forEach(function(t,n){function u(){++i<t.length?a():d()}function a(){var a=t[i],c=a[0],h=a[1];if(r.has(n))ni(e,r.get(n),c,s,h,u,o,l);else{var p=yn([],c.metadata.rev_tree[0],e);c.metadata.rev_tree=p.tree,c.stemmedRevs=p.stemmedRevs||[],f(c,h,u)}}var i=0;a()})}function pi(e){try{return JSON.parse(e)}catch(t){return c.parse(e)}}function di(e){try{return JSON.stringify(e)}catch(t){return c.stringify(e)}}function vi(e){return function(t){var n="unknown_error";t.target&&t.target.error&&(n=t.target.error.name||t.target.error.message),e(gt(ft,n,t.type))}}function mi(e,t,n){return{data:di(e),winningRev:t,deletedOrLocal:n?"1":"0",seq:e.seq,id:e.id}}function gi(e){if(!e)return null;var t=pi(e.data);return t.winningRev=e.winningRev,t.deleted=e.deletedOrLocal==="1",t.seq=e.seq,t}function yi(e){if(!e)return e;var t=e._doc_id_rev.lastIndexOf(":");return e._id=e._doc_id_rev.substring(0,t-1),e._rev=e._doc_id_rev.substring(t+1),delete e._doc_id_rev,e}function bi(e,t,n,r){n?e?typeof e!="string"?r(e):r(qt(e,t)):r(jt([""],{type:t})):e?typeof e!="string"?Ut(e,function(e){r(Bt(e))}):r(e):r("")}function wi(e,t,n,r){function o(){++s===i.length&&r&&r()}function u(e,t){var r=e._attachments[t],i=r.digest,s=n.objectStore(ai).get(i);s.onsuccess=function(e){r.body=e.target.result.body,o()}}var i=Object.keys(e._attachments||{});if(!i.length)return r&&r();var s=0;i.forEach(function(n){t.attachments&&t.include_docs?u(e,n):(e._attachments[n].stub=!0,o())})}function Ei(e,t){return Promise.all(e.map(function(e){if(e.doc&&e.doc._attachments){var n=Object.keys(e.doc._attachments);return Promise.all(n.map(function(n){var r=e.doc._attachments[n];if("body"in r){var i=r.body,s=r.content_type;return new Promise(function(o){bi(i,s,t,function(t){e.doc._attachments[n]=X(O(r,["digest","content_type"]),{data:t}),o()})})}return}))}}))}function Si(e,t,n){function a(){u--,u||f()}function f(){if(!r.length)return;r.forEach(function(e){var t=o.index("digestSeq").count(IDBKeyRange.bound(e+"::",e+"::￿",!1,!1));t.onsuccess=function(t){var n=t.target.result;n||s.delete(e)}})}var r=[],i=n.objectStore(ui),s=n.objectStore(ai),o=n.objectStore(fi),u=e.length;e.forEach(function(e){var n=i.index("_doc_id_rev"),s=t+"::"+e;n.getKey(s).onsuccess=function(e){var t=e.target.result;if(typeof t!="number")return a();i.delete(t);var n=o.index("seq").openCursor(IDBKeyRange.only(t));n.onsuccess=function(e){var t=e.target.result;if(t){var n=t.value.digestSeq.split("::")[0];r.push(n),o.delete(t.primaryKey),t.continue()}else a()}}})}function xi(e,t,n){try{return{txn:e.transaction(t,n)}}catch(r){return{error:r}}}function Ni(e,t,n,r,i,s){function T(){var e=[oi,ui,ai,ci,fi,li],t=xi(i,e,"readwrite");if(t.error)return s(t.error);u=t.txn,u.onabort=vi(s),u.ontimeout=vi(s),u.oncomplete=O,a=u.objectStore(oi),f=u.objectStore(ui),l=u.objectStore(ai),c=u.objectStore(fi),h=u.objectStore(li),h.get(li).onsuccess=function(e){d=e.target.result,k()},_(function(e){if(e)return S=!0,s(e);L()})}function N(){y=!0,k()}function C(){ii(e.revs_limit,o,r,E,u,w,D,n,N)}function k(){if(!d||!y)return;d.docCount+=b,h.put(d)}function L(){function t(){++e===o.length&&C()}function n(e){var n=gi(e.target.result);n&&E.set(n.id,n),t()}if(!o.length)return;var e=0;for(var r=0,i=o.length;r<i;r++){var s=o[r];if(s._id&&Sn(s._id)){t();continue}var u=a.get(s.metadata.id);u.onsuccess=n}}function O(){if(S)return;Ti.notify(r._meta.name),s(null,w)}function M(e,t){var n=l.get(e);n.onsuccess=function(n){if(!n.target.result){var r=gt(vt,"unknown stub attachment with digest "+e);r.status=412,t(r)}else t()}}function _(e){function i(){++n===t.length&&e(r)}var t=[];o.forEach(function(e){e.data&&e.data._attachments&&Object.keys(e.data._attachments).forEach(function(n){var r=e.data._attachments[n];r.stub&&t.push(r.digest)})});if(!t.length)return e();var n=0,r;t.forEach(function(e){M(e,function(e){e&&!r&&(r=e),i()})})}function D(e,t,n,r,i,s,o,u){e.metadata.winningRev=t,e.metadata.deleted=n;var a=e.data;a._id=e.metadata.id,a._rev=e.metadata.rev,r&&(a._deleted=!0);var f=a._attachments&&Object.keys(a._attachments).length;if(f)return H(e,t,n,i,o,u);b+=s,k(),P(e,t,n,i,o,u)}function P(e,t,n,i,s,o){function h(s){var o=e.stemmedRevs||[];i&&r.auto_compaction&&(o=o.concat(an(e.metadata))),o&&o.length&&Si(o,e.metadata.id,u),c.seq=s.target.result;var f=mi(c,t,n),l=a.put(f);l.onsuccess=d}function p(e){e.preventDefault(),e.stopPropagation();var t=f.index("_doc_id_rev"),n=t.getKey(l._doc_id_rev);n.onsuccess=function(e){var t=f.put(l,e.target.result);t.onsuccess=h}}function d(){w[s]={ok:!0,id:c.id,rev:c.rev},E.set(e.metadata.id,e.metadata),B(e,c.seq,o)}var l=e.data,c=e.metadata;l._doc_id_rev=c.id+"::"+c.rev,delete l._id,delete l._rev;var v=f.put(l);v.onsuccess=h,v.onerror=p}function H(e,t,n,r,i,s){function f(){u===a.length&&P(e,t,n,r,i,s)}function l(){u++,f()}var o=e.data,u=0,a=Object.keys(o._attachments);a.forEach(function(n){var r=e.data._attachments[n];if(!r.stub){var i=r.data;delete r.data,r.revpos=parseInt(t,10);var s=r.digest;j(s,i,l)}else u++,f()})}function B(e,t,n){function s(){++r===i.length&&n()}function o(n){var r=e.data._attachments[n].digest,i=c.put({seq:t,digestSeq:r+"::"+t});i.onsuccess=s,i.onerror=function(e){e.preventDefault(),e.stopPropagation(),s()}}var r=0,i=Object.keys(e.data._attachments||{});if(!i.length)return n();for(var u=0;u<i.length;u++)o(i[u])}function j(e,t,n){var r=l.count(e);r.onsuccess=function(r){var i=r.target.result;if(i)return n();var s={digest:e,body:t},o=l.put(s);o.onsuccess=n}}var o=t.docs,u,a,f,l,c,h,p,d;for(var v=0,m=o.length;v<m;v++){var g=o[v];if(g._id&&Sn(g._id))continue;g=o[v]=Qr(g,n.new_edits,e),g.error&&!p&&(p=g)}if(p)return s(p);var y=!1,b=0,w=new Array(o.length),E=new A,S=!1,x=r._meta.blobSupport?"blob":"base64";ti(o,x,function(e){if(e)return s(e);T()})}function Ci(e,t,n,r,i){function f(e){u=e.target.result,o&&i(o,u,a)}function l(e){o=e.target.result,u&&i(o,u,a)}function c(){if(!o.length)return i();var n=o[o.length-1],s;if(t&&t.upper)try{s=IDBKeyRange.bound(n,t.upper,!0,t.upperOpen)}catch(a){if(a.name==="DataError"&&a.code===0)return i()}else s=IDBKeyRange.lowerBound(n,!0);t=s,o=null,u=null,e.getAll(t,r).onsuccess=f,e.getAllKeys(t,r).onsuccess=l}function h(e){var t=e.target.result;if(!t)return i();i([t.key],[t.value],t)}r===-1&&(r=1e3);var s=typeof e.getAll=="function"&&typeof e.getAllKeys=="function"&&r>1&&!n,o,u,a;s?(a={"continue":c},e.getAll(t,r).onsuccess=f,e.getAllKeys(t,r).onsuccess=l):n?e.openCursor(t,"prev").onsuccess=h:e.openCursor(t).onsuccess=h}function ki(e,t,n){function i(e){var t=e.target.result;t?(r.push(t.value),t.continue()):n({target:{result:r}})}if(typeof e.getAll=="function"){e.getAll(t).onsuccess=n;return}var r=[];e.openCursor(t).onsuccess=i}function Li(e,t,n){var r=new Array(e.length),i=0;e.forEach(function(s,o){t.get(s).onsuccess=function(t){t.target.result?r[o]=t.target.result:r[o]={key:s,error:"not_found"},i++,i===e.length&&n(e,r,{})}})}function Ai(e,t,n,r,i){try{if(e&&t)return i?IDBKeyRange.bound(t,e,!n,!1):IDBKeyRange.bound(e,t,!1,!n);if(e)return i?IDBKeyRange.upperBound(e):IDBKeyRange.lowerBound(e);if(t)return i?IDBKeyRange.lowerBound(t,!n):IDBKeyRange.upperBound(t,!n);if(r)return IDBKeyRange.only(r)}catch(s){return{error:s}}return null}function Oi(e,t,n){function S(e,t){function n(e){var n=e.target.result,r=undefined;return n&&n.key&&(r=n.key),t({target:{result:[r]}})}e.openCursor(null,"prev").onsuccess=n}function x(t,n,r){var i=t.id+"::"+r;y.get(i).onsuccess=function(i){n.doc=yi(i.target.result)||{};if(e.conflicts){var s=un(t);s.length&&(n.doc._conflicts=s)}wi(n.doc,e,d)}}function T(t,n){var r={id:n.id,key:n.id,value:{rev:t}},i=n.deleted;i?o&&(b.push(r),r.value.deleted=!0,r.doc=null):u--<=0&&(b.push(r),e.include_docs&&x(n,r,t))}function N(e){for(var t=0,n=e.length;t<n;t++){if(b.length===a)break;var r=e[t];if(r.error&&o){b.push(r);continue}var i=gi(r),s=i.winningRev;T(s,i)}}function C(e,t,n){if(!n)return;N(t),b.length<a&&n.continue()}function k(t){var n=t.target.result;e.descending&&(n=n.reverse()),N(n)}function L(){var t={total_rows:w,offset:e.skip,rows:b};e.update_seq&&E!==undefined&&(t.update_seq=E),n(null,t)}function A(){e.attachments?Ei(b,e.binary).then(L):L()}var r="startkey"in e?e.startkey:!1,i="endkey"in e?e.endkey:!1,s="key"in e?e.key:!1,o="keys"in e?e.keys:!1,u=e.skip||0,a=typeof e.limit=="number"?e.limit:-1,f=e.inclusive_end!==!1,l,c;if(!o){l=Ai(r,i,f,s,e.descending),c=l&&l.error;if(c&&(c.name!=="DataError"||c.code!==0))return n(gt(ft,c.name,c.message))}var h=[oi,ui,li];e.attachments&&h.push(ai);var p=xi(t,h,"readonly");if(p.error)return n(p.error);var d=p.txn;d.oncomplete=A,d.onabort=vi(n);var v=d.objectStore(oi),m=d.objectStore(ui),g=d.objectStore(li),y=m.index("_doc_id_rev"),b=[],w,E;g.get(li).onsuccess=function(e){w=e.target.result.docCount},e.update_seq&&S(m,function(e){e.target.result&&e.target.result.length>0&&(E=e.target.result[0])});if(c||a===0)return;if(o)return Li(e.keys,v,C);if(a===-1)return ki(v,l,k);Ci(v,l,e.descending,a+u,C)}function Mi(e){return(new Promise(function(t){var n=jt([""]),r=e.objectStore(hi).put(n,"key");r.onsuccess=function(){var e=navigator.userAgent.match(/Chrome\/(\d+)/),n=navigator.userAgent.match(/Edge\//);t(n||!e||parseInt(e[1],10)>=43)},r.onerror=e.onabort=function(e){e.preventDefault(),e.stopPropagation(),t(!1)}})).catch(function(){return!1})}function _i(e,t){var n=e.objectStore(oi).index("deletedOrLocal");n.count(IDBKeyRange.only("0")).onsuccess=function(e){t(e.target.result)}}function Hi(e,t,n,r){try{e(t,n)}catch(t){r.emit("error",t)}}function Bi(){if(Di||!Pi.length)return;Di=!0,Pi.shift()()}function ji(e,t,n){Pi.push(function(){e(function(r,i){Hi(t,r,i,n),Di=!1,o(function(){Bi(n)})})}),Bi()}function Fi(e,t,n,r){function m(t,n,r){function c(t,n){var r=e.processChange(n,t,e);o=r.seq=t.seq;var i=l(r);return typeof i=="object"?Promise.reject(i):i?(f++,e.return_docs&&a.push(r),e.attachments&&e.include_docs?new Promise(function(t){wi(n,e,h,function(){Ei([r],e.binary).then(function(){t(r)})})}):Promise.resolve(r)):Promise.resolve()}function p(){var t=[];for(var n=0,o=i.length;n<o;n++){if(f===u)break;var a=i[n];if(!a)continue;var l=s[n];t.push(c(l,a))}Promise.all(t).then(function(t){for(var n=0,r=t.length;n<r;n++)t[n]&&e.onChange(t[n])}).catch(e.complete),f!==u&&r.continue()}if(!r||!t.length)return;var i=new Array(t.length),s=new Array(t.length),d=0;n.forEach(function(e,n){var r=yi(e),o=t[n];b(r,o,function(e,r){s[n]=e,i[n]=r,++d===t.length&&p()})})}function g(e,t,n,r){if(n.seq!==t)return r();if(n.winningRev===e._rev)return r(n,e);var i=e._id+"::"+n.winningRev,s=v.get(i);s.onsuccess=function(e){r(n,yi(e.target.result))}}function b(e,t,n){if(s&&!s.has(e._id))return n();var r=c.get(e._id);if(r)return g(e,t,r,n);d.get(e._id).onsuccess=function(i){r=gi(i.target.result),c.set(e._id,r),g(e,t,r,n)}}function w(){e.complete(null,{results:a,last_seq:o})}function E(){!e.continuous&&e.attachments?Ei(a).then(w):w()}e=y(e);if(e.continuous){var i=n+":"+tn();return Ti.addListener(n,i,t,e),Ti.notify(n),{cancel:function(){Ti.removeListener(n,i)}}}var s=e.doc_ids&&new L(e.doc_ids);e.since=e.since||0;var o=e.since,u="limit"in e?e.limit:-1;u===0&&(u=1);var a=[],f=0,l=wt(e),c=new A,h,p,d,v,S=[oi,ui];e.attachments&&S.push(ai);var x=xi(r,S,"readonly");if(x.error)return e.complete(x.error);h=x.txn,h.onabort=vi(e.complete),h.oncomplete=E,p=h.objectStore(ui),d=h.objectStore(oi),v=p.index("_doc_id_rev");var T=e.since&&!e.descending?IDBKeyRange.lowerBound(e.since,!0):null;Ci(p,T,e.descending,u,m)}function Ui(e,t){var n=this;ji(function(t){zi(n,e,t)},t,n.constructor)}function zi(e,t,n){function s(e){var t=e.createObjectStore(oi,{keyPath:"id"});e.createObjectStore(ui,{autoIncrement:!0}).createIndex("_doc_id_rev","_doc_id_rev",{unique:!0}),e.createObjectStore(ai,{keyPath:"digest"}),e.createObjectStore(li,{keyPath:"id",autoIncrement:!1}),e.createObjectStore(hi),t.createIndex("deletedOrLocal","deletedOrLocal",{unique:!1}),e.createObjectStore(ci,{keyPath:"_id"});var n=e.createObjectStore(fi,{autoIncrement:!0});n.createIndex("seq","seq"),n.createIndex("digestSeq","digestSeq",{unique:!0})}function u(e,t){var n=e.objectStore(oi);n.createIndex("deletedOrLocal","deletedOrLocal",{unique:!1}),n.openCursor().onsuccess=function(e){var r=e.target.result;if(r){var i=r.value,s=En(i);i.deletedOrLocal=s?"1":"0",n.put(i),r.continue()}else t()}}function a(e){e.createObjectStore(ci,{keyPath:"_id"}).createIndex("_doc_id_rev","_doc_id_rev",{unique:!0})}function f(e,t){var n=e.objectStore(ci),r=e.objectStore(oi),i=e.objectStore(ui),s=r.openCursor();s.onsuccess=function(e){var s=e.target.result;if(s){var o=s.value,u=o.id,a=Sn(u),f=nn(o);if(a){var l=u+"::"+f,c=u+"::",h=u+"::~",p=i.index("_doc_id_rev"),d=IDBKeyRange.bound(c,h,!1,!1),v=p.openCursor(d);v.onsuccess=function(e){v=e.target.result;if(!v)r.delete(s.primaryKey),s.continue();else{var t=v.value;t._doc_id_rev===l&&n.put(t),i.delete(v.primaryKey),v.continue()}}}else s.continue()}else t&&t()}}function l(e){var t=e.createObjectStore(fi,{autoIncrement:!0});t.createIndex("seq","seq"),t.createIndex("digestSeq","digestSeq",{unique:!0})}function c(e,t){var n=e.objectStore(ui),r=e.objectStore(ai),i=e.objectStore(fi),s=r.count();s.onsuccess=function(e){var r=e.target.result;if(!r)return t();n.openCursor().onsuccess=function(e){var n=e.target.result;if(!n)return t();var r=n.value,s=n.primaryKey,o=Object.keys(r._attachments||{}),u={};for(var a=0;a<o.length;a++){var f=r._attachments[o[a]];u[f.digest]=!0}var l=Object.keys(u);for(a=0;a<l.length;a++){var c=l[a];i.put({seq:s,digestSeq:c+"::"+s})}n.continue()}}}function h(e){function t(e){return e.data?gi(e):(e.deleted=e.deletedOrLocal==="1",e)}var n=e.objectStore(ui),r=e.objectStore(oi),i=r.openCursor();i.onsuccess=function(e){function o(){var e=s.id+"::",t=s.id+"::￿",r=n.index("_doc_id_rev").openCursor(IDBKeyRange.bound(e,t)),i=0;r.onsuccess=function(e){var t=e.target.result;if(!t)return s.seq=i,u();var n=t.primaryKey;n>i&&(i=n),t.continue()}}function u(){var e=mi(s,s.winningRev,s.deleted),t=r.put(e);t.onsuccess=function(){i.continue()}}var i=e.target.result;if(!i)return;var s=t(i.value);s.winningRev=s.winningRev||nn(s);if(s.seq)return u();o()}}var r=t.name,i=null;e._meta=null,e._remote=!1,e.type=function(){return"idb"},e._id=w(function(t){t(null,e._meta.instanceId)}),e._bulkDocs=function(r,s,o){Ni(t,r,s,e,i,o)},e._get=function(t,n,r){function l(){r(u,{doc:s,metadata:o,ctx:a})}var s,o,u,a=n.ctx;if(!a){var f=xi(i,[oi,ui,ai],"readonly");if(f.error)return r(f.error);a=f.txn}a.objectStore(oi).get(t).onsuccess=function(e){o=gi(e.target.result);if(!o)return u=gt(K,"missing"),l();var t;if(!n.rev){t=o.winningRev;var r=En(o);if(r)return u=gt(K,"deleted"),l()}else t=n.latest?xn(n.rev,o):n.rev;var i=a.objectStore(ui),f=o.id+"::"+t;i.index("_doc_id_rev").get(f).onsuccess=function(e){s=e.target.result,s&&(s=yi(s));if(!s)return u=gt(K,"missing"),l();l()}}},e._getAttachment=function(e,t,n,r,s){var o;if(r.ctx)o=r.ctx;else{var u=xi(i,[oi,ui,ai],"readonly");if(u.error)return s(u.error);o=u.txn}var a=n.digest,f=n.content_type;o.objectStore(ai).get(a).onsuccess=function(e){var t=e.target.result.body;bi(t,f,r.binary,function(e){s(null,e)})}},e._info=function(n){var r,s,o=xi(i,[li,ui],"readonly");if(o.error)return n(o.error);var u=o.txn;u.objectStore(li).get(li).onsuccess=function(e){s=e.target.result.docCount},u.objectStore(ui).openCursor(null,"prev").onsuccess=function(e){var t=e.target.result;r=t?t.key:0},u.oncomplete=function(){n(null,{doc_count:s,update_seq:r,idb_attachment_format:e._meta.blobSupport?"binary":"base64"})}},e._allDocs=function(t,n){Oi(t,i,n)},e._changes=function(n){return Fi(n,e,r,i)},e._close=function(e){i.close(),Ii.delete(r),e()},e._getRevisionTree=function(e,t){var n=xi(i,[oi],"readonly");if(n.error)return t(n.error);var r=n.txn,s=r.objectStore(oi).get(e);s.onsuccess=function(e){var n=gi(e.target.result);n?t(null,n.rev_tree):t(gt(K))}},e._doCompaction=function(e,t,n){var r=[oi,ui,ai,fi],s=xi(i,r,"readwrite");if(s.error)return n(s.error);var o=s.txn,u=o.objectStore(oi);u.get(e).onsuccess=function(n){var r=gi(n.target.result);rn(r.rev_tree,function(e,n,r,i,s){var o=n+"-"+r;t.indexOf(o)!==-1&&(s.status="missing")}),Si(t,e,o);var i=r.winningRev,s=r.deleted;o.objectStore(oi).put(mi(r,i,s))},o.onabort=vi(n),o.oncomplete=function(){n()}},e._getLocal=function(e,t){var n=xi(i,[ci],"readonly");if(n.error)return t(n.error);var r=n.txn,s=r.objectStore(ci).get(e);s.onerror=vi(t),s.onsuccess=function(e){var n=e.target.result;n?(delete n._doc_id_rev,t(null,n)):t(gt(K))}},e._putLocal=function(e,t,n){typeof t=="function"&&(n=t,t={}),delete e._revisions;var r=e._rev,s=e._id;r?e._rev="0-"+(parseInt(r.split("-")[1],10)+1):e._rev="0-1";var o=t.ctx,u;if(!o){var a=xi(i,[ci],"readwrite");if(a.error)return n(a.error);o=a.txn,o.onerror=vi(n),o.oncomplete=function(){u&&n(null,u)}}var f=o.objectStore(ci),l;r?(l=f.get(s),l.onsuccess=function(i){var s=i.target.result;if(!s||s._rev!==r)n(gt(Q));else{var o=f.put(e);o.onsuccess=function(){u={ok:!0,id:e._id,rev:e._rev},t.ctx&&n(null,u)}}}):(l=f.add(e),l.onerror=function(e){n(gt(Q)),e.preventDefault(),e.stopPropagation()},l.onsuccess=function(){u={ok:!0,id:e._id,rev:e._rev},t.ctx&&n(null,u)})},e._removeLocal=function(e,t,n){typeof t=="function"&&(n=t,t={});var r=t.ctx;if(!r){var s=xi(i,[ci],"readwrite");if(s.error)return n(s.error);r=s.txn,r.oncomplete=function(){o&&n(null,o)}}var o,u=e._id,a=r.objectStore(ci),f=a.get(u);f.onerror=vi(n),f.onsuccess=function(r){var i=r.target.result;!i||i._rev!==e._rev?n(gt(K)):(a.delete(u),o={ok:!0,id:u,rev:"0-0"},t.ctx&&n(null,o))}},e._destroy=function(e,t){Ti.removeAllListeners(r);var n=Ri.get(r);n&&n.result&&(n.result.close(),Ii.delete(r));var i=indexedDB.deleteDatabase(r);i.onsuccess=function(){Ri.delete(r),j()&&r in localStorage&&delete localStorage[r],t(null,{ok:!0})},i.onerror=vi(t)};var p=Ii.get(r);if(p)return i=p.idb,e._meta=p.global,o(function(){n(null,e)});var d=indexedDB.open(r,si);Ri.set(r,d),d.onupgradeneeded=function(e){function o(){var e=r[i-1];i++,e&&e(n,o)}var t=e.target.result;if(e.oldVersion<1)return s(t);var n=e.currentTarget.transaction;e.oldVersion<3&&a(t),e.oldVersion<4&&l(t);var r=[u,f,c,h],i=e.oldVersion;o()},d.onsuccess=function(t){function c(){if(typeof f=="undefined"||!o)return;e._meta={name:r,instanceId:l,blobSupport:f},Ii.set(r,{idb:i,global:e._meta}),n(null,e)}function h(){if(typeof a=="undefined"||typeof u=="undefined")return;var e=r+"_id";e in u?l=u[e]:u[e]=l=tn(),u.docCount=a,s.objectStore(li).put(u)}i=t.target.result,i.onversionchange=function(){i.close(),Ii.delete(r)},i.onabort=function(e){q("error","Database has a global failure",e.target.error),i.close(),Ii.delete(r)};var s=i.transaction([li,hi,oi],"readwrite"),o=!1,u,a,f,l;s.objectStore(li).get(li).onsuccess=function(e){u=e.target.result||{id:li},h()},_i(s,function(e){a=e,h()}),qi||(qi=Mi(s)),qi.then(function(e){f=e,c()}),s.oncomplete=function(){o=!0,c()},s.onabort=vi(n)},d.onerror=function(){var e="Failed to open indexedDB, are you in private browsing mode?";q("error",e),n(gt(ft,e))}}function Wi(e){e.adapter("idb",Ui,!0)}function Xi(e,t){return new Promise(function(n,r){function f(){i++,e[s++]().then(c,h)}function l(){++o===u?a?r(a):n():p()}function c(){i--,l()}function h(e){i--,a=a||e,l()}function p(){while(i<t&&s<u)f()}var i=0,s=0,o=0,u=e.length,a;p()})}function Gi(e){var t=e.doc||e.ok,n=t._attachments;if(!n)return;Object.keys(n).forEach(function(e){var t=n[e];t.data=qt(t.data,t.content_type)})}function Yi(e){return/^_design/.test(e)?"_design/"+encodeURIComponent(e.slice(8)):/^_local/.test(e)?"_local/"+encodeURIComponent(e.slice(7)):encodeURIComponent(e)}function Zi(e){return!e._attachments||!Object.keys(e._attachments)?Promise.resolve():Promise.all(Object.keys(e._attachments).map(function(t){var n=e._attachments[t];if(n.data&&typeof n.data!="string")return(new Promise(function(e){Wt(n.data,e)})).then(function(e){n.data=e})}))}function es(e){if(!e.prefix)return!1;var t=Mt(e.prefix).protocol;return t==="http"||t==="https"}function ts(e,t){if(es(t)){var n=t.name.substr(t.prefix.length),r=t.prefix.replace(/\/?$/,"/");e=r+encodeURIComponent(n)}var i=Mt(e);if(i.user||i.password)i.auth={username:i.user,password:i.password};var s=i.path.replace(/(^\/|\/$)/g,"").split("/");return i.db=s.pop(),i.db.indexOf("%")===-1&&(i.db=encodeURIComponent(i.db)),i.path=s.join("/"),i}function ns(e,t){return rs(e,e.db+"/"+t)}function rs(e,t){var n=e.path?"/":"";return e.protocol+"://"+e.host+(e.port?":"+e.port:"")+"/"+e.path+n+t}function is(e){return"?"+Object.keys(e).map(function(t){return t+"="+encodeURIComponent(e[t])}).join("&")}function ss(e){var t=typeof navigator!="undefined"&&navigator.userAgent?navigator.userAgent.toLowerCase():"",n=t.indexOf("msie")!==-1,r=t.indexOf("trident")!==-1,i=t.indexOf("edge")!==-1,s=!("method"in e)||e.method==="GET";return(n||r||i)&&s}function os(e,t){function f(e,t){return S(e,s(function(e){h().then(function(){return t.apply(this,e)}).catch(function(t){var n=e.pop();n(t)})})).bind(r)}function l(e,t,n){var r={};return t=t||{},t.headers=t.headers||new Un,t.headers.get("Content-Type")||t.headers.set("Content-Type","application/json"),t.headers.get("Accept")||t.headers.set("Accept","application/json"),a(e,t).then(function(e){return r.ok=e.ok,r.status=e.status,e.json()}).then(function(e){r.data=e;if(!r.ok){r.data.status=r.status;var t=yt(r.data);if(n)return n(t);throw t}Array.isArray(r.data)&&(r.data=r.data.map(function(e){return e.error||e.missing?yt(e):e}));if(!n)return r;n(null,r.data)})}function h(){return e.skip_setup?Promise.resolve():c?c:(c=l(u).catch(function(e){return e&&e.status&&e.status===404?(z(404,"PouchDB is just detecting if the remote exists."),l(u,{method:"PUT"})):Promise.reject(e)}).catch(function(e){return e&&e.status&&e.status===412?!0:Promise.reject(e)}),c.catch(function(){c=null}),c)}function p(e){return e.split("/").map(encodeURIComponent).join("/")}var r=this,i=ts(e.name,e),u=ns(i,"");e=y(e);var a=function(t,n){n=n||{},n.headers=n.headers||new Un;if(e.auth||i.auth){var r=e.auth||i.auth,s=r.username+":"+r.password,o=Bt(unescape(encodeURIComponent(s)));n.headers.set("Authorization","Basic "+o)}var u=e.headers||{};Object.keys(u).forEach(function(e){n.headers.append(e,u[e])}),ss(n)&&(t+=(t.indexOf("?")===-1?"?":"&")+"_nonce="+Date.now());var a=e.fetch||Rn;return a(t,n)},c;o(function(){t(null,r)}),r._remote=!0,r.type=function(){return"http"},r.id=f("id",function(e){a(rs(i,"")).then(function(e){return e.json()}).then(function(t){var n=t&&t.uuid?t.uuid+i.db:ns(i,"");e(null,n)}).catch(function(t){e(t)})}),r.compact=f("compact",function(e,t){typeof e=="function"&&(t=e,e={}),e=y(e),l(ns(i,"_compact"),{method:"POST"}).then(function(){function n(){r.info(function(r,i){i&&!i.compact_running?t(null,{ok:!0}):setTimeout(n,e.interval||200)})}n()})}),r.bulkGet=S("bulkGet",function(e,t){function r(t){var n={};e.revs&&(n.revs=!0),e.attachments&&(n.attachments=!0),e.latest&&(n.latest=!0),l(ns(i,"_bulk_get"+is(n)),{method:"POST",body:JSON.stringify({docs:e.docs})}).then(function(n){e.attachments&&e.binary&&n.data.results.forEach(function(e){e.docs.forEach(Gi)}),t(null,n.data)}).catch(t)}function s(){function u(e){return function(n,r){o[e]=r.results,++s===i&&t(null,{results:Et(o)})}}var r=$i,i=Math.ceil(e.docs.length/r),s=0,o=new Array(i);for(var a=0;a<i;a++){var f=O(e,["revs","attachments","binary","latest"]);f.docs=e.docs.slice(a*r,Math.min(e.docs.length,(a+1)*r)),P(n,f,u(a))}}var n=this,o=rs(i,""),u=Qi[o];typeof u!="boolean"?r(function(e,n){e?(Qi[o]=!1,z(e.status,"PouchDB is just detecting if the remote supports the _bulk_get API."),s()):(Qi[o]=!0,t(null,n))}):u?r(t):s()}),r._info=function(e){h().then(function(){return a(ns(i,""))}).then(function(e){return e.json()}).then(function(t){t.host=ns(i,""),e(null,t)}).catch(e)},r.fetch=function(e,t){return h().then(function(){return a(ns(i,e),t)})},r.get=f("get",function(e,t,r){function o(e){function o(s){var o=r[s],u=Yi(e._id)+"/"+p(s)+"?rev="+e._rev;return a(ns(i,u)).then(function(e){return typeof n!="undefined"&&!n.browser?e.buffer():e.blob()}).then(function(e){return t.binary?(typeof n!="undefined"&&!n.browser&&(e.type=o.content_type),e):new Promise(function(t){Wt(e,t)})}).then(function(e){delete o.stub,delete o.length,o.data=e})}var r=e._attachments,s=r&&Object.keys(r);if(!r||!s.length)return;var u=s.map(function(e){return function(){return o(e)}});return Xi(u,5)}function u(e){return Array.isArray(e)?Promise.all(e.map(function(e){if(e.ok)return o(e.ok)})):o(e)}typeof t=="function"&&(r=t,t={}),t=y(t);var s={};t.revs&&(s.revs=!0),t.revs_info&&(s.revs_info=!0),t.latest&&(s.latest=!0),t.open_revs&&(t.open_revs!=="all"&&(t.open_revs=JSON.stringify(t.open_revs)),s.open_revs=t.open_revs),t.rev&&(s.rev=t.rev),t.conflicts&&(s.conflicts=t.conflicts),t.update_seq&&(s.update_seq=t.update_seq),e=Yi(e);var f=ns(i,e+is(s));l(f).then(function(e){return Promise.resolve().then(function(){if(t.attachments)return u(e.data)}).then(function(){r(null,e.data)})}).catch(function(t){t.docId=e,r(t)})}),r.remove=f("remove",function(e,t,n,r){var s;typeof t=="string"?(s={_id:e,_rev:t},typeof n=="function"&&(r=n,n={})):(s=e,typeof t=="function"?(r=t,n={}):(r=n,n=t));var o=s._rev||n.rev,u=ns(i,Yi(s._id))+"?rev="+o;l(u,{method:"DELETE"},r).catch(r)}),r.getAttachment=f("getAttachment",function(e,t,r,s){typeof r=="function"&&(s=r,r={});var o=r.rev?"?rev="+r.rev:"",u=ns(i,Yi(e))+"/"+p(t)+o,f;a(u,{method:"GET"}).then(function(e){f=e.headers.get("content-type");if(!e.ok)throw e;return typeof n!="undefined"&&!n.browser?e.buffer():e.blob()}).then(function(e){typeof n!="undefined"&&!n.browser&&(e.type=f),s(null,e)}).catch(function(e){s(e)})}),r.removeAttachment=f("removeAttachment",function(e,t,n,r){var s=ns(i,Yi(e)+"/"+p(t))+"?rev="+n;l(s,{method:"DELETE"},r).catch(r)}),r.putAttachment=f("putAttachment",function(e,t,n,r,s,o){typeof s=="function"&&(o=s,s=r,r=n,n=null);var u=Yi(e)+"/"+p(t),a=ns(i,u);n&&(a+="?rev="+n);if(typeof r=="string"){var f;try{f=Ht(r)}catch(c){return o(gt(nt,"Attachment is not a valid base64 string"))}r=f?It(f,s):""}l(a,{headers:new Un({"Content-Type":s}),method:"PUT",body:r},o).catch(o)}),r._bulkDocs=function(e,t,n){e.new_edits=t.new_edits,h().then(function(){return Promise.all(e.docs.map(Zi))}).then(function(){return l(ns(i,"_bulk_docs"),{method:"POST",body:JSON.stringify(e)},n)}).catch(n)},r._put=function(e,t,n){h().then(function(){return Zi(e)}).then(function(){return l(ns(i,Yi(e._id)),{method:"PUT",body:JSON.stringify(e)})}).then(function(e){n(null,e.data)}).catch(function(t){t.docId=e&&e._id,n(t)})},r.allDocs=f("allDocs",function(e,t){typeof e=="function"&&(t=e,e={}),e=y(e);var n={},r,s="GET";e.conflicts&&(n.conflicts=!0),e.update_seq&&(n.update_seq=!0),e.descending&&(n.descending=!0),e.include_docs&&(n.include_docs=!0),e.attachments&&(n.attachments=!0),e.key&&(n.key=JSON.stringify(e.key)),e.start_key&&(e.startkey=e.start_key),e.startkey&&(n.startkey=JSON.stringify(e.startkey)),e.end_key&&(e.endkey=e.end_key),e.endkey&&(n.endkey=JSON.stringify(e.endkey)),typeof e.inclusive_end!="undefined"&&(n.inclusive_end=!!e.inclusive_end),typeof e.limit!="undefined"&&(n.limit=e.limit),typeof e.skip!="undefined"&&(n.skip=e.skip);var o=is(n);typeof e.keys!="undefined"&&(s="POST",r={keys:e.keys}),l(ns(i,"_all_docs"+o),{method:s,body:JSON.stringify(r)}).then(function(n){e.include_docs&&e.attachments&&e.binary&&n.data.rows.forEach(Gi),t(null,n.data)}).catch(t)}),r._changes=function(e){var t="batch_size"in e?e.batch_size:Vi;e=y(e),e.continuous&&!("heartbeat"in e)&&(e.heartbeat=Ki);var n="timeout"in e?e.timeout:3e4;"timeout"in e&&e.timeout&&n-e.timeout<Ji&&(n=e.timeout+Ji),"heartbeat"in e&&e.heartbeat&&n-e.heartbeat<Ji&&(n=e.heartbeat+Ji);var r={};"timeout"in e&&e.timeout&&(r.timeout=e.timeout);var s=typeof e.limit!="undefined"?e.limit:!1,u=s;e.style&&(r.style=e.style);if(e.include_docs||e.filter&&typeof e.filter=="function")r.include_docs=!0;e.attachments&&(r.attachments=!0),e.continuous&&(r.feed="longpoll"),e.seq_interval&&(r.seq_interval=e.seq_interval),e.conflicts&&(r.conflicts=!0),e.descending&&(r.descending=!0),e.update_seq&&(r.update_seq=!0),"heartbeat"in e&&e.heartbeat&&(r.heartbeat=e.heartbeat),e.filter&&typeof e.filter=="string"&&(r.filter=e.filter),e.view&&typeof e.view=="string"&&(r.filter="_view",r.view=e.view);if(e.query_params&&typeof e.query_params=="object")for(var a in e.query_params)e.query_params.hasOwnProperty(a)&&(r[a]=e.query_params[a]);var f="GET",c;e.doc_ids?(r.filter="_doc_ids",f="POST",c={doc_ids:e.doc_ids}):e.selector&&(r.filter="_selector",f="POST",c={selector:e.selector});var p=new qn,d,v=function(n,o){if(e.aborted)return;r.since=n,typeof r.since=="object"&&(r.since=JSON.stringify(r.since)),e.descending?s&&(r.limit=u):r.limit=!s||u>t?t:u;var a=ns(i,"_changes"+is(r)),v={signal:p.signal,method:f,body:JSON.stringify(c)};d=n;if(e.aborted)return;h().then(function(){return l(a,v,o)}).catch(o)},m={results:[]},g=function(n,r){if(e.aborted)return;var i=0;if(r&&r.results){i=r.results.length,m.last_seq=r.last_seq;var a=null,f=null;typeof r.pending=="number"&&(a=r.pending);if(typeof m.last_seq=="string"||typeof m.last_seq=="number")f=m.last_seq;var l={};l.query=e.query_params,r.results=r.results.filter(function(t){u--;var n=wt(e)(t);return n&&(e.include_docs&&e.attachments&&e.binary&&Gi(t),e.return_docs&&m.results.push(t),e.onChange(t,a,f)),n})}else if(n){e.aborted=!0,e.complete(n);return}r&&r.last_seq&&(d=r.last_seq);var c=s&&u<=0||r&&i<t||e.descending;e.continuous&&!(s&&u<=0)||!c?o(function(){v(d,g)}):e.complete(null,m)};return v(e.since||0,g),{cancel:function(){e.aborted=!0,p.abort()}}},r.revsDiff=f("revsDiff",function(e,t,n){typeof t=="function"&&(n=t,t={}),l(ns(i,"_revs_diff"),{method:"POST",body:JSON.stringify(e)},n).catch(n)}),r._close=function(e){e()},r._destroy=function(e,t){l(ns(i,""),{method:"DELETE"}).then(function(e){t(null,e)}).catch(function(e){e.status===404?t(null,{ok:!0}):t(e)})}}function us(e){e.adapter("http",os,!1),e.adapter("https",os,!1)}function as(e){this.status=400,this.name="query_parse_error",this.message=e,this.error=!0;try{Error.captureStackTrace(this,as)}catch(t){}}function fs(e){this.status=404,this.name="not_found",this.message=e,this.error=!0;try{Error.captureStackTrace(this,fs)}catch(t){}}function ls(e){this.status=500,this.name="invalid_value",this.message=e,this.error=!0;try{Error.captureStackTrace(this,ls)}catch(t){}}function cs(e,t){return t&&e.then(function(e){o(function(){t(null,e)})},function(e){o(function(){t(e)})}),e}function hs(e){return s(function(t){var n=t.pop(),r=e.apply(this,t);return typeof n=="function"&&cs(r,n),r})}function ps(e,t){return e.then(function(e){return t().then(function(){return e})},function(e){return t().then(function(){throw e})})}function ds(e,t){return function(){var n=arguments,r=this;return e.add(function(){return t.apply(r,n)})}}function vs(e){var t=new L(e),n=new Array(t.size),r=-1;return t.forEach(function(e){n[++r]=e}),n}function ms(e){var t=new Array(e.size),n=-1;return e.forEach(function(e,r){t[++n]=r}),t}function gs(e){var t="builtin "+e+" function requires map values to be numbers"+" or number arrays";return new ls(t)}function ys(e){var t=0;for(var n=0,r=e.length;n<r;n++){var i=e[n];if(typeof i!="number"){if(!Array.isArray(i))throw gs("_sum");t=typeof t=="number"?[t]:t;for(var s=0,o=i.length;s<o;s++){var u=i[s];if(typeof u!="number")throw gs("_sum");typeof t[s]=="undefined"?t.push(u):t[s]+=u}}else typeof t=="number"?t+=i:t[0]+=i}return t}function Ss(e,t){return _t("return ("+e.replace(/;\s*$/,"")+");",{emit:t,sum:ys,log:bs,isArray:ws,toJSON:Es})}function xs(){this.promise=new Promise(function(e){e()})}function Ts(e){if(!e)return"undefined";switch(typeof e){case"function":return e.toString();case"string":return e.toString();default:return JSON.stringify(e)}}function Ns(e,t){return Ts(e)+Ts(t)+"undefined"}function Cs(e,t,n,r,i,s){var o=Ns(n,r),u;if(!i){u=e._cachedViews=e._cachedViews||{};if(u[o])return u[o]}var a=e.info().then(function(a){function l(e){e.views=e.views||{};var n=t;n.indexOf("/")===-1&&(n=t+"/"+t);var r=e.views[n]=e.views[n]||{};if(r[f])return;return r[f]=!0,e}var f=a.db_name+"-mrview-"+(i?"temp":Zt(o));return Dt(e,"_local/"+s,l).then(function(){return e.registerDependentDatabase(f).then(function(t){var i=t.db;i.auto_compaction=!0;var s={name:f,db:i,sourceDB:e,adapter:e.adapter,mapFun:n,reduceFun:r};return s.db.get("_local/lastSeq").catch(function(e){if(e.status!==404)throw e}).then(function(e){return s.seq=e?e.seq:0,u&&s.db.once("destroyed",function(){delete u[o]}),s})})})});return u&&(u[o]=a),a}function Os(e){return e.indexOf("/")===-1?[e,e]:e.split("/")}function Ms(e){return e.length===1&&/^1-/.test(e[0].rev)}function _s(e,t){try{e.emit("error",t)}catch(n){q("error","The user's map/reduce function threw an uncaught error.\nYou can debug this error by doing:\nmyDatabase.on('error', function (err) { debugger; });\nPlease double-check your map/reduce function."),q("error",t)}}function Ds(e,t,n,r){function i(e,t,n){try{t(n)}catch(r){_s(e,r)}}function s(e,t,n,r,i){try{return{output:t(n,r,i)}}catch(s){return _s(e,s),{error:s}}}function u(e,t){var n=lr(e.key,t.key);return n!==0?n:lr(e.value,t.value)}function a(e,t,n){return n=n||0,typeof t=="number"?e.slice(n,t+n):n>0?e.slice(n):e}function f(e){var t=e.value,n=t&&typeof t=="object"&&t._id||e.id;return n}function l(e){e.rows.forEach(function(e){var t=e.doc&&e.doc._attachments;if(!t)return;Object.keys(t).forEach(function(e){var n=t[e];t[e].data=qt(n.data,n.content_type)})})}function c(e){return function(t){return e.include_docs&&e.attachments&&e.binary&&l(t),t}}function h(e,t,n,r){var i=t[e];typeof i!="undefined"&&(r&&(i=encodeURIComponent(JSON.stringify(i))),n.push(e+"="+i))}function p(e){if(typeof e!="undefined"){var t=Number(e);return!isNaN(t)&&t===parseInt(e,10)?t:e}}function d(e){return e.group_level=p(e.group_level),e.limit=p(e.limit),e.skip=p(e.skip),e}function v(e){if(e){if(typeof e!="number")return new as('Invalid value for integer: "'+e+'"');if(e<0)return new as('Invalid value for positive integer: "'+e+'"')}}function m(e,t){var n=e.descending?"endkey":"startkey",r=e.descending?"startkey":"endkey";if(typeof e[n]!="undefined"&&typeof e[r]!="undefined"&&lr(e[n],e[r])>0)throw new as("No rows can match your key range, reverse your start_key and end_key or set {descending : true}");if(t.reduce&&e.reduce!==!1){if(e.include_docs)throw new as("{include_docs:true} is invalid for reduce");if(e.keys&&e.keys.length>1&&!e.group&&!e.group_level)throw new as("Multi-key fetches for reduce views must use {group: true}")}["group_level","limit","skip"].forEach(function(t){var n=v(e[t]);if(n)throw n})}function g(e,t,n){var r=[],i,s="GET",o,u;h("reduce",n,r),h("include_docs",n,r),h("attachments",n,r),h("limit",n,r),h("descending",n,r),h("group",n,r),h("group_level",n,r),h("skip",n,r),h("stale",n,r),h("conflicts",n,r),h("startkey",n,r,!0),h("start_key",n,r,!0),h("endkey",n,r,!0),h("end_key",n,r,!0),h("inclusive_end",n,r),h("key",n,r,!0),h("update_seq",n,r),r=r.join("&"),r=r===""?"":"?"+r;if(typeof n.keys!="undefined"){var a=2e3,f="keys="+encodeURIComponent(JSON.stringify(n.keys));f.length+r.length+1<=a?r+=(r[0]==="?"?"&":"?")+f:(s="POST",typeof t=="string"?i={keys:n.keys}:t.keys=n.keys)}if(typeof t=="string"){var l=Os(t);return e.fetch("_design/"+l[0]+"/_view/"+l[1]+r,{headers:new Un({"Content-Type":"application/json"}),method:s,body:JSON.stringify(i)}).then(function(e){return o=e.ok,u=e.status,e.json()}).then(function(e){if(!o)throw e.status=u,yt(e);return e.rows.forEach(function(e){if(e.value&&e.value.error&&e.value.error==="builtin_reduce_error")throw new Error(e.reason)}),e}).then(c(n))}return i=i||{},Object.keys(t).forEach(function(e){Array.isArray(t[e])?i[e]=t[e]:i[e]=t[e].toString()}),e.fetch("_temp_view"+r,{headers:new Un({"Content-Type":"application/json"}),method:"POST",body:JSON.stringify(i)}).then(function(e){return o=e.ok,u=e.status,e.json()}).then(function(e){if(!o)throw e.status=u,yt(e);return e}).then(c(n))}function y(e,t,n){return new Promise(function(r,i){e._query(t,n,function(e,t){if(e)return i(e);r(t)})})}function b(e){return new Promise(function(t,n){e._viewCleanup(function(e,r){if(e)return n(e);t(r)})})}function w(e){return function(t){if(t.status===404)return e;throw t}}function E(e,t,n){function a(){return Ms(u)?Promise.resolve(i):t.db.get(r).catch(w(i))}function f(e){return e.keys.length?t.db.allDocs({keys:e.keys,include_docs:!0}):Promise.resolve({rows:[]})}function l(e,t){var n=[],r=new L;for(var i=0,s=t.rows.length;i<s;i++){var u=t.rows[i],a=u.doc;if(!a)continue;n.push(a),r.add(a._id),a._deleted=!o.has(a._id);if(!a._deleted){var f=o.get(a._id);"value"in f&&(a.value=f.value)}}var l=ms(o);return l.forEach(function(e){if(!r.has(e)){var t={_id:e},i=o.get(e);"value"in i&&(t.value=i.value),n.push(t)}}),e.keys=vs(l.concat(e.keys)),n.push(e),n}var r="_local/doc_"+e,i={_id:r,keys:[]},s=n.get(e),o=s[0],u=s[1];return a().then(function(e){return f(e).then(function(t){return l(e,t)})})}function S(e,t,n){var r="_local/lastSeq";return e.db.get(r).catch(w({_id:r,seq:0})).then(function(r){var i=ms(t);return Promise.all(i.map(function(n){return E(n,e,t)})).then(function(t){var i=Et(t);return r.seq=n,i.push(r),e.db.bulkDocs({docs:i})})})}function x(e){var t=typeof e=="string"?e:e.name,n=ks[t];return n||(n=ks[t]=new xs),n}function T(e){return ds(x(e),function(){return N(e)})()}function N(e){function s(e,t){var i={id:r._id,key:cr(e)};typeof t!="undefined"&&t!==null&&(i.value=cr(t)),n.push(i)}function f(t,n){return function(){return S(e,t,n)}}function c(){return e.sourceDB.changes({return_docs:!0,conflicts:!0,include_docs:!0,style:"all_docs",since:a,limit:As}).then(h)}function h(e){var t=e.results;if(!t.length)return;var n=p(t);l.add(f(n,a));if(t.length<As)return;return c()}function p(t){var s=new A;for(var f=0,l=t.length;f<l;f++){var c=t[f];if(c.doc._id[0]!=="_"){n=[],r=c.doc,r._deleted||i(e.sourceDB,o,r),n.sort(u);var h=d(n);s.set(c.doc._id,[h,c.changes])}a=c.seq}return s}function d(e){var t=new A,n;for(var r=0,i=e.length;r<i;r++){var s=e[r],o=[s.key,s.id];r>0&&lr(s.key,n)===0&&o.push(r),t.set(pr(o),s),n=s.key}return t}var n,r,o=t(e.mapFun,s),a=e.seq||0,l=new xs;return c().then(function(){return l.finish()}).then(function(){e.seq=a})}function C(e,t,r){r.group_level===0&&delete r.group_level;var i=r.group||r.group_level,o=n(e.reduceFun),u=[],f=isNaN(r.group_level)?Number.POSITIVE_INFINITY:r.group_level;t.forEach(function(e){var t=u[u.length-1],n=i?e.key:null;i&&Array.isArray(n)&&(n=n.slice(0,f));if(t&&lr(t.groupKey,n)===0){t.keys.push([e.key,e.id]),t.values.push(e.value);return}u.push({keys:[[e.key,e.id]],values:[e.value],groupKey:n})}),t=[];for(var l=0,c=u.length;l<c;l++){var h=u[l],p=s(e.sourceDB,o,h.keys,h.values,!1);if(p.error&&p.error instanceof ls)throw p.error;t.push({value:p.error?null:p.output,key:h.groupKey})}return{rows:a(t,r.limit,r.skip)}}function k(e,t){return ds(x(e),function(){return O(e,t)})()}function O(e,t){function s(t){return t.include_docs=!0,e.db.allDocs(t).then(function(e){return n=e.total_rows,e.rows.map(function(e){if("value"in e.doc&&typeof e.doc.value=="object"&&e.doc.value!==null){var t=Object.keys(e.doc.value).sort(),n=["id","key","value"];if(!(t<n||t>n))return e.doc.value}var r=mr(e.doc._id);return{key:r[0],id:r[1],value:"value"in e.doc?e.doc.value:null}})})}function o(s){var o;r?o=C(e,s,t):o={total_rows:n,offset:i,rows:s},t.update_seq&&(o.update_seq=e.seq);if(t.include_docs){var u=vs(s.map(f));return e.sourceDB.allDocs({keys:u,include_docs:!0,conflicts:t.conflicts,attachments:t.attachments,binary:t.binary}).then(function(e){var t=new A;return e.rows.forEach(function(e){t.set(e.id,e.doc)}),s.forEach(function(e){var n=f(e),r=t.get(n);r&&(e.doc=r)}),o})}return o}var n,r=e.reduceFun&&t.reduce!==!1,i=t.skip||0;typeof t.keys!="undefined"&&!t.keys.length&&(t.limit=0,delete t.keys);if(typeof t.keys!="undefined"){var u=t.keys,a=u.map(function(e){var n={startkey:pr([e]),endkey:pr([e,{}])};return t.update_seq&&(n.update_seq=!0),s(n)});return Promise.all(a).then(Et).then(o)}var l={descending:t.descending};t.update_seq&&(l.update_seq=!0);var c,h;"start_key"in t&&(c=t.start_key),"startkey"in t&&(c=t.startkey),"end_key"in t&&(h=t.end_key),"endkey"in t&&(h=t.endkey),typeof c!="undefined"&&(l.startkey=t.descending?pr([c,{}]):pr([c]));if(typeof h!="undefined"){var p=t.inclusive_end!==!1;t.descending&&(p=!p),l.endkey=pr(p?[h,{}]:[h])}if(typeof t.key!="undefined"){var d=pr([t.key]),v=pr([t.key,{}]);l.descending?(l.endkey=d,l.startkey=v):(l.startkey=d,l.endkey=v)}return r||(typeof t.limit=="number"&&(l.limit=t.limit),l.skip=i),s(l).then(o)}function M(e){return e.fetch("_view_cleanup",{headers:new Un({"Content-Type":"application/json"}),method:"POST"}).then(function(e){return e.json()})}function _(t){return t.get("_local/"+e).then(function(e){var n=new A;Object.keys(e.views).forEach(function(e){var t=Os(e),r="_design/"+t[0],i=t[1],s=n.get(r);s||(s=new L,n.set(r,s)),s.add(i)});var r={keys:ms(n),include_docs:!0};return t.allDocs(r).then(function(r){var i={};r.rows.forEach(function(t){var r=t.key.substring(8);n.get(t.key).forEach(function(n){var s=r+"/"+n;e.views[s]||(s=n);var o=Object.keys(e.views[s]),u=t.doc&&t.doc.views&&t.doc.views[n];o.forEach(function(e){i[e]=i[e]||u})})});var s=Object.keys(i).filter(function(e){return!i[e]}),o=s.map(function(e){return ds(x(e),function(){return(new t.constructor(e,t.__opts)).destroy()})()});return Promise.all(o).then(function(){return{ok:!0}})})},w({ok:!0}))}function D(t,n,i){if(typeof t._query=="function")return y(t,n,i);if(xt(t))return g(t,n,i);if(typeof n!="string")return m(i,n),Ls.add(function(){var r=Cs(t,"temp_view/temp_view",n.map,n.reduce,!0,e);return r.then(function(e){return ps(T(e).then(function(){return k(e,i)}),function(){return e.db.destroy()})})}),Ls.finish();var s=n,u=Os(s),a=u[0],f=u[1];return t.get("_design/"+a).then(function(n){var u=n.views&&n.views[f];if(!u)throw new fs("ddoc "+n._id+" has no view named "+f);r(n,f),m(i,u);var a=Cs(t,s,u.map,u.reduce,!1,e);return a.then(function(e){return i.stale==="ok"||i.stale==="update_after"?(i.stale==="update_after"&&o(function(){T(e)}),k(e,i)):T(e).then(function(){return k(e,i)})})})}function P(e,t,n){var r=this;typeof t=="function"&&(n=t,t={}),t=t?d(t):{},typeof e=="function"&&(e={map:e});var i=Promise.resolve().then(function(){return D(r,e,t)});return cs(i,n),i}var H=hs(function(){var e=this;return typeof e._viewCleanup=="function"?b(e):xt(e)?M(e):_(e)});return{query:P,viewCleanup:H}}function Hs(e){if(/^_sum/.test(e))return Ps._sum;if(/^_count/.test(e))return Ps._count;if(/^_stats/.test(e))return Ps._stats;if(/^_/.test(e))throw new Error(e+" is not a supported reduce function.")}function Bs(e,t){if(typeof e=="function"&&e.length===2){var n=e;return function(e){return n(e,t)}}return Ss(e.toString(),t)}function js(e){var t=e.toString(),n=Hs(t);return n?n:Ss(t)}function Fs(e,t){var n=e.views&&e.views[t];if(typeof n.map!="string")throw new fs("ddoc "+e._id+" has no string view named "+t+", instead found object of type: "+typeof n.map)}function Rs(e,t,n){return qs.query.call(this,e,t,n)}function Us(e){return qs.viewCleanup.call(this,e)}function Ws(e){return/^1-/.test(e)}function Xs(e,t,n){return!e._attachments||!e._attachments[n]||e._attachments[n].digest!==t._attachments[n].digest}function Vs(e,t){var n=Object.keys(t._attachments);return Promise.all(n.map(function(n){return e.getAttachment(t._id,n,{rev:t._rev})}))}function $s(e,t,n){var r=xt(t)&&!xt(e),i=Object.keys(n._attachments);return r?e.get(n._id).then(function(r){return Promise.all(i.map(function(i){return Xs(r,n,i)?t.getAttachment(n._id,i):e.getAttachment(r._id,i)}))}).catch(function(e){if(e.status!==404)throw e;return Vs(t,n)}):Vs(t,n)}function Js(e){var t=[];return Object.keys(e).forEach(function(n){var r=e[n].missing;r.forEach(function(e){t.push({id:n,rev:e})})}),{docs:t,revs:!0,latest:!0}}function Ks(e,t,n,r){function o(){var o=Js(n);if(!o.docs.length)return;return e.bulkGet(o).then(function(n){if(r.cancelled)throw new Error("cancelled");return Promise.all(n.results.map(function(n){return Promise.all(n.docs.map(function(n){var r=n.ok;return n.error&&(s=!1),!r||!r._attachments?r:$s(t,e,r).then(function(e){var t=Object.keys(r._attachments);return e.forEach(function(e,n){var i=r._attachments[t[n]];delete i.stub,delete i.length,i.data=e}),r})}))})).then(function(e){i=i.concat(Et(e).filter(Boolean))})})}function u(e){return e._attachments&&Object.keys(e._attachments).length>0}function a(e){return e._conflicts&&e._conflicts.length>0}function f(t){return e.allDocs({keys:t,include_docs:!0,conflicts:!0}).then(function(e){if(r.cancelled)throw new Error("cancelled");e.rows.forEach(function(e){if(e.deleted||!e.doc||!Ws(e.value.rev)||u(e.doc)||a(e.doc))return;e.doc._conflicts&&delete e.doc._conflicts,i.push(e.doc),delete n[e.id]})})}function l(){var e=Object.keys(n).filter(function(e){var t=n[e].missing;return t.length===1&&Ws(t[0])});if(e.length>0)return f(e)}function c(){return{ok:s,docs:i}}n=y(n);var i=[],s=!0;return Promise.resolve().then(l).then(o).then(c)}function eo(e,t,n,r,i){return e.get(t).catch(function(n){if(n.status===404)return(e.adapter==="http"||e.adapter==="https")&&z(404,"PouchDB is just checking if a remote checkpoint exists."),{session_id:r,_id:t,history:[],replicator:Gs,version:Qs};throw n}).then(function(s){if(i.cancelled)return;if(s.last_seq===n)return;return s.history=(s.history||[]).filter(function(e){return e.session_id!==r}),s.history.unshift({last_seq:n,session_id:r}),s.history=s.history.slice(0,Ys),s.version=Qs,s.replicator=Gs,s.session_id=r,s.last_seq=n,e.put(s).catch(function(s){if(s.status===409)return eo(e,t,n,r,i);throw s})})}function to(e,t,n,r,i){this.src=e,this.target=t,this.id=n,this.returnValue=r,this.opts=i||{}}function ro(e,t){return e.session_id===t.session_id?{last_seq:e.last_seq,history:e.history}:io(e.history,t.history)}function io(e,t){var n=e[0],r=e.slice(1),i=t[0],s=t.slice(1);if(!n||t.length===0)return{last_seq:Zs,history:[]};var o=n.session_id;if(so(o,t))return{last_seq:n.last_seq,history:e};var u=i.session_id;return so(u,r)?{last_seq:i.last_seq,history:s}:io(r,s)}function so(e,t){var n=t[0],r=t.slice(1);return!e||t.length===0?!1:e===n.session_id?!0:so(e,r)}function oo(e){return typeof e.status=="number"&&Math.floor(e.status/100)===4}function ao(e,t,n,r){if(e.retry===!1){t.emit("error",n),t.removeAllListeners();return}typeof e.back_off_function!="function"&&(e.back_off_function=U),t.emit("requestError",n);if(t.state==="active"||t.state==="pending"){t.emit("paused",n),t.state="stopped";var i=function(){e.current_back_off=uo},s=function(){t.removeListener("active",i)};t.once("paused",s),t.once("active",i)}e.current_back_off=e.current_back_off||uo,e.current_back_off=e.back_off_function(e.current_back_off),setTimeout(r,e.current_back_off)}function fo(e){return Object.keys(e).sort(lr).reduce(function(t,n){return t[n]=e[n],t},{})}function lo(e,t,n){var r=n.doc_ids?n.doc_ids.sort(lr):"",i=n.filter?n.filter.toString():"",s="",o="",u="";return n.selector&&(u=JSON.stringify(n.selector)),n.filter&&n.query_params&&(s=JSON.stringify(fo(n.query_params))),n.filter&&n.filter==="_view"&&(o=n.view.toString()),Promise.all([e.id(),t.id()]).then(function(e){var t=e[0]+e[1]+i+o+s+r+u;return new Promise(function(e){Yt(t,e)})}).then(function(e){return e=e.replace(/\//g,".").replace(/\+/g,"_"),"_local/"+e})}function co(e,t,n,r,i){function N(){return E?Promise.resolve():lo(e,t,n).then(function(i){w=i;var s={};n.checkpoint===!1?s={writeSourceCheckpoint:!1,writeTargetCheckpoint:!1}:n.checkpoint==="source"?s={writeSourceCheckpoint:!0,writeTargetCheckpoint:!1}:n.checkpoint==="target"?s={writeSourceCheckpoint:!1,writeTargetCheckpoint:!0}:s={writeSourceCheckpoint:!0,writeTargetCheckpoint:!0},E=new to(e,t,w,r,s)})}function C(){S=[];if(u.docs.length===0)return;var e=u.docs,s={timeout:n.timeout};return t.bulkDocs({docs:e,new_edits:!1},s).then(function(t){if(r.cancelled)throw D(),new Error("cancelled");var n=Object.create(null);t.forEach(function(e){e.error&&(n[e.id]=e)});var s=Object.keys(n).length;i.doc_write_failures+=s,i.docs_written+=e.length-s,e.forEach(function(e){var t=n[e._id];if(t){i.errors.push(t);var s=(t.name||"").toLowerCase();if(s!=="unauthorized"&&s!=="forbidden")throw t;r.emit("denied",y(t))}else S.push(e)})},function(t){throw i.doc_write_failures+=e.length,t})}function k(){if(u.error)throw new Error("There was a problem getting docs.");i.last_seq=h=u.seq;var e=y(i);return S.length&&(e.docs=S,typeof u.pending=="number"&&(e.pending=u.pending,delete u.pending),r.emit("change",e)),f=!0,E.writeCheckpoint(u.seq,x).then(function(){f=!1;if(r.cancelled)throw D(),new Error("cancelled");u=undefined,j()}).catch(function(e){throw I(e),e})}function L(){var e={};return u.changes.forEach(function(t){if(t.id==="_user/")return;e[t.id]=t.changes.map(function(e){return e.rev})}),t.revsDiff(e).then(function(e){if(r.cancelled)throw D(),new Error("cancelled");u.diffs=e})}function A(){return Ks(e,t,u.diffs,r).then(function(e){u.error=!e.ok,e.docs.forEach(function(e){delete u.diffs[e._id],i.docs_read++,u.docs.push(e)})})}function O(){if(r.cancelled||u)return;if(s.length===0){M(!0);return}u=s.shift(),L().then(A).then(C).then(k).then(O).catch(function(e){_("batch processing terminated with error",e)})}function M(e){if(a.changes.length===0){if(s.length===0&&!u){if(p&&T.live||l)r.state="pending",r.emit("paused");l&&D()}return}if(e||l||a.changes.length>=d){s.push(a),a={seq:0,changes:[],docs:[]};if(r.state==="pending"||r.state==="stopped")r.state="active",r.emit("active");O()}}function _(e,t){if(c)return;t.message||(t.message=e),i.ok=!1,i.status="aborting",s=[],a={seq:0,changes:[],docs:[]},D(t)}function D(s){if(c)return;if(r.cancelled){i.status="cancelled";if(f)return}i.status=i.status||"complete",i.end_time=(new Date).toISOString(),i.last_seq=h,c=!0;if(s){s=gt(s),s.result=i;var o=(s.name||"").toLowerCase();o==="unauthorized"||o==="forbidden"?(r.emit("error",s),r.removeAllListeners()):ao(n,r,s,function(){co(e,t,n,r)})}else r.emit("complete",i),r.removeAllListeners()}function P(e,t,i){if(r.cancelled)return D();typeof t=="number"&&(a.pending=t);var u=wt(n)(e);if(!u)return;a.seq=e.seq||i,a.changes.push(e),o(function(){M(s.length===0&&T.live)})}function H(e){m=!1;if(r.cancelled)return D();if(e.results.length>0)T.since=e.results[e.results.length-1].seq,j(),M(!0);else{var t=function(){p?(T.live=!0,j()):l=!0,M(!0)};!u&&e.results.length===0?(f=!0,E.writeCheckpoint(e.last_seq,x).then(function(){f=!1,i.last_seq=h=e.last_seq,t()}).catch(I)):t()}}function B(e){m=!1;if(r.cancelled)return D();_("changes rejected",e)}function j(){function t(){o.cancel()}function i(){r.removeListener("cancel",t)}if(!(!m&&!l&&s.length<v))return;m=!0,r._changes&&(r.removeListener("cancel",r._abortChanges),r._changes.cancel()),r.once("cancel",t);var o=e.changes(T).on("change",P);o.then(i,i),o.then(H).catch(B),n.retry&&(r._changes=o,r._abortChanges=t)}function F(){N().then(function(){if(r.cancelled){D();return}return E.getCheckpoint().then(function(e){h=e,T={since:h,limit:d,batch_size:d,style:"all_docs",doc_ids:g,selector:b,return_docs:!0},n.filter&&(typeof n.filter!="string"?T.include_docs=!0:T.filter=n.filter),"heartbeat"in n&&(T.heartbeat=n.heartbeat),"timeout"in n&&(T.timeout=n.timeout),n.query_params&&(T.query_params=n.query_params),n.view&&(T.view=n.view),j()})}).catch(function(e){_("getCheckpoint rejected with ",e)})}function I(e){f=!1,_("writeCheckpoint completed with error",e)}var s=[],u,a={seq:0,changes:[],docs:[]},f=!1,l=!1,c=!1,h=0,p=n.continuous||n.live||!1,d=n.batch_size||100,v=n.batches_limit||10,m=!1,g=n.doc_ids,b=n.selector,w,E,S=[],x=tn();i=i||{ok:!0,start_time:(new Date).toISOString(),docs_read:0,docs_written:0,doc_write_failures:0,errors:[]};var T={};r.ready(e,t);if(r.cancelled){D();return}r._addedListeners||(r.once("cancel",D),typeof n.complete=="function"&&(r.once("error",n.complete),r.once("complete",function(e){n.complete(null,e)})),r._addedListeners=!0),typeof n.since=="undefined"?F():N().then(function(){return f=!0,E.writeCheckpoint(n.since,x)}).then(function(){f=!1;if(r.cancelled){D();return}h=n.since,F()}).catch(I)}function ho(){u.EventEmitter.call(this),this.cancelled=!1,this.state="pending";var e=this,t=new Promise(function(t,n){e.once("complete",t),e.once("error",n)});e.then=function(e,n){return t.then(e,n)},e.catch=function(e){return t.catch(e)},e.catch(function(){})}function po(e,t){var n=t.PouchConstructor;return typeof e=="string"?new n(e,t):e}function vo(e,t,n,r){typeof n=="function"&&(r=n,n={}),typeof n=="undefined"&&(n={});if(n.doc_ids&&!Array.isArray(n.doc_ids))throw gt(ot,"`doc_ids` filter parameter is not a list.");n.complete=r,n=y(n),n.continuous=n.continuous||n.live,n.retry="retry"in n?n.retry:!1,n.PouchConstructor=n.PouchConstructor||this;var i=new ho(n),s=po(e,n),o=po(t,n);return co(s,o,n,i),i}function mo(e,t,n,r){return typeof n=="function"&&(r=n,n={}),typeof n=="undefined"&&(n={}),n=y(n),n.PouchConstructor=n.PouchConstructor||this,e=po(e,n),t=po(t,n),new go(e,t,n,r)}function go(e,t,n,r){function u(e){i.emit("change",{direction:"pull",change:e})}function a(e){i.emit("change",{direction:"push",change:e})}function f(e){i.emit("denied",{direction:"push",doc:e})}function l(e){i.emit("denied",{direction:"pull",doc:e})}function c(){i.pushPaused=!0,i.pullPaused&&i.emit("paused")}function h(){i.pullPaused=!0,i.pushPaused&&i.emit("paused")}function p(){i.pushPaused=!1,i.pullPaused&&i.emit("active",{direction:"push"})}function d(){i.pullPaused=!1,i.pushPaused&&i.emit("active",{direction:"pull"})}function m(e){return function(t,n){var r=t==="change"&&(n===u||n===a),s=t==="denied"&&(n===l||n===f),o=t==="paused"&&(n===h||n===c),m=t==="active"&&(n===d||n===p);if(r||s||o||m)t in v||(v[t]={}),v[t][e]=!0,Object.keys(v[t]).length===2&&i.removeAllListeners(t)}}function g(e,t,n){e.listeners(t).indexOf(n)==-1&&e.on(t,n)}var i=this;this.canceled=!1;var s=n.push?X({},n,n.push):n,o=n.pull?X({},n,n.pull):n;this.push=vo(e,t,s),this.pull=vo(t,e,o),this.pushPaused=!0,this.pullPaused=!0;var v={};n.live&&(this.push.on("complete",i.pull.cancel.bind(i.pull)),this.pull.on("complete",i.push.cancel.bind(i.push))),this.on("newListener",function(e){e==="change"?(g(i.pull,"change",u),g(i.push,"change",a)):e==="denied"?(g(i.pull,"denied",l),g(i.push,"denied",f)):e==="active"?(g(i.pull,"active",d),g(i.push,"active",p)):e==="paused"&&(g(i.pull,"paused",h),g(i.push,"paused",c))}),this.on("removeListener",function(e){e==="change"?(i.pull.removeListener("change",u),i.push.removeListener("change",a)):e==="denied"?(i.pull.removeListener("denied",l),i.push.removeListener("denied",f)):e==="active"?(i.pull.removeListener("active",d),i.push.removeListener("active",p)):e==="paused"&&(i.pull.removeListener("paused",h),i.push.removeListener("paused",c))}),this.pull.on("removeListener",m("pull")),this.push.on("removeListener",m("push"));var y=Promise.all([this.push,this.pull]).then(function(e){var t={push:e[0],pull:e[1]};return i.emit("complete",t),r&&r(null,t),i.removeAllListeners(),t},function(e){i.cancel(),r?r(e):i.emit("error",e),i.removeAllListeners();if(r)throw e});this.then=function(e,t){return y.then(e,t)},this.catch=function(e){return y.catch(e)}}function yo(e){e.replicate=vo,e.sync=mo,Object.defineProperty(e.prototype,"replicate",{get:function(){var e=this;return typeof this.replicateMethods=="undefined"&&(this.replicateMethods={from:function(t,n,r){return e.constructor.replicate(t,e,n,r)},to:function(t,n,r){return e.constructor.replicate(e,t,n,r)}}),this.replicateMethods}}),e.prototype.sync=function(e,t,n){return this.constructor.sync(this,e,t,n)}}var s=i(e("argsarray")),o=i(e("immediate")),u=e("events"),a=i(e("inherits")),f=i(e("spark-md5")),l=i(e("uuid")),c=i(e("vuvuzela")),v=Function.prototype.toString,m=v.call(Object);N.prototype.get=function(e){var t=x(e);return this._store[t]},N.prototype.set=function(e,t){var n=x(e);return this._store[n]=t,!0},N.prototype.has=function(e){var t=x(e);return t in this._store},N.prototype.delete=function(e){var t=x(e),n=t in this._store;return delete this._store[t],n},N.prototype.forEach=function(e){var t=Object.keys(this._store);for(var n=0,r=t.length;n<r;n++){var i=t[n],s=this._store[i];i=T(i),e(s,i)}},Object.defineProperty(N.prototype,"size",{get:function(){return Object.keys(this._store).length}}),C.prototype.add=function(e){return this._store.set(e,!0)},C.prototype.has=function(e){return this._store.has(e)},C.prototype.forEach=function(e){this._store.forEach(function(t,n){e(n)})},Object.defineProperty(C.prototype,"size",{get:function(){return this._store.size}});var L,A;k()?(L=Set,A=Map):(L=C,A=N);var M=6,H;try{localStorage.setItem("_pouch_check_localstorage",1),H=!!localStorage.getItem("_pouch_check_localstorage")}catch(B){H=!1}a(I,u.EventEmitter),I.prototype.addListener=function(e,t,n,r){function u(){function a(){s=!1}if(!i._listeners[t])return;if(s){s="waiting";return}s=!0;var e=O(r,["style","include_docs","attachments","conflicts","filter","doc_ids","view","since","query_params","binary","return_docs"]);n.changes(e).on("change",function(e){e.seq>r.since&&!r.cancelled&&(r.since=e.seq,r.onChange(e))}).on("complete",function(){s==="waiting"&&o(u),s=!1}).on("error",a)}if(this._listeners[t])return;var i=this,s=!1;this._listeners[t]=u,this.on(e,u)},I.prototype.removeListener=function(e,t){if(!(t in this._listeners))return;u.EventEmitter.prototype.removeListener.call(this,e,this._listeners[t]),delete this._listeners[t]},I.prototype.notifyLocalWindows=function(e){j()&&(localStorage[e]=localStorage[e]==="a"?"b":"a")},I.prototype.notify=function(e){this.emit(e),this.notifyLocalWindows(e)};var W;typeof Object.assign=="function"?W=Object.assign:W=function(e){var t=Object(e);for(var n=1;n<arguments.length;n++){var r=arguments[n];if(r!=null)for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&(t[i]=r[i])}return t};var X=W;a(V,Error),V.prototype.toString=function(){return JSON.stringify({status:this.status,name:this.name,message:this.message,reason:this.reason})};var $=new V(401,"unauthorized","Name or password is incorrect."),J=new V(400,"bad_request","Missing JSON list of 'docs'"),K=new V(404,"not_found","missing"),Q=new V(409,"conflict","Document update conflict"),G=new V(400,"bad_request","_id field must contain a string"),Y=new V(412,"missing_id","_id is required for puts"),Z=new V(400,"bad_request","Only reserved document ids may start with underscore."),et=new V(412,"precondition_failed","Database not open"),tt=new V(500,"unknown_error","Database encountered an unknown error"),nt=new V(500,"badarg","Some query argument is invalid"),rt=new V(400,"invalid_request","Request was invalid"),it=new V(400,"query_parse_error","Some query parameter is invalid"),st=new V(500,"doc_validation","Bad special document member"),ot=new V(400,"bad_request","Something wrong with the request"),ut=new V(400,"bad_request","Document must be a JSON object"),at=new V(404,"not_found","Database not found"),ft=new V(500,"indexed_db_went_bad","unknown"),lt=new V(500,"web_sql_went_bad","unknown"),ct=new V(500,"levelDB_went_went_bad","unknown"),ht=new V(403,"forbidden","Forbidden by design doc validate_doc_update function"),pt=new V(400,"bad_request","Invalid rev format"),dt=new V(412,"file_exists","The database could not be created, the file already exists."),vt=new V(412,"missing_stub","A pre-existing attachment stub wasn't found"),mt=new V(413,"invalid_url","Provided URL is invalid"),kt=["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],Lt="queryKey",At=/(?:^|&)([^&=]*)=?([^&]*)/g,Ot=/^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/,Ht=function(e){return atob(e)},Bt=function(e){return btoa(e)},Vt=r.setImmediate||r.setTimeout,$t=32768,tn=l.v4;a(Nn,u.EventEmitter),Nn.prototype.cancel=function(){this.isCancelled=!0,this.db.taskqueue.isReady&&this.emit("cancel")},Nn.prototype.validateChanges=function(e){var t=e.complete,n=this;In._changesFilterPlugin?In._changesFilterPlugin.validate(e,function(r){if(r)return t(r);n.doChanges(e)}):n.doChanges(e)},Nn.prototype.doChanges=function(e){var t=this,n=e.complete;e=y(e),"live"in e&&!("continuous"in e)&&(e.continuous=e.live),e.processChange=Cn,e.since==="latest"&&(e.since="now"),e.since||(e.since=0);if(e.since==="now"){this.db.info().then(function(r){if(t.isCancelled){n(null,{status:"cancelled"});return}e.since=r.update_seq,t.doChanges(e)},n);return}if(In._changesFilterPlugin){In._changesFilterPlugin.normalize(e);if(In._changesFilterPlugin.shouldFilter(this,e))return In._changesFilterPlugin.filter(this,e)}else["doc_ids","filter","selector","view"].forEach(function(t){t in e&&q("warn",'The "'+t+'" option was passed in to changes/replicate, '+"but pouchdb-changes-filter plugin is not installed, so it "+"was ignored. Please install the plugin to enable filtering.")});"descending"in e||(e.descending=!1),e.limit=e.limit===0?1:e.limit,e.complete=n;var r=this.db._changes(e);if(r&&typeof r.cancel=="function"){var i=t.cancel;t.cancel=s(function(e){r.cancel(),i.apply(this,e)})}},a(Hn,u.EventEmitter),Hn.prototype.post=S("post",function(e,t,n){typeof t=="function"&&(n=t,t={});if(typeof e!="object"||Array.isArray(e))return n(gt(ut));this.bulkDocs({docs:[e]},t,Ln(n,e._id))}),Hn.prototype.put=S("put",function(e,t,n){function i(){var n=e._rev.split("-"),r=n[1],i=parseInt(n[0],10),s=i+1,o=en();e._revisions={start:s,ids:[o,r]},e._rev=s+"-"+o,t.new_edits=!1}function s(n){typeof r._put=="function"&&t.new_edits!==!1?r._put(e,t,n):r.bulkDocs({docs:[e]},t,Ln(n,e._id))}typeof t=="function"&&(n=t,t={});if(typeof e!="object"||Array.isArray(e))return n(gt(ut));St(e._id);if(Sn(e._id)&&typeof this._putLocal=="function")return e._deleted?this._removeLocal(e,n):this._putLocal(e,n);var r=this;t.force&&e._rev?(i(),s(function(t){var r=t?null:{ok:!0,id:e._id,rev:e._rev};n(t,r)})):s(n)}),Hn.prototype.putAttachment=S("putAttachment",function(e,t,n,r,i){function o(e){var n="_rev"in e?parseInt(e._rev,10):0;return e._attachments=e._attachments||{},e._attachments[t]={content_type:i,data:r,revpos:++n},s.put(e)}var s=this;return typeof i=="function"&&(i=r,r=n,n=null),typeof i=="undefined"&&(i=r,r=n,n=null),i||q("warn","Attachment",t,"on document",e,"is missing content_type"),s.get(e).then(function(e){if(e._rev!==n)throw gt(Q);return o(e)},function(t){if(t.reason===K.message)return o({_id:e});throw t})}),Hn.prototype.removeAttachment=S("removeAttachment",function(e,t,n,r){var i=this;i.get(e,function(e,s){if(e){r(e);return}if(s._rev!==n){r(gt(Q));return}if(!s._attachments)return r();delete s._attachments[t],Object.keys(s._attachments).length===0&&delete s._attachments,i.put(s,r)})}),Hn.prototype.remove=S("remove",function(e,t,n,r){var i;typeof t=="string"?(i={_id:e,_rev:t},typeof n=="function"&&(r=n,n={})):(i=e,typeof t=="function"?(r=t,n={}):(r=n,n=t)),n=n||{},n.was_delete=!0;var s={_id:i._id,_rev:i._rev||n.rev};s._deleted=!0;if(Sn(s._id)&&typeof this._removeLocal=="function")return this._removeLocal(i,r);this.bulkDocs({docs:[s]},n,Ln(r,s._id))}),Hn.prototype.revsDiff=S("revsDiff",function(e,t,n){function o(e,t){s.has(e)||s.set(e,{missing:[]}),s.get(e).missing.push(t)}function u(t,n){var r=e[t].slice(0);rn(n,function(e,n,i,s,u){var a=n+"-"+i,f=r.indexOf(a);if(f===-1)return;r.splice(f,1),u.status!=="available"&&o(t,a)}),r.forEach(function(e){o(t,e)})}typeof t=="function"&&(n=t,t={});var r=Object.keys(e);if(!r.length)return n(null,{});var i=0,s=new A;r.map(function(t){this._getRevisionTree(t,function(o,a){if(o&&o.status===404&&o.message==="missing")s.set(t,{missing:e[t]});else{if(o)return n(o);u(t,a)}if(++i===r.length){var f={};return s.forEach(function(e,t){f[t]=e}),n(null,f)}})},this)}),Hn.prototype.bulkGet=S("bulkGet",function(e,t){P(this,e,t)}),Hn.prototype.compactDocument=S("compactDocument",function(e,t,n){var r=this;this._getRevisionTree(e,function(i,s){if(i)return n(i);var o=Mn(s),u=[],a=[];Object.keys(o).forEach(function(e){o[e]>t&&u.push(e)}),rn(s,function(e,t,n,r,i){var s=t+"-"+n;i.status==="available"&&u.indexOf(s)!==-1&&a.push(s)}),r._doCompaction(e,a,n)})}),Hn.prototype.compact=S("compact",function(e,t){typeof e=="function"&&(t=e,e={});var n=this;e=e||{},n._compactionQueue=n._compactionQueue||[],n._compactionQueue.push({opts:e,callback:t}),n._compactionQueue.length===1&&Dn(n)}),Hn.prototype._compact=function(e,t){function s(e){i.push(n.compactDocument(e.id,0))}function o(e){var r=e.last_seq;Promise.all(i).then(function(){return Dt(n,"_local/compaction",function(t){return!t.last_seq||t.last_seq<r?(t.last_seq=r,t):!1})}).then(function(){t(null,{ok:!0})}).catch(t)}var n=this,r={return_docs:!1,last_seq:e.last_seq||0},i=[];n.changes(r).on("change",s).on("complete",o).on("error",t)},Hn.prototype.get=S("get",function(e,t,n){function s(){var s=[],o=r.length;if(!o)return n(null,s);r.forEach(function(r){i.get(e,{rev:r,revs:t.revs,latest:t.latest,attachments:t.attachments,binary:t.binary},function(e,t){if(!e){var i;for(var u=0,a=s.length;u<a;u++)if(s[u].ok&&s[u].ok._rev===t._rev){i=!0;break}i||s.push({ok:t})}else s.push({missing:r});o--,o||n(null,s)})})}typeof t=="function"&&(n=t,t={});if(typeof e!="string")return n(gt(G));if(Sn(e)&&typeof this._getLocal=="function")return this._getLocal(e,n);var r=[],i=this;if(t.open_revs){if(t.open_revs==="all")this._getRevisionTree(e,function(e,t){if(e)return n(e);r=on(t).map(function(e){return e.rev}),s()});else{if(!Array.isArray(t.open_revs))return n(gt(tt,"function_clause"));r=t.open_revs;for(var o=0;o<r.length;o++){var u=r[o];if(typeof u!="string"||!/^\d+-/.test(u))return n(gt(pt))}s()}return}return this._get(e,t,function(r,s){if(r)return r.docId=e,n(r);var o=s.doc,u=s.metadata,a=s.ctx;if(t.conflicts){var f=un(u);f.length&&(o._conflicts=f)}En(u,o._rev)&&(o._deleted=!0);if(t.revs||t.revs_info){var l=o._rev.split("-"),c=parseInt(l[0],10),h=l[1],p=fn(u.rev_tree),d=null;for(var v=0;v<p.length;v++){var m=p[v],g=m.ids.map(function(e){return e.id}).indexOf(h),y=g===c-1;if(y||!d&&g!==-1)d=m}var b=d.ids.map(function(e){return e.id}).indexOf(o._rev.split("-")[1])+1,w=d.ids.length-b;d.ids.splice(b,w),d.ids.reverse(),t.revs&&(o._revisions={start:d.pos+d.ids.length-1,ids:d.ids.map(function(e){return e.id})});if(t.revs_info){var E=d.pos+d.ids.length;o._revs_info=d.ids.map(function(e){return E--,{rev:E+"-"+e.id,status:e.opts.status}})}}if(t.attachments&&o._attachments){var S=o._attachments,x=Object.keys(S).length;if(x===0)return n(null,o);Object.keys(S).forEach(function(e){this._getAttachment(o._id,e,S[e],{rev:o._rev,binary:t.binary,ctx:a},function(t,r){var i=o._attachments[e];i.data=r,delete i.stub,delete i.length,--x||n(null,o)})},i)}else{if(o._attachments)for(var T in o._attachments)o._attachments.hasOwnProperty(T)&&(o._attachments[T].stub=!0);n(null,o)}})}),Hn.prototype.getAttachment=S("getAttachment",function(e,t,n,r){var i=this;n instanceof Function&&(r=n,n={}),this._get(e,n,function(s,o){if(s)return r(s);if(!o.doc._attachments||!o.doc._attachments[t])return r(gt(K));n.ctx=o.ctx,n.binary=!0,i._getAttachment(e,t,o.doc._attachments[t],n,r)})}),Hn.prototype.allDocs=S("allDocs",function(e,t){typeof e=="function"&&(t=e,e={}),e.skip=typeof e.skip!="undefined"?e.skip:0,e.start_key&&(e.startkey=e.start_key),e.end_key&&(e.endkey=e.end_key);if("keys"in e){if(!Array.isArray(e.keys))return t(new TypeError("options.keys must be an array"));var n=["startkey","endkey","key"].filter(function(t){return t in e})[0];if(n){t(gt(it,"Query parameter `"+n+"` is not compatible with multi-get"));return}if(!xt(this)){_n(e);if(e.keys.length===0)return this._allDocs({limit:0},t)}}return this._allDocs(e,t)}),Hn.prototype.changes=function(e,t){return typeof e=="function"&&(t=e,e={}),e=e||{},e.return_docs="return_docs"in e?e.return_docs:!e.live,new Nn(this,e,t)},Hn.prototype.close=S("close",function(e){return this._closed=!0,this.emit("closed"),this._close(e)}),Hn.prototype.info=S("info",function(e){var t=this;this._info(function(n,r){if(n)return e(n);r.db_name=r.db_name||t.name,r.auto_compaction=!!t.auto_compaction&&!xt(t),r.adapter=t.adapter,e(null,r)})}),Hn.prototype.id=S("id",function(e){return this._id(e)}),Hn.prototype.type=function(){return typeof this._type=="function"?this._type():this.adapter},Hn.prototype.bulkDocs=S("bulkDocs",function(e,t,n){typeof t=="function"&&(n=t,t={}),t=t||{},Array.isArray(e)&&(e={docs:e});if(!e||!e.docs||!Array.isArray(e.docs))return n(gt(J));for(var r=0;r<e.docs.length;++r)if(typeof e.docs[r]!="object"||Array.isArray(e.docs[r]))return n(gt(ut));var i;e.docs.forEach(function(e){e._attachments&&Object.keys(e._attachments).forEach(function(t){i=i||Pn(t),e._attachments[t].content_type||q("warn","Attachment",t,"on document",e._id,"is missing content_type")})});if(i)return n(gt(ot,i));"new_edits"in t||("new_edits"in e?t.new_edits=e.new_edits:t.new_edits=!0);var s=this;!t.new_edits&&!xt(s)&&e.docs.sort(On),An(e.docs);var o=e.docs.map(function(e){return e._id});return this._bulkDocs(e,t,function(e,r){if(e)return n(e);t.new_edits||(r=r.filter(function(e){return e.error}));if(!xt(s))for(var i=0,u=r.length;i<u;i++)r[i].id=r[i].id||o[i];n(null,r)})}),Hn.prototype.registerDependentDatabase=S("registerDependentDatabase",function(e,t){function r(t){return t.dependentDbs=t.dependentDbs||{},t.dependentDbs[e]?!1:(t.dependentDbs[e]=!0,t)}var n=new this.constructor(e,this.__opts);Dt(this,"_local/_pouch_dependentDbs",r).then(function(){t(null,{db:n})}).catch(t)}),Hn.prototype.destroy=S("destroy",function(e,t){function i(){n._destroy(e,function(e,r){if(e)return t(e);n._destroyed=!0,n.emit("destroyed"),t(null,r||{ok:!0})})}typeof e=="function"&&(t=e,e={});var n=this,r="use_prefix"in n?n.use_prefix:!0;if(xt(n))return i();n.get("_local/_pouch_dependentDbs",function(e,s){if(e)return e.status!==404?t(e):i();var o=s.dependentDbs,u=n.constructor,a=Object.keys(o).map(function(e){var t=r?e.replace(new RegExp("^"+u.prefix),""):e;return(new u(t,n.__opts)).destroy()});Promise.all(a).then(i,t)})}),Bn.prototype.execute=function(){var e;if(this.failed)while(e=this.queue.shift())e(this.failed);else while(e=this.queue.shift())e()},Bn.prototype.fail=function(e){this.failed=e,this.execute()},Bn.prototype.ready=function(e){this.isReady=!0,this.db=e,this.execute()},Bn.prototype.addTask=function(e){this.queue.push(e),this.failed&&this.execute()},a(In,Hn);var qn=typeof AbortController!="undefined"?AbortController:function(){return{abort:function(){}}},Rn=fetch,Un=Headers;In.adapters={},In.preferredAdapters=[],In.prefix="_pouch_";var zn=new u.EventEmitter;Wn(In),In.adapter=function(e,t,n){t.valid()&&(In.adapters[e]=t,n&&In.preferredAdapters.push(e))},In.plugin=function(e){if(typeof e=="function")e(In);else{if(typeof e!="object"||Object.keys(e).length===0)throw new Error('Invalid plugin: got "'+e+'", expected an object or a function');Object.keys(e).forEach(function(t){In.prototype[t]=e[t]})}return this.__defaults&&(In.__defaults=X({},this.__defaults)),In},In.defaults=function(e){function t(e,n){if(!(this instanceof t))return new t(e,n);n=n||{},e&&typeof e=="object"&&(n=e,e=n.name,delete n.name),n=X({},t.__defaults,n),In.call(this,e,n)}return a(t,In),t.preferredAdapters=In.preferredAdapters.slice(),Object.keys(In).forEach(function(e){e in t||(t[e]=In[e])}),t.__defaults=X({},this.__defaults,e),t},In.fetch=function(e,t){return Rn(e,t)};var Xn="7.0.0",Kn=["$or","$nor","$not"],ur=-324,ar=3,fr="",Br={$elemMatch:function(e,t,n,r){return Array.isArray(r)?r.length===0?!1:typeof r[0]=="object"?r.some(function(e){return Tr(e,t,Object.keys(t))}):r.some(function(r){return Nr(t,e,n,r)}):!1},$allMatch:function(e,t,n,r){return Array.isArray(r)?r.length===0?!1:typeof r[0]=="object"?r.every(function(e){return Tr(e,t,Object.keys(t))}):r.every(function(r){return Nr(t,e,n,r)}):!1},$eq:function(e,t,n,r){return Ar(r)&&lr(r,t)===0},$gte:function(e,t,n,r){return Ar(r)&&lr(r,t)>=0},$gt:function(e,t,n,r){return Ar(r)&&lr(r,t)>0},$lte:function(e,t,n,r){return Ar(r)&&lr(r,t)<=0},$lt:function(e,t,n,r){return Ar(r)&&lr(r,t)<0},$exists:function(e,t,n,r){return t?Ar(r):!Ar(r)},$mod:function(e,t,n,r){return Lr(r)&&Or(r,t)},$ne:function(e,t,n,r){return t.every(function(e){return lr(r,e)!==0})},$in:function(e,t,n,r){return Lr(r)&&Mr(r,t)},$nin:function(e,t,n,r){return Lr(r)&&!Mr(r,t)},$size:function(e,t,n,r){return Lr(r)&&Dr(r,t)},$all:function(e,t,n,r){return Array.isArray(r)&&_r(r,t)},$regex:function(e,t,n,r){return Lr(r)&&Pr(r,t)},$type:function(e,t,n,r){return Hr(r,t)}};In.plugin(Wr),In.version=Xn;var Vr=Xr(["_id","_rev","_attachments","_deleted","_revisions","_revs_info","_conflicts","_deleted_conflicts","_local_seq","_rev_tree","_replication_id","_replication_state","_replication_state_time","_replication_state_reason","_replication_stats","_removed"]),$r=Xr(["_attachments","_replication_id","_replication_state","_replication_state_time","_replication_state_reason","_replication_stats"]),si=5,oi="document-store",ui="by-sequence",ai="attach-store",fi="attach-seq-store",li="meta-store",ci="local-store",hi="detect-blob-support",Ti=new I,Di=!1,Pi=[],Ii=new A,qi,Ri=new A;Ui.valid=function(){try{return typeof indexedDB!="undefined"&&typeof IDBKeyRange!="undefined"}catch(e){return!1}};var Vi=25,$i=50,Ji=5e3,Ki=1e4,Qi={};os.valid=function(){return!0},a(as,Error),a(fs,Error),a(ls,Error);var bs=q.bind(null,"log"),ws=Array.isArray,Es=JSON.parse;xs.prototype.add=function(e){return this.promise=this.promise.catch(function(){}).then(function(){return e()}),this.promise},xs.prototype.finish=function(){return this.promise};var ks={},Ls=new xs,As=50,Ps={_sum:function(e,t){return ys(t)},_count:function(e,t){return t.length},_stats:function(e,t){function n(e){var t=0;for(var n=0,r=e.length;n<r;n++){var i=e[n];t+=i*i}return t}return{sum:ys(t),min:Math.min.apply(null,t),max:Math.max.apply(null,t),count:t.length,sumsqr:n(t)}}},Is="mrviews",qs=Ds(Is,Bs,js,Fs),zs={query:Rs,viewCleanup:Us},Qs=1,Gs="pouchdb",Ys=5,Zs=0;to.prototype.writeCheckpoint=function(e,t){var n=this;return this.updateTarget(e,t).then(function(){return n.updateSource(e,t)})},to.prototype.updateTarget=function(e,t){return this.opts.writeTargetCheckpoint?eo(this.target,this.id,e,t,this.returnValue):Promise.resolve(!0)},to.prototype.updateSource=function(e,t){if(this.opts.writeSourceCheckpoint){var n=this;return eo(this.src,this.id,e,t,this.returnValue).catch(function(e){if(oo(e))return n.opts.writeSourceCheckpoint=!1,!0;throw e})}return Promise.resolve(!0)};var no={"undefined":function(e,t){return lr(e.last_seq,t.last_seq)===0?t.last_seq:0},1:function(e,t){return ro(t,e).last_seq}};to.prototype.getCheckpoint=function(){var e=this;return e.opts&&e.opts.writeSourceCheckpoint&&!e.opts.writeTargetCheckpoint?e.src.get(e.id).then(function(e){return e.last_seq||Zs}).catch(function(e){if(e.status!==404)throw e;return Zs}):e.target.get(e.id).then(function(t){return e.opts&&e.opts.writeTargetCheckpoint&&!e.opts.writeSourceCheckpoint?t.last_seq||Zs:e.src.get(e.id).then(function(e){if(t.version!==e.version)return Zs;var n;return t.version?n=t.version.toString():n="undefined",n in no?no[n](t,e):Zs},function(n){if(n.status===404&&t.last_seq)return e.src.put({_id:e.id,last_seq:Zs}).then(function(){return Zs},function(n){return oo(n)?(e.opts.writeSourceCheckpoint=!1,t.last_seq):Zs});throw n})}).catch(function(e){if(e.status!==404)throw e;return Zs})};var uo=0;a(ho,u.EventEmitter),ho.prototype.cancel=function(){this.cancelled=!0,this.state="cancelled",this.emit("cancel")},ho.prototype.ready=function(e,t){function r(){n.cancel()}function i(){e.removeListener("destroyed",r),t.removeListener("destroyed",r)}var n=this;if(n._readyCalled)return;n._readyCalled=!0,e.once("destroyed",r),t.once("destroyed",r),n.once("complete",i)},a(go,u.EventEmitter),go.prototype.cancel=function(){this.canceled||(this.canceled=!0,this.push.cancel(),this.pull.cancel())},In.plugin(Wi).plugin(us).plugin(zs).plugin(yo),t.exports=In}).call(this)}).call(this,e("_process"),typeof global!="undefined"?global:typeof self!="undefined"?self:typeof window!="undefined"?window:{})},{_process:6,argsarray:1,events:2,immediate:3,inherits:4,"spark-md5":7,uuid:8,vuvuzela:13}],6:[function(e,t,n){function o(){throw new Error("setTimeout has not been defined")}function u(){throw new Error("clearTimeout has not been defined")}function a(e){if(i===setTimeout)return setTimeout(e,0);if((i===o||!i)&&setTimeout)return i=setTimeout,setTimeout(e,0);try{return i(e,0)}catch(t){try{return i.call(null,e,0)}catch(t){return i.call(this,e,0)}}}function f(e){if(s===clearTimeout)return clearTimeout(e);if((s===u||!s)&&clearTimeout)return s=clearTimeout,clearTimeout(e);try{return s(e)}catch(t){try{return s.call(null,e)}catch(t){return s.call(this,e)}}}function d(){if(!c||!h)return;c=!1,h.length?l=h.concat(l):p=-1,l.length&&v()}function v(){if(c)return;var e=a(d);c=!0;var t=l.length;while(t){h=l,l=[];while(++p<t)h&&h[p].run();p=-1,t=l.length}h=null,c=!1,f(e)}function m(e,t){this.fun=e,this.array=t}function g(){}var r=t.exports={},i,s;(function(){try{typeof setTimeout=="function"?i=setTimeout:i=o}catch(e){i=o}try{typeof clearTimeout=="function"?s=clearTimeout:s=u}catch(e){s=u}})();var l=[],c=!1,h,p=-1;r.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];l.push(new m(e,t)),l.length===1&&!c&&a(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=g,r.addListener=g,r.once=g,r.off=g,r.removeListener=g,r.removeAllListeners=g,r.emit=g,r.prependListener=g,r.prependOnceListener=g,r.listeners=function(e){return[]},r.binding=function(e){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(e){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}},{}],7:[function(t,n,r){(function(t){if(typeof r=="object")n.exports=t();else if(typeof e=="function"&&e.amd)e(t);else{var i;try{i=window}catch(s){i=self}i.SparkMD5=t()}})(function(e){"use strict";function r(e,n,r,i,s,o){return n=t(t(n,e),t(i,o)),t(n<<s|n>>>32-s,r)}function i(e,t){var n=e[0],r=e[1],i=e[2],s=e[3];n+=(r&i|~r&s)+t[0]-680876936|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[1]-389564586|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[2]+606105819|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[3]-1044525330|0,r=(r<<22|r>>>10)+i|0,n+=(r&i|~r&s)+t[4]-176418897|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[5]+1200080426|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[6]-1473231341|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[7]-45705983|0,r=(r<<22|r>>>10)+i|0,n+=(r&i|~r&s)+t[8]+1770035416|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[9]-1958414417|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[10]-42063|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[11]-1990404162|0,r=(r<<22|r>>>10)+i|0,n+=(r&i|~r&s)+t[12]+1804603682|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[13]-40341101|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[14]-1502002290|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[15]+1236535329|0,r=(r<<22|r>>>10)+i|0,n+=(r&s|i&~s)+t[1]-165796510|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[6]-1069501632|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[11]+643717713|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[0]-373897302|0,r=(r<<20|r>>>12)+i|0,n+=(r&s|i&~s)+t[5]-701558691|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[10]+38016083|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[15]-660478335|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[4]-405537848|0,r=(r<<20|r>>>12)+i|0,n+=(r&s|i&~s)+t[9]+568446438|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[14]-1019803690|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[3]-187363961|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[8]+1163531501|0,r=(r<<20|r>>>12)+i|0,n+=(r&s|i&~s)+t[13]-1444681467|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[2]-51403784|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[7]+1735328473|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[12]-1926607734|0,r=(r<<20|r>>>12)+i|0,n+=(r^i^s)+t[5]-378558|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[8]-2022574463|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[11]+1839030562|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[14]-35309556|0,r=(r<<23|r>>>9)+i|0,n+=(r^i^s)+t[1]-1530992060|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[4]+1272893353|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[7]-155497632|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[10]-1094730640|0,r=(r<<23|r>>>9)+i|0,n+=(r^i^s)+t[13]+681279174|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[0]-358537222|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[3]-722521979|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[6]+76029189|0,r=(r<<23|r>>>9)+i|0,n+=(r^i^s)+t[9]-640364487|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[12]-421815835|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[15]+530742520|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[2]-995338651|0,r=(r<<23|r>>>9)+i|0,n+=(i^(r|~s))+t[0]-198630844|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[7]+1126891415|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[14]-1416354905|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[5]-57434055|0,r=(r<<21|r>>>11)+i|0,n+=(i^(r|~s))+t[12]+1700485571|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[3]-1894986606|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[10]-1051523|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[1]-2054922799|0,r=(r<<21|r>>>11)+i|0,n+=(i^(r|~s))+t[8]+1873313359|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[15]-30611744|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[6]-1560198380|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[13]+1309151649|0,r=(r<<21|r>>>11)+i|0,n+=(i^(r|~s))+t[4]-145523070|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[11]-1120210379|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[2]+718787259|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[9]-343485551|0,r=(r<<21|r>>>11)+i|0,e[0]=n+e[0]|0,e[1]=r+e[1]|0,e[2]=i+e[2]|0,e[3]=s+e[3]|0}function s(e){var t=[],n;for(n=0;n<64;n+=4)t[n>>2]=e.charCodeAt(n)+(e.charCodeAt(n+1)<<8)+(e.charCodeAt(n+2)<<16)+(e.charCodeAt(n+3)<<24);return t}function o(e){var t=[],n;for(n=0;n<64;n+=4)t[n>>2]=e[n]+(e[n+1]<<8)+(e[n+2]<<16)+(e[n+3]<<24);return t}function u(e){var t=e.length,n=[1732584193,-271733879,-1732584194,271733878],r,o,u,a,f,l;for(r=64;r<=t;r+=64)i(n,s(e.substring(r-64,r)));e=e.substring(r-64),o=e.length,u=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];for(r=0;r<o;r+=1)u[r>>2]|=e.charCodeAt(r)<<(r%4<<3);u[r>>2]|=128<<(r%4<<3);if(r>55){i(n,u);for(r=0;r<16;r+=1)u[r]=0}return a=t*8,a=a.toString(16).match(/(.*?)(.{0,8})$/),f=parseInt(a[2],16),l=parseInt(a[1],16)||0,u[14]=f,u[15]=l,i(n,u),n}function a(e){var t=e.length,n=[1732584193,-271733879,-1732584194,271733878],r,s,u,a,f,l;for(r=64;r<=t;r+=64)i(n,o(e.subarray(r-64,r)));e=r-64<t?e.subarray(r-64):new Uint8Array(0),s=e.length,u=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];for(r=0;r<s;r+=1)u[r>>2]|=e[r]<<(r%4<<3);u[r>>2]|=128<<(r%4<<3);if(r>55){i(n,u);for(r=0;r<16;r+=1)u[r]=0}return a=t*8,a=a.toString(16).match(/(.*?)(.{0,8})$/),f=parseInt(a[2],16),l=parseInt(a[1],16)||0,u[14]=f,u[15]=l,i(n,u),n}function f(e){var t="",r;for(r=0;r<4;r+=1)t+=n[e>>r*8+4&15]+n[e>>r*8&15];return t}function l(e){var t;for(t=0;t<e.length;t+=1)e[t]=f(e[t]);return e.join("")}function c(e){return/[\u0080-\uFFFF]/.test(e)&&(e=unescape(encodeURIComponent(e))),e}function h(e,t){var n=e.length,r=new ArrayBuffer(n),i=new Uint8Array(r),s;for(s=0;s<n;s+=1)i[s]=e.charCodeAt(s);return t?i:r}function p(e){return String.fromCharCode.apply(null,new Uint8Array(e))}function d(e,t,n){var r=new Uint8Array(e.byteLength+t.byteLength);return r.set(new Uint8Array(e)),r.set(new Uint8Array(t),e.byteLength),n?r:r.buffer}function v(e){var t=[],n=e.length,r;for(r=0;r<n-1;r+=2)t.push(parseInt(e.substr(r,2),16));return String.fromCharCode.apply(String,t)}function m(){this.reset()}var t=function(e,t){return e+t&4294967295},n=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return l(u("hello"))!=="5d41402abc4b2a76b9719d911017c592"&&(t=function(e,t){var n=(e&65535)+(t&65535),r=(e>>16)+(t>>16)+(n>>16);return r<<16|n&65535}),typeof ArrayBuffer!="undefined"&&!ArrayBuffer.prototype.slice&&function(){function t(e,t){return e=e|0||0,e<0?Math.max(e+t,0):Math.min(e,t)}ArrayBuffer.prototype.slice=function(n,r){var i=this.byteLength,s=t(n,i),o=i,u,a,f,l;return r!==e&&(o=t(r,i)),s>o?new ArrayBuffer(0):(u=o-s,a=new ArrayBuffer(u),f=new Uint8Array(a),l=new Uint8Array(this,s,u),f.set(l),a)}}(),m.prototype.append=function(e){return this.appendBinary(c(e)),this},m.prototype.appendBinary=function(e){this._buff+=e,this._length+=e.length;var t=this._buff.length,n;for(n=64;n<=t;n+=64)i(this._hash,s(this._buff.substring(n-64,n)));return this._buff=this._buff.substring(n-64),this},m.prototype.end=function(e){var t=this._buff,n=t.length,r,i=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],s;for(r=0;r<n;r+=1)i[r>>2]|=t.charCodeAt(r)<<(r%4<<3);return this._finish(i,n),s=l(this._hash),e&&(s=v(s)),this.reset(),s},m.prototype.reset=function(){return this._buff="",this._length=0,this._hash=[1732584193,-271733879,-1732584194,271733878],this},m.prototype.getState=function(){return{buff:this._buff,length:this._length,hash:this._hash}},m.prototype.setState=function(e){return this._buff=e.buff,this._length=e.length,this._hash=e.hash,this},m.prototype.destroy=function(){delete this._hash,delete this._buff,delete this._length},m.prototype._finish=function(e,t){var n=t,r,s,o;e[n>>2]|=128<<(n%4<<3);if(n>55){i(this._hash,e);for(n=0;n<16;n+=1)e[n]=0}r=this._length*8,r=r.toString(16).match(/(.*?)(.{0,8})$/),s=parseInt(r[2],16),o=parseInt(r[1],16)||0,e[14]=s,e[15]=o,i(this._hash,e)},m.hash=function(e,t){return m.hashBinary(c(e),t)},m.hashBinary=function(e,t){var n=u(e),r=l(n);return t?v(r):r},m.ArrayBuffer=function(){this.reset()},m.ArrayBuffer.prototype.append=function(e){var t=d(this._buff.buffer,e,!0),n=t.length,r;this._length+=e.byteLength;for(r=64;r<=n;r+=64)i(this._hash,o(t.subarray(r-64,r)));return this._buff=r-64<n?new Uint8Array(t.buffer.slice(r-64)):new Uint8Array(0),this},m.ArrayBuffer.prototype.end=function(e){var t=this._buff,n=t.length,r=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],i,s;for(i=0;i<n;i+=1)r[i>>2]|=t[i]<<(i%4<<3);return this._finish(r,n),s=l(this._hash),e&&(s=v(s)),this.reset(),s},m.ArrayBuffer.prototype.reset=function(){return this._buff=new Uint8Array(0),this._length=0,this._hash=[1732584193,-271733879,-1732584194,271733878],this},m.ArrayBuffer.prototype.getState=function(){var e=m.prototype.getState.call(this);return e.buff=p(e.buff),e},m.ArrayBuffer.prototype.setState=function(e){return e.buff=h(e.buff,!0),m.prototype.setState.call(this,e)},m.ArrayBuffer.prototype.destroy=m.prototype.destroy,m.ArrayBuffer.prototype._finish=m.prototype._finish,m.ArrayBuffer.hash=function(e,t){var n=a(new Uint8Array(e)),r=l(n);return t?v(r):r},m})},{}],8:[function(e,t,n){var r=e("./v1"),i=e("./v4"),s=i;s.v1=r,s.v4=i,t.exports=s},{"./v1":11,"./v4":12}],9:[function(e,t,n){function s(e,t){var n=t||0,i=r;return i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]}var r=[];for(var i=0;i<256;++i)r[i]=(i+256).toString(16).substr(1);t.exports=s},{}],10:[function(e,t,n){var r=typeof crypto!="undefined"&&crypto.getRandomValues.bind(crypto)||typeof msCrypto!="undefined"&&msCrypto.getRandomValues.bind(msCrypto);if(r){var i=new Uint8Array(16);t.exports=function(){return r(i),i}}else{var s=new Array(16);t.exports=function(){for(var t=0,n;t<16;t++)(t&3)===0&&(n=Math.random()*4294967296),s[t]=n>>>((t&3)<<3)&255;return s}}},{}],11:[function(e,t,n){function f(e,t,n){var f=t&&n||0,l=t||[];e=e||{};var c=e.node||s,h=e.clockseq!==undefined?e.clockseq:o;if(c==null||h==null){var p=r();c==null&&(c=s=[p[0]|1,p[1],p[2],p[3],p[4],p[5]]),h==null&&(h=o=(p[6]<<8|p[7])&16383)}var d=e.msecs!==undefined?e.msecs:(new Date).getTime(),v=e.nsecs!==undefined?e.nsecs:a+1,m=d-u+(v-a)/1e4;m<0&&e.clockseq===undefined&&(h=h+1&16383),(m<0||d>u)&&e.nsecs===undefined&&(v=0);if(v>=1e4)throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");u=d,a=v,o=h,d+=122192928e5;var g=((d&268435455)*1e4+v)%4294967296;l[f++]=g>>>24&255,l[f++]=g>>>16&255,l[f++]=g>>>8&255,l[f++]=g&255;var y=d/4294967296*1e4&268435455;l[f++]=y>>>8&255,l[f++]=y&255,l[f++]=y>>>24&15|16,l[f++]=y>>>16&255,l[f++]=h>>>8|128,l[f++]=h&255;for(var b=0;b<6;++b)l[f+b]=c[b];return t?t:i(l)}var r=e("./lib/rng"),i=e("./lib/bytesToUuid"),s,o,u=0,a=0;t.exports=f},{"./lib/bytesToUuid":9,"./lib/rng":10}],12:[function(e,t,n){function s(e,t,n){var s=t&&n||0;typeof e=="string"&&(t=e==="binary"?new Array(16):null,e=null),e=e||{};var o=e.random||(e.rng||r)();o[6]=o[6]&15|64,o[8]=o[8]&63|128;if(t)for(var u=0;u<16;++u)t[s+u]=o[u];return t||i(o)}var r=e("./lib/rng"),i=e("./lib/bytesToUuid");t.exports=s},{"./lib/bytesToUuid":9,"./lib/rng":10}],13:[function(e,t,n){"use strict";function r(e,t,n){var r=n[n.length-1];e===r.element&&(n.pop(),r=n[n.length-1]);var i=r.element,s=r.index;if(Array.isArray(i))i.push(e);else if(s===t.length-2){var o=t.pop();i[o]=e}else t.push(e)}n.stringify=function(t){var n=[];n.push({obj:t});var r="",i,s,o,u,a,f,l,c,h,p,d;while(i=n.pop()){s=i.obj,o=i.prefix||"",u=i.val||"",r+=o;if(u)r+=u;else if(typeof s!="object")r+=typeof s=="undefined"?null:JSON.stringify(s);else if(s===null)r+="null";else if(Array.isArray(s)){n.push({val:"]"});for(a=s.length-1;a>=0;a--)f=a===0?"":",",n.push({obj:s[a],prefix:f});n.push({val:"["})}else{l=[];for(c in s)s.hasOwnProperty(c)&&l.push(c);n.push({val:"}"});for(a=l.length-1;a>=0;a--)h=l[a],p=s[h],d=a>0?",":"",d+=JSON.stringify(h)+":",n.push({obj:p,prefix:d});n.push({val:"{"})}}return r},n.parse=function(e){var t=[],n=[],i=0,s,o,u,a,f,l,c,h,p;for(;;){s=e[i++];if(s==="}"||s==="]"||typeof s=="undefined"){if(t.length===1)return t.pop();r(t.pop(),t,n);continue}switch(s){case" ":case"	":case"\n":case":":case",":break;case"n":i+=3,r(null,t,n);break;case"t":i+=3,r(!0,t,n);break;case"f":i+=4,r(!1,t,n);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":case"-":o="",i--;for(;;){u=e[i++];if(!/[\d\.\-e\+]/.test(u)){i--;break}o+=u}r(parseFloat(o),t,n);break;case'"':a="",f=void 0,l=0;for(;;){c=e[i++];if(c==='"'&&(f!=="\\"||l%2!==1))break;a+=c,f=c,f==="\\"?l++:l=0}r(JSON.parse('"'+a+'"'),t,n);break;case"[":h={element:[],index:t.length},t.push(h.element),n.push(h);break;case"{":p={element:{},index:t.length},t.push(p.element),n.push(p);break;default:throw new Error("unexpectedly reached end of input: "+s)}}}},{}]},{},[5])(5)}),define("persist/impl/pouchDBPersistenceStore",["../PersistenceStore","../impl/storageUtils","pouchdb","./logger"],function(e,t,n,r){"use strict";var i=function(t){e.call(this,t)};i.prototype=new e,i.prototype.Init=function(e){this._version=e&&e.version||"0";var t=this._name+this._version,i=e?e.adapter:null,s=this._extractDBOptions(e);if(i)try{i.plugin&&n.plugin(i.plugin),s=s?s:{},s.adapter=i.name,this._dbOptions=s,this._db=new n(t,s)}catch(o){return r.log("Error creating PouchDB instance with adapter "+i+": ",o.message),r.log("Please make sure the needed plugin and adapter are installed."),Promise.reject(o)}else s?(this._dbOptions=s,this._db=new n(t,s)):(this._dbOptions=null,this._db=new n(t));return e&&e.index&&(Array.isArray(e.index)?(this._index=e.index.filter(function(e){return e!=="key"}),this._index.length===0&&(this._index=null)):r.log("index must be an array")),this._createIndex()},i.prototype._extractDBOptions=function(e){var t=null;if(e){var n=this;Object.keys(e).forEach(function(r){n._isPersistenceStoreKey(r)||(t||(t={}),t[r]=e[r])})}return t},i.prototype._isPersistenceStoreKey=function(e){return e==="version"||e==="adapter"||e==="index"||e==="skipMetadata"},i.prototype._createIndex=function(){if(!this._index||!this._db.createIndex)return Promise.resolve();var e=this,t=e._name+e._index.toString().replace(",","").replace(".",""),n={index:{fields:e._index,name:t}};return e._db.createIndex(n).catch(function(t){r.error("creating index on "+e._index.toString()+" failed with error "+t)})},i.prototype.upsert=function(e,t,n,i){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: upsert() for key: "+e);var o=this,u=e.toString();return o._db.get(u).then(function(e){return s(i,e)?e:Promise.reject({status:409})}).catch(function(e){if(e.status===404&&e.message==="missing")return;return Promise.reject(e)}).then(function(e){return o._put(u,t,n,i,e)})},i.prototype._put=function(e,t,n,r,i){var s=[],o=this._prepareUpsert(n,s),u={_id:e,key:e,metadata:t,value:o?null:n};i&&(u._rev=i._rev);var a=this;return a._db.put(u).then(function(t){return a._addAttachments(e,t.rev,s)}).catch(function(e){if(e.status!==409)throw e})};var s=function(e,t){if(!e)return!0;var n=t.metadata.versionIdentifier;return n===e};i.prototype._addAttachments=function(e,t,n){if(!n||!n.length)return Promise.resolve();var i=this,s=n.map(function(n){var r;return n.value instanceof Blob?r=n.value:r=new Blob([n.value]),i._db.putAttachment(e,n.path,t,r,"binary")},this);return Promise.all(s).catch(function(t){r.error("store: "+i._name+" failed add attachment for doc "+e)})},i.prototype.upsertAll=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: upsertAll()");if(!e||!e.length)return Promise.resolve();var t=this,n={},i=e.map(function(e){var r=e.key.toString(),i=e.value,s=[],o=t._prepareUpsert(i,s);s.length>0&&(n[r]=s);var u={_id:r,key:e.key,metadata:e.metadata,value:o?null:i};return t._db.get(r).then(function(e){return u._rev=e._rev,u}).catch(function(e){if(e.status===404&&e.message==="missing")return u;throw e})});return Promise.all(i).then(function(e){return t._db.bulkDocs(e)}).then(function(e){var i=[];e.forEach(function(e,s){if(e.ok){var o=n[e.id];o&&i.push(t._addAttachments(e.id,e.rev,o))}else e.status===409&&r.log("conflict error")});if(i.length>0)return Promise.all(i)}).catch(function(e){r.log("error in upsertAll")})},i.prototype.find=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: find() for expression: "+JSON.stringify(e));var n=this;e=e||{};if(n._db.find){var i=n._prepareFind(e);return n._db.find(i).then(function(e){if(e&&e.docs&&e.docs.length){var t=e.docs.map(n._findResultCallback(i.fields),n);return Promise.all(t)}return[]}).catch(function(e){if(e.status===404&&e.message==="missing")return[];throw e})}return n._db.allDocs({include_docs:!0}).then(function(r){if(r&&r.rows&&r.rows.length){var i=r.rows.filter(function(n){var r=n.doc;return!o(n)&&t.satisfy(e.selector,r)?!0:!1});if(i.length){var s=i.map(function(e){return n._fixKey(e.doc),e.doc}),u=t.sortRows(s,e.sort),a=u.map(function(r){return n._fixBinaryValue(r).then(function(n){return e.fields?t.assembleObject(n,e.fields):n.value})});return Promise.all(a)}return[]}return[]}).catch(function(e){return r.log("error retrieving all documents from pouch db, returns empty list as find operation.",e),[]})},i.prototype._findResultCallback=function(e){return function(t){var n=this;return n._fixValue(t).then(function(t){return e?t:t.value})}},i.prototype._fixValue=function(e){return this._fixKey(e),this._fixBinaryValue(e)},i.prototype._fixBinaryValue=function(e){var t=e._id||e.id||e.key,n=e._attachments;if(!n)return Promise.resolve(e);var i=this,s=Object.keys(n)[0];return i._db.getAttachment(t,s).then(function(t){if(s==="rootpath")e.value=t;else{var n=s.split("."),r=e.value;for(var i=0;i<n.length-1;i++)r=r[n[i]];r[n[n.length-1]]=t}return e}).catch(function(e){r.error("store: "+i._name+" error getting attachment. ")})},i.prototype.findByKey=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: findByKey() for key: "+e);var t=this,n=e.toString();return t._db.get(n,{attachments:!0}).then(function(e){return t._fixBinaryValue(e)}).then(function(e){return e.value}).catch(function(e){if(e.status===404&&e.message==="missing")return;return Promise.reject(e)})},i.prototype.removeByKey=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: removeByKey() for key: "+e);var t=this;if(!e)return Promise.resolve(!1);var n=e.toString();return t._db.get(n).then(function(e){return t._db.remove(e)}).then(function(){return!0}).catch(function(e){return e.status===404&&e.message==="missing"?!1:Promise.reject(e)})},i.prototype.delete=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: delete() for expression: "+JSON.stringify(e));var t=this;if(e){var i=e;return i.fields=["_id","_rev"],t.find(i).then(function(e){if(e&&e.length){var n=e.map(function(e){return{_id:e._id,_rev:e._rev,_deleted:!0}});return t._db.bulkDocs(n)}return}).catch(function(e){r.error("store: "+t._name+" error deleting....")})}return t._db.destroy().then(function(){var e=t._name+t._version;return t._dbOptions?t._db=new n(e,t._dbOptions):t._db=new n(e),t._createIndex()}).catch(function(e){r.error("store: "+t._name+" error deleting....")})},i.prototype.keys=function(){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: keys()");var e=this;return e._db.allDocs().then(function(e){var t=e.rows,n=[];if(t&&t.length)for(var r=0;r<t.length;r++)o(t[r])||n.push(t[r].id);return n}).catch(function(t){r.error("store: "+e._name+" error getting all the docs for keys ")})},i.prototype._prepareFind=function(e){var t={},n=e.selector;n?n&&(t.selector=n):t.selector={_id:{$gt:null}};var r=e.fields;return r&&r.length&&(t.fields=r,r.indexOf("key")!==-1&&r.indexOf("_id")===-1&&t.fields.push("_id")),t},i.prototype._prepareUpsert=function(e,t){if(!e)return!1;if(e instanceof Blob||e instanceof ArrayBuffer)return t.push({path:"rootpath",value:e}),!0;var n="";return this._inspectValue(n,e,t),!1},i.prototype._inspectValue=function(e,t,n){for(var r in t)if(t.hasOwnProperty(r)){var i=t[r];if(i&&typeof i=="object")if(i instanceof Blob||i instanceof ArrayBuffer){var s=e;s.length>0&&(s+=".");var o={path:s+r,value:i};n.push(o),t.key=null}else if(i.length===undefined){var u=e;e.length>0&&(e+="."),e+=r,this._inspectValue(e,i,n),e=u}}},i.prototype.updateKey=function(e,t){r.log("Offline Persistence Toolkit PouchDBPersistenceStore: updateKey() with currentKey: "+e+" and new key: "+t);var n=this;return n._db.get(e).then(function(e){return e?n.upsert(t,e.metadata,e.value):Promise.reject("No existing key found to update")}).then(function(){return n.removeByKey(e)}).catch(function(){r.error("store: "+n._name+" error updating key")})};var o=function(e){var t=e.id;return t.startsWith("_design/")};return i.prototype._fixKey=function(e){var t=e._id||e.id||e.key;t&&(e.key=t)},i}),define("persist/pouchDBPersistenceStoreFactory",["./impl/pouchDBPersistenceStore"],function(e){"use strict";var t=function(){function t(t,n){var r=new e(t);return r.Init(n).then(function(){return r})}return{createPersistenceStore:function(e,n){return t(e,n)}}}();return t}),define("persist/impl/fileSystemPersistenceStore",["./keyValuePersistenceStore","../persistenceStoreManager","./logger"],function(e,t,n){"use strict";function i(e,t,n,r,i){return new Promise(function(o,u){e._directory.getFile(t,{create:!0,exclusive:!1},function(e){e.createWriter(function(e){e.onwriteend=function(){s(n,t,r).then(function(){o()})},e.onerror=function(e){u(e)},r.data_type=="JSON"&&(i=JSON.stringify(i)),e.write(i)})})})}function s(e,t,n){return o().then(function(r){return r.upsert(e,n,{filename:t,metadata:n})})}function o(){var e={index:["key"],skipMetadata:!0};return t.openStore("fileIndex",e)}function u(e,t){return new Promise(function(n,r){e._directory.getFile(t,{create:!1,exclusive:!1},function(e){n(e)},function(e){e.code===FileError.NOT_FOUND_ERR||e.code===FileError.SYNTAX_ERR?n(null):r(e)})})}function a(e,t){var n=new DataView(e.slice(t));return new Blob([n])}function f(e){return o().then(function(t){return t.findByKey(e)})}function l(e){return o().then(function(t){return t.removeByKey(e)})}function c(e,t){return u(e,t).then(function(e){return e?new Promise(function(t,n){e.remove(function(){t(!0)},function(e){t(!1)})}):!1})}function h(){return o().then(function(e){return e.keys()})}function p(){return o().then(function(e){return e.delete()})}function d(e){var t=/[<>\:"\/\\\|\?\*\~]/g,n=/^\.+$/,r=/^(con|prn|aux|nul|com[0-9]|lpt[0-9])(\..*)?$/i,i=/[\x00-\x1f\x80-\x9f]/g,s="",o=255,u=e.replace(t,s),a=u.replace(n,s),f=a.replace(r,s),l=f.replace(i,s);return l.length>o?l.slice(0,o):l}var r=function(t){e.call(this,t),this._directoryName=d(t),this._directory=null};return r.prototype=new e,r.prototype.Init=function(t){var n=this;return e.prototype.Init.call(n,t).then(function(){return n._directoryName=d(n._name+n._version),new Promise(function(e,t){window.requestFileSystem(LocalFileSystem.PERSISTENT,0,function(t){t.root.getDirectory(n._directoryName,{create:!0},function(t){n._directory=t,e()})},function(e){t(e)})})})},r.prototype._insert=function(e,t,n){var r=this;return this.removeByKey(e).then(function(){n instanceof Blob?t.data_type="Blob":t.data_type="JSON";var s=r._directory.createReader();return new Promise(function(o,u){s.readEntries(function(s){var u=function(e){var t=s.filter(function(t){return t.name==e?!0:!1});return t.length>0},a=Math.floor(Math.random()*1e8)+".pds";while(u(a))a=Math.floor(Math.random()*1e8)+".pds";i(r,a,e,t,n).then(function(){o()})})})})},r.prototype.getItem=function(e){n.log("Offline Persistence Toolkit fileSystemPersistenceStore: getItem() with key: "+e);var t=this;return f(e).then(function(e){if(e){var n=e.filename,r=e.metadata;return u(t,n).then(function(e){if(e)return new Promise(function(t,n){e.file(function(e){var n=new FileReader;n.onloadend=function(e){var n=a(this.result,0);if(r.data_type=="JSON"){var i=new FileReader;i.onloadend=function(){t({metadata:r,value:JSON.parse(this.result)})},i.readAsText(n)}else t({metadata:r,value:n})},n.readAsArrayBuffer(e)},function(e){n(e)})})})}})},r.prototype.removeByKey=function(e){n.log("Offline Persistence Toolkit fileSystemPersistenceStore: removeByKey() with key: "+e);var t=this;return f(e).then(function(n){return n?l(e).then(function(){return c(t,n.filename)}):Promise.resolve(!1)})},r.prototype.keys=function(){return n.log("Offline Persistence Toolkit fileSystemPersistenceStore: keys()"),h()},r.prototype.deleteAll=function(){n.log("Offline Persistence Toolkit fileSystemPersistenceStore: deleteAll()");var e=this;return p().then(function(){var t=[],n=e._directory.createReader();return t.push(new Promise(function(r,i){n.readEntries(function(n){n.map(function(n){t.push(c(e,n.name))}),r()})})),Promise.all(t)})},r.prototype.updateKey=function(e,t){n.log("Offline Persistence Toolkit FileSystemPersistenceStore: updateKey() with currentKey: "+e+" and new key: "+t);var r=this;return f(e).then(function(e){if(e){var n=e.filename,r=e.metadata;return s(t,n,r)}return Promise.reject("No existing key found to update")}).then(function(){return l(e)})},r}),define("persist/fileSystemPersistenceStoreFactory",["./impl/fileSystemPersistenceStore"],function(e){"use strict";var t=function(){function t(t,n){var r=new e(t);return r.Init(n).then(function(){return r})}return{createPersistenceStore:function(e,n){return t(e,n)}}}();return t}),define("persist/persistenceStoreFactory",[],function(){"use strict";var e={createPersistenceStore:function(e,t){}};return e});